{ Analizzatore di espressioni aritmetiche contenenti i quattro
  operatori, numeri reali in notazione esponenziale, funzioni,
  variabili e costanti.

  Priorita' operatori:
  <,=,>
  +,-
  *,/


}

(* BUG: la posizione di un errore per le espressioni errate
        lunghe 255 caratteri e' errata *)
{$R+ only for debugging }

{ I programmi che utilizzano questa UNIT possono definire nuove
  funzioni usando la funzione <Register_function> (vedi..),
  nuove costanti usando <Register_constant> e nuove variabili
  usando <Register_Variable>.
  La funzione <analizza> fornisce uno strumento flessibile per
  l'analisi sintattica delle espressioni, riportando eventuali
  informazioni di errore in una struttura adeguata.
  Il codice di errore puo' essere convertito in una stringa mediante
  l'uso della funzione <error>

  la funzione <analizza2> estende <analizza> con la possibilita' di
  usare variabili locali all'espressione. Questa procedura trova
  il suo uso ottimale nella gestione delle funzioni di utente.
  In questo caso usa <_value2> al posto di <_value>!!!!
}

unit math;

{ Rev 0.61   1/1/1994     L.C. 1987 }

{ ATTN: se l'esponente di un numero e' troppo grande i risultati sono errati }
{       la struttura dati e' stata modificata rispetto la prima versione     }

interface
const zMaxVars=256;

type tindex=0..zMaxVars-1;
type tAReal=array[tindex]of ^real; (* usato per il passaggio delle variabili *)
     pAReal=^tAReal;
type preal=^real;
type punt=^nodo;
     nodo=record
            tipo:char{}; {'c','n','v','l','f','m','*','-','/','+','^','=','>','<'}
            num:real;
            address:byte{};
            sin,des:punt
	  end;
     error_info=record
                  pos,no:byte
                end;
     functiont=function(x:real):real;     { tipo di funzione utente }
     namet=string[8];                     { tipo di identificatore  }

const mathver='0.6';

procedure analizza(var p:punt;var expr:string;
                   var err:error_info);{ nuova procedura di analisi }
procedure visita(p:punt);
function error(errno:byte):string; { converte errno--> error string }
procedure clear(var p:punt);       { rilascia la memoria impegnata }
function _value(p:punt;var error:integer):real;


(* procedure da usare per espressione con argomenti *)
procedure visita2(p:punt;args:string);
function _value2(p:punt;var AReal(*:tAReal*);var error:integer):real;
procedure analizza2(var p:punt;args:string;var expr:string;
                   var err:error_info);

(* procedure per la registrazione di simboli GLOBALI *)
function Register_function(fname:namet;fun:functiont):integer;
function Register_Constant(cname:namet;value:real):integer;
function Register_Variable(vname:namet;p:preal):integer;


(* --- vecchie procedure --- da non usare --- *)
function fxy(p:punt;x,y:real):real;
function valore(p:punt):real; { NON USARE QUESTA FUNZIONE -> USARE _value }
procedure analisi(var p:punt;expr:string);           { vecchia procedura }


implementation


const MaxNumOfDigit=38;                  { Numero massimo di cifre }
      MaxNumOfEDigit=2;                  { Numero massimo di cifre per l'esponente }
const fsin=0;fcos=1;ftan=2;farctan=3;    { Indirizzi simbolici delle funzioni }
      fsqr=4;fsqrt=5;fln=6;fexp=7;
      fabs=8;
      MaxSizeOfList=16;                  { Dimensione della tavola degli identificatori }
      SizeOfDefault= 9;                  { Dimensione della tavola degli identificatori }
      FUserFunction=9; {>fabs}           { Indirizzo simbolico riservato alla prima funzione utente }
      MaxUserFunction=4;
      MaxConstant=4;
      MaxVariable=8;

type Item=record                         { Elemento della tavola degli identificatori }
            Name:namet;
            address:byte{};
            Ty:char{};
          end; { of Item }
     List=array[1..MaxSizeOfList]of Item;
     DefList=array[1..SizeOfDefault]of Item;
     UserFunctiont=array[1..MaxUserFunction]of functiont;

{ Tavola degli identificatori di default                }
{ Questa tavola contiene funzioni e costanti            }

const Default:DefList=((name:'sin';address:fsin;Ty:'f'),(name:'cos';address:fcos;Ty:'f'),(name:'tan';address:ftan;Ty:'f'),
                   (name:'arctan';address:farctan;Ty:'f'),(name:'sqr';address:fsqr;Ty:'f'),(name:'sqrt';address:fsqrt;Ty:'f'),
                   (name:'ln';address:fln;Ty:'f'),(name:'exp';address:fexp;Ty:'f'),(name:'abs';address:fabs;Ty:'f'));


var   Constant:array[0..MaxConstant-1]of real;
      Variables:array[0..MaxVariable-1]of preal;

var   OldHeapError:pointer;
      IdList:List;
      UserFunction:UserFunctiont;
      LastVariable,LastUserFunction,LastConstant,SizeOfList:integer;
      fault:integer;pLocal:pAReal;
      SaveSizeOfList:integer;

  procedure fetch_id(var id:namet;var str:string;var i:integer);
  begin
    id:='';
    while (i <= length(str))and(str[i] in['A'..'Z','a'..'z','0'..'9'])
    do begin
         id:=id+str[i];
         inc(i)
       end;
  end; { of fetch_id }

  procedure UnRegisterLocal;
(* This procedure unregisters local variables *)
  begin
     SizeOfList:=SaveSizeOfList;
  end;

  function RegisterLocal(var args:string):integer;
(* This function registers local variables *)
  var i,lindex,error:integer;
      vname:namet;
  { return code:  0 = Variable has been registered
                  1 = No room in IdList
                  2 = No room in Variable
                  3 = Error in name                  }

  begin
  SaveSizeOfList:=SizeOfList;
  lindex:=0;i:=1;error:=0;
  fetch_id(vname,args,i);inc(i);
  if vname <> 'real'
  then error:=3;
  while (i<=length(args))and(error=0)
  do begin
     fetch_id(vname,args,i);
     inc(i);
     if SizeOfList<MaxSizeOfList
     then if lindex < zMaxVars
          then begin
               if (length(vname)>0)
               then begin
                    inc(SizeOfList);
                    with IdList[SizeOfList]
                    do begin
                       Name:=vname; { strip_space }
                       Address:=lindex;
                       Ty:='l'; (* LOCAL VARIABLE *)
                       end;
                    inc(lindex);
                    end
               else error:=3
               end
          else error:=2
     else error:=1;
     end;
  RegisterLocal:=error;
  end; { of RegisterLocal }


procedure visita(p:punt);
begin
  visita2(p,'real x,y');
end;

procedure visita2(p:punt;args:string);

  procedure visit(p:punt);

     procedure write_id;
     var index:integer;
         found:boolean;
     begin
     index:=1;found:=false;
     while (not found)and(index<=SizeOfList)
     do with p^
        do if (IdList[index].address=address)and(IdList[index].Ty=tipo)
           then found:=true
           else inc(index);
     if found
     then write(IdList[index].name)
     else if p^.tipo='l'
          then write('local[',p^.address,']')
          else write('!!!!');
     end; { of write_id }

   begin
   if p<>nil
   then with p^
        do case tipo of
           '+','-','*','/','=','<','>':
                begin
                 write('(');
                 visit(sin);
                 write(tipo);
                 visit(des);
                 write(')')
                end;
           'm':begin
                 write('-');
                 visit(sin);
               end;
           'n':write(num:9);
           'f':begin
                 write_Id;
                 write('(');visit(sin);write(')')
               end;
           'l','v','c':write_Id;
           '^':begin
                 write('(');
                 visit(sin);
                 write(')^');
                 if num=trunc(num)
                 then write(trunc(num))
                 else write(num:9);
               end;
           else write('????');
           end; { of case }
   end; { of visit }
begin
     RegisterLocal(args);
     visit(p);
     UnRegisterLocal;
end; { of visita2 }


function _value2(p:punt;var AReal;var error:integer):real;
{ error code:   0 = correct expression
              100 = domain violation (e.g. ln(-1)) }
begin
fault:=0;
pLocal:=@AReal;
_value2:=valore(p);
error:=fault;
end;

function _value(p:punt;var error:integer):real;
{ error code:   0 = correct expression
              100 = domain violation (e.g. ln(-1)) }
begin
fault:=0;
pLocal:=nil;
_value:=valore(p);
error:=fault;
end;

function valore(p:punt):real;
(* questa funzione ha un effetto collaterale sulla
   variabile <fault> *)
  function Intpower(base:real;exp:integer):real;
  var ris:real;
  { Attenzione: exp>=0 }
  begin
  ris:=1;
  while exp<>0
  do begin
      ris:=ris*base;
      dec(exp);
     end;
  Intpower:=ris;
  end; { of Intpower }

  function power(base,num:real):real;
  begin
  if num<0
  then power:=1/power(base,-num)
  else if (base=1) or (num=0)
       then power:=1
       else if base=0      
            then power:=0
            else if num=trunc(num)
                 then power:=Intpower (base, trunc (num))
                 else power:=exp(num*ln(base));
  end; { of power }

var vs:real;
begin
  if fault = 0
  then
  with p^ do
        case tipo of
           'l':valore:=pLocal^[address]^;
           'v':valore:=variables[address]^;
           'c':valore:=constant[address];
           'm':valore:=-valore(sin);
           'n':valore:=num;
           'f':begin
               vs:=valore(sin);
               case address of
                fsin:valore:=system.sin(vs);
                fcos:valore:=cos(vs);
                ftan:valore:=system.sin(vs)/cos(vs);
                farctan:valore:=arctan(vs);
                fsqr:valore:=sqr(vs);
                fsqrt:if vs >= 0
                      then valore:=sqrt(vs)
                      else begin
                           valore:=0;
                           fault:=100;
                           end;
                fln:if vs > 0
                      then valore:=ln(vs)
                      else begin
                           valore:=0;
                           fault:=100;
                           end;
                fexp:valore:=exp(vs);
                fabs:valore:=abs(vs);
                else valore:=UserFunction[address-FUserFunction+1](vs);
               end {of case}
               end;
           '>':if valore(sin) > valore(des)
               then valore:=1
               else valore:=0;
           '<':if valore(sin) < valore(des)
               then valore:=1
               else valore:=0;
           '=':if valore(sin) = valore(des)
               then valore:=1
               else valore:=0;
           '+':valore:=valore(sin) + valore(des);
           '-':valore:=valore(sin) - valore(des);
           '*':valore:=valore(sin) * valore(des);
           '/':begin
                 vs:=valore(des);
                 if vs <> 0
                 then valore:=valore(sin)/vs
                 else begin
                           valore:=0;
                           fault:=100;
                      end;
               end;
           '^':valore:=power(valore(sin),num)
        end
end; { of valore }

function fxy(p:punt;x,y:real):real;
var pAA:pAReal;
begin
GetMem(pAA,2*sizeof(pointer));
pLocal:=pAA;
pAA^[0]:=@x;
pAA^[1]:=@y;
fault:=0;
fxy:=valore(p);
FreeMem(pAA,2*sizeof(pointer));
end; { of fxy }

function error(errno:byte):string;
begin
   case errno of
   1:error:=') expected';
   2:error:='( expected';
   3:error:='unknow identifier';
   4:error:='factor expected';
   5:error:='eoln expected';
   6:error:='too complex';
   7:error:='real out of range';
   8:error:='exponent out of range';
   9:error:='bad argument list';
   else error:='***';
   end; { of case }
end; { of error }

function NoMemory(size:word):integer;far;
begin
  NoMemory:=1;
end; { of NoMemory }

function Find_Id(name:namet):integer;
var i:word;found:boolean;
begin
    found:=false;i:=SizeOfList;
    repeat
      if name=IdList[i].name
      then found:=true
      else dec(i)
    until found or(i=0);
    if found
    then Find_Id:=i
    else Find_Id:=0
end; { of Find_Id }


procedure analisi(var p:punt;expr:string);
var err:error_info;
begin
analizza2(p,'real x,y',expr,err);
if err.no<>0
then begin
        writeln('Error ',error(err.no));
        writeln(expr);
        writeln('^':err.pos);
        writeln('program aborted in expr evaluation');
        halt
     end;
end; { of analisi }




procedure analizza(var p:punt;var expr:string;var err:error_info);
begin
  analizza2(p,'real x,y',expr,err); (* inserted 'real x,y' *)
end;

procedure analizza2(var p:punt;args:string;var expr:string;var err:error_info);
var ch:char;pointer:integer;
    id:namet;

  procedure error(errno:byte);
  begin
   if err.no=0
   then begin
          err.no:=errno;
          err.pos:=pointer-1;
        end;
  end; { of error }

  procedure leggi_ch;
  begin
    if (err.no=0)
    then begin
         (* skip blanks *)
         while (pointer <= length(expr)) and (expr[pointer] = ' ')
         do inc(pointer);
         if (pointer <= length(expr))
         then ch:=expr[pointer]
         else ch:=#13;
         end
    else ch:=#13;
    inc(pointer);
  end; { of leggi_ch }


  procedure expression(var p:punt);
  var ps:punt;

    procedure simple_expression(var p:punt);
    var pt:punt;

      procedure term(var p:punt);
      var pf:punt;

        procedure factor(var p:punt);
        var m,n:real;i:word;
            e_sign,e,e1,NDigits,EDigits:integer;
        begin
        leggi_ch;
        case ch of
        '(': begin
	      expression(p);leggi_ch;if ch<>')'then error(1)
             end;
        '-':begin
              new(p);
              if p<>nil
              then begin
                   p^.tipo:='m';factor(p^.sin);p^.des:=nil;
                   end
              else error(6)
            end;
        'a'..'z','A'..'Z':begin
                   dec(pointer);
                   Fetch_Id(id,expr,pointer);
                   ch:=expr[pointer];
                   i:=find_id(id);
                   if i=0 { identifier was not found }
                   then begin
                        error(3);
                        p:=nil;
                        end
                   else begin
                        new(p);
                        if p<>nil
                        then begin
                             p^.tipo:=IdList[i].Ty;
                             p^.des:=nil;p^.sin:=nil;
                             p^.address:=IdList[i].address;
                             case IdList[i].Ty of
                             'f':begin
                                  if ch<>'('then error(2);
                                  factor(p^.sin);
                                 end;
                             end; { of case }
                             end
                        else error(6)
                        end
                 end;
         '0'..'9':begin
                       n:=0;NDigits:=0;
                       e1:=0;
                       while ch='0'  {elimina 0 non significativi}
                       do leggi_ch;
                       while (ch in['0'..'9'])
                       do begin
                          if (NDigits<MaxNumOfDigit)
                          then begin
                               n:=n*10+ord(ch)-ord('0');
                               inc(NDigits);
                               end
                          else inc(e1);
                          leggi_ch
                          end;
                       if ch='.'
                       then begin
                             leggi_ch;m:=1;
                             while ch in['0'..'9']
                             do begin
                                m:=m*0.1;
                                n:=n+(ord(ch)-ord('0'))*m;
                                leggi_ch
                                end
                            end;
                       if UpCase(ch)='E'
                       then begin
                            e_sign:=1;e:=0;
                            leggi_ch;
                            if ch='+'
                            then leggi_ch
                            else if ch='-'
                                 then begin
                                      e_sign:=-1;
                                      leggi_ch;
                                      end;
                            while ch='0'  {elimina 0 non significativi}
                            do leggi_ch;
                            EDigits:=0;
                            while (ch in['0'..'9'])and(Edigits<MaxNumOfEDigit)
                            do begin
                               e:=e*10+ord(ch)-ord('0');
                               Inc(EDigits);
                               leggi_ch
                               end;
                            if ch in['0'..'9']
                            then error(8);
                            inc(e1,e*e_sign);
                            end;
                       dec(pointer);
                       new(p);
                       if p<>nil
                       then begin
                            if (e1+NDigits>MaxNumOfDigit)
                            then error(7)
                            else begin
                                 while (e1>0)
                                 do begin
                                    n:=n*10;dec(e1);
                                    end;
                                 while (e1<0)
                                 do begin
                                    n:=n*0.1;inc(e1);
                                    end;
                                 end;
                            p^.tipo:='n';p^.sin:=nil;p^.des:=nil;p^.num:=n
                            end
                       else error(6)
                  end;
        else begin
             error(4);
             p:=nil;
             end;
        end; { of case }
        end; { of factor }

      begin
      factor(pf);
      leggi_ch;
      while ch in['*','/']
      do begin
           new(p);
           if p<>nil
           then begin
                p^.tipo:=ch;p^.sin:=pf;pf:=p;
                factor(p^.des);
                end
           else error(6);
           leggi_ch
         end;
         p:=pf;dec(pointer);
      end; { of term }

    begin
    term(pt);
    leggi_ch;
    while ch in['+','-']
    do begin
         new(p);
         if p<>nil
         then begin
              p^.tipo:=ch;p^.sin:=pt;pt:=p;
              term(p^.des);
              end
         else error(6);
         leggi_ch
       end;
    p:=pt;dec(pointer);
    end; { of simple_expression }

  begin
  simple_expression(ps);
  leggi_ch;
  if ch in['>','<','=']
  then begin
         new(p);
         if p<>nil
         then begin
              p^.tipo:=ch;p^.sin:=ps;ps:=p;
              simple_expression(p^.des);
              end
         else error(6);
         leggi_ch
       end;
  p:=ps;dec(pointer);
  end; { of expression }

begin
err.no:=0;err.pos:=0;
pointer:=1;
OldHeapError:=HeapError;
HeapError:=@NoMemory;
if Args<>''
then begin
     if RegisterLocal(args)=0
     then expression(p)
     else error(9);
     UnRegisterLocal;
     end
else expression(p);

HeapError:=OldHeapError;
leggi_ch;
if ch<>#13 then error(5)
end; { of analizza2 }

procedure clear(var p:punt);
begin
if p<>nil
then begin
     clear(p^.sin);
     clear(p^.des);
     dispose(p);
     end;
end; { of clear }

function Register_function;

{ return code:  0 = Function has been registered
                1 = No room in IdList
                2 = No room in UserFunction
                3 = Error in name                  }
{ La funzione da registrare DEVE essere di tipo <far> }

begin
if SizeOfList<MaxSizeOfList
then if LastUserFunction<MaxUserFunction
     then begin
          if (length(fname)>0)and(Find_Id(fname)=0)
          then begin
               inc(LastUserFunction);
               UserFunction[LastUserFunction]:=fun;
               inc(SizeOfList);
               with IdList[SizeOfList]
               do begin
                  Name:=fname; { strip_space }
                  Address:=FUserFunction+LastUserFunction-1;
                  Ty:='f';
                  end;
               Register_function:=0;
               end
          else Register_function:=3
          end
     else Register_function:=2
else Register_function:=1;
end; { of Register_function }

function Register_Constant;

{ return code:  0 = Constant has been registered
                1 = No room in IdList
                2 = No room in Constant
                3 = Error in name                  }

begin
if SizeOfList<MaxSizeOfList
then if LastConstant<MaxConstant
     then begin
          if (length(cname)>0)and(Find_Id(cname)=0)
          then begin
               inc(LastConstant);
               Constant[LastConstant]:=value;
               inc(SizeOfList);
               with IdList[SizeOfList]
               do begin
                  Name:=cname; { strip_space }
                  Address:=LastConstant;
                  Ty:='c';
                  end;
               Register_Constant:=0;
               end
          else Register_Constant:=3
          end
     else Register_Constant:=2
else Register_Constant:=1;
end; { of Register_Constant }

function Register_Variable(vname:namet;p:preal):integer;

{ return code:  0 = Variable has been registered
                1 = No room in IdList
                2 = No room in Variable
                3 = Error in name                  }

begin
if SizeOfList<MaxSizeOfList
then if LastVariable<MaxVariable
     then begin
          if (length(vname)>0)and(Find_Id(vname)=0)
          then begin
               inc(LastVariable);
               Variables[LastVariable]:=p;
               inc(SizeOfList);
               with IdList[SizeOfList]
               do begin
                  Name:=vname; { strip_space }
                  Address:=LastVariable;
                  Ty:='v';
                  end;
               Register_Variable:=0;
               end
          else Register_Variable:=3
          end
     else Register_Variable:=2
else Register_Variable:=1;
end; { of Register_Variable }



procedure Init;
var i:integer;
begin
for i:=1 to SizeOfDefault
do IdList[i]:=Default[i];
SizeOfList:=SizeOfDefault;
LastUserFunction:=0;
LastConstant:=0;
LastVariable:=0;
i:=Register_Constant('pi',pi);
end; { of Init }

begin
Init;
end.
