{************************************************}
{                                                }
{ Program WS version 0.42 date 01-03-97          }
{ Main Part: uses WSwnd,WSObj,WSDLL,WSDLL1       }
{************************************************}

{ Modificato il 1/1/1994: introdotto multi-tasking (vedi MT)
                7/5/1994: introdotto il file WSINI.INI
                22/7/1994: nuove finestre di tipo library
                15/4/1994: aggiunta la funzione drag&drop
                1/3/1997: adattato a WIN95
}

program WS; { WS=program name }

{$R WS}     { WS=resource name }

uses
  WinTypes, WinProcs, WObjects, Strings, WSwnd,
  CommDLG, WinDos, ShellApi, Win31;

const
  AppName='WS';
  IniName='WSINI.INI';

type TFileName = array[0..fsPathName] of Char;

(* Begin: Aggiunta per MDI *)
     PMDIWin = ^TMDIWin;

     TMDIWin = OBJECT (TMDIWindow)
       constructor Init (ATitle : PChar; AMenu : HMenu);
       procedure SetupWindow;virtual;
       procedure WMEnterIdle(var Msg: TMessage); virtual WM_First + WM_EnterIdle;
       procedure WMDropFiles(var Msg: TMessage); virtual wm_First + wm_DropFiles;
       procedure About(var Message: TMessage); Virtual cm_first + idm_About;
       procedure Open(var Message: TMessage); Virtual cm_first + idm_Open;
       procedure NewWave(var Message: TMessage); Virtual cm_first + idm_Wave;
       procedure NewFilter(var Message: TMessage); Virtual cm_first + idm_Filter;
       procedure NewSystem(var Message: TMessage); Virtual cm_first + idm_System;
       procedure NewLibrary(var Message: TMessage); Virtual cm_first + idm_Library;
       procedure GetWindowClass(var WndClass: TWndClass); virtual;
       procedure OpenAFile(FileName: PChar); virtual;
     END;
(* End: Aggiunta per MDI *)


  TApp = object(TApplication)
    procedure InitMainWindow; virtual;
    procedure InitInstance; virtual;
  end; { of TApp }

function WSDLLVersion:word;far;external 'WSDLL';

{--------------- TApp ------------------------}

procedure TApp.InitMainWindow;

   procedure RegisterSym;
   var FileName: TFileName;
   begin
     GetModuleFilename(HInstance, FileName, SizeOf(TFileName));
     RegSetValue(hkey_Classes_Root, '\.sym\shell\open\command',reg_sz,StrCat(FileName,' %1'),0);
     GetModuleFilename(HInstance, FileName, SizeOf(TFileName));
     RegSetValue(hkey_Classes_Root, '\.sym\DefaultIcon',reg_sz,StrCat(FileName,',4'),0);
   end;

begin
  RegisterSym;
  if lobyte(GetVersion) = $03
  then if WSDLLVersion = $0500
       then MainWindow := New(PMDIWin, Init('WinSound/04',
                  LoadMenu(HInstance, 'MENU_WS')))
       else MainWindow := new(PDialog,init(nil,'WrongDLL'))
  else MainWindow := new(PDialog,init(nil,'WrongWin'));
end;

procedure TApp.InitInstance;
begin
  TApplication.InitInstance;
  HAccTable := LoadAccelerators(HInstance, 'ACCELERATORS');
end;


(* Begin: Aggiunta per MDI *)
CONSTRUCTOR TMDIWin.Init (ATitle : PChar; AMenu : HMenu);
BEGIN
  TMDIWindow.Init (ATitle, AMenu);
  ChildMenuPos := 0;
END;

procedure TMDIWin.SetupWindow;
var p:pointer;
    str:pChar;
begin
  TMDIWindow.SetupWindow;
  DragAcceptFiles(HWindow, True);
  if ParamCount = 1
  then begin
       GetMem(str,length(ParamStr(1))+1);
       StrPCopy(str,ParamStr(1));
       p:=New (PSystemWindow, Init (@self, str));
       FreeMem(str,length(ParamStr(1))+1);
       if p<>nil
       then Application^.MakeWindow (p);
       end;
end;


procedure TMDIWin.GetWindowClass(var WndClass: TWndClass);
begin
  TMDIWindow.GetWindowClass(WndClass);
  WndClass.hIcon := LoadIcon(HInstance, 'A_ICON');
end;

procedure TMDIWin.About(var Message: TMessage);
begin
  Application^.ExecDialog(new(PDialog,init(@Self,'About')))
end;

function FileOpen(HWindow:HWND;FileName:PChar):boolean;
const
  DefExt = 'wav';
var
  OpenFN      : TOpenFileName;
  i:integer;
begin
  StrCopy(FileName, '');

  FillChar(OpenFN, SizeOf(TOpenFileName), #0);
  with OpenFN do
  begin
    hInstance     := HInstance;
    hwndOwner     := HWindow;
    lpstrDefExt   := DefExt;
    lpstrFile     := FileName;
    lpstrFilter   := 'All WinSound files'+#0+'*.wav;*.flt;*.sym'+#0+'Waves'+#0+'*.wav'
                     +#0+'Filters'+#0+'*.flt'+#0+'Systems'+#0+'*.sym'+#0+#0;
    flags         := ofn_FileMustExist(* or ofn_AllowMultiSelect*);
    lStructSize   := sizeof(TOpenFileName);
    nFilterIndex  := 1;       {Index into Filter String in lpstrFilter}
    nMaxFile      := SizeOf(TFileName);
  end;
  FileOpen:=GetOpenFileName(OpenFN);
end;



procedure TMDIWin.Open(var Message: TMessage);
var  FileName: TFileName;
     Dir: array[0..fsDirectory] of Char;
begin
  GetCurDir(Dir,0);
  GetPrivateProfileString('Files','LastDir',Dir,Dir,sizeof(Dir),IniName);
  SetCurDir(Dir);
  if FileOpen(HWindow, @FileName)
  then begin
         GetCurDir(Dir,0);
         WritePrivateProfileString('Files','LastDir',Dir,IniName);
         WritePrivateProfileString('Files','LastFile',FileName,IniName);
         OpenAFile(FileName);
       end;
end;

procedure TMDIWin.NewWave(var Message: TMessage);
begin
(*  Application^.ExecDialog(new(PTinfoDialog,init(@Self,'Param')));*)
  Application^.MakeWindow (New (PWaveWindow, Init (@self, nil)));
end;

procedure TMDIWin.NewFilter(var Message: TMessage);
begin
(*  Application^.ExecDialog(new(PTinfoDialog,init(@Self,'Param')));*)
  Application^.MakeWindow (New (PFilterwindow, Init (@self, nil)));
end;

procedure TMDIWin.NewSystem(var Message: TMessage);
begin
(*  Application^.ExecDialog(new(PTinfoDialog,init(@Self,'Param')));*)
  Application^.MakeWindow (New (PSystemWindow, Init (@self, nil)));
end;

procedure TMDIWin.NewLibrary(var Message: TMessage);
begin
(*  Application^.ExecDialog(new(PTinfoDialog,init(@Self,'Param')));*)
  Application^.MakeWindow (New (PLibraryWindow, Init (@self, nil)));
end;

procedure TMDIWin.WMEnterIdle(var Msg: TMessage);
(* MT: Questa procedura assicura il MultiTask *)
begin
  Msg.Result:=0;
  if hAnaWindow <> 0
  then PostMessage(hAnaWindow,WM_U_Analysis,hAnaWindow,0);
end;

procedure TMDIWin.WMDropFiles(var Msg: TMessage);
var
  DropPt     : TPoint;
  hDrop      : THandle;
  NumDropped : Integer;
  DroppedName: TFilename;
  I          : Integer;
begin
  hDrop := Msg.WParam;
  DragQueryPoint(hDrop, DropPt);

{ By passing in exactly these parameters, we get the number of files
  (and directories) being dropped.
}
  NumDropped := DragQueryFile(hDrop, Word(-1), nil, 0);

{ This time we pass in the 'real' parameters and SHELL.DLL will fill
  in the path to the file (or directory).  Do so for each dropped file.
}
  for I := 0 to NumDropped-1 do
  begin
    DragQueryFile(hDrop, I, DroppedName, SizeOf(DroppedName));
    OpenAFile(DroppedName);
  end;

  DragFinish(hDrop);
end;

procedure TMDIWin.OpenAFile(FileName: PChar);
var p:pointer;
     Dir: array[0..fsDirectory] of Char;
     Name: array[0..fsFileName] of Char;
     Ext: array[0..fsExtension] of Char;
begin
  FileSplit(FileName, Dir, Name, Ext);
  StrUpper(Ext);
  if StrComp(Ext,'.WAV') = 0
  then p:=New (PWaveWindow, Init (@self, FileName))
  else if StrComp(Ext,'.FLT') = 0
       then p:=New (PFilterWindow, Init (@self, FileName))
       else begin
            p:=New (PSystemWindow, Init (@self, FileName));
            if p = nil
            then p:=New (PLibraryWindow, Init (@self, FileName));
            end;
  if p<>nil
  then Application^.MakeWindow (p);
end;

{------------- Main Program --------------------}

var
  App: TApp;
begin
  App.Init(AppName);
  App.Run;
  App.Done;
end.
