unit WsDLL1;

(* ATTENZIONE: 4444 identifica le modifiche per 0.3-> 0.4
               Le parti marcate con 4444 vanno RIVISTE !!!!
   VERIFICARE LA VALIDITA' DEL METODO <StoreParam> PER
   TUTTI GLI OGGETTI !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
*)

{  A causa dell'errore 48 del turbo pascal 1.5, il file
   WSDLL.PAS e' stato suddiviso in due files: WSDLL1.PAS
   e WSDLL.PAS. Questa unit e' usata solo da WSDLL.
   
}
{  Questa libreria contiene le funzioni e procedure per
   la gestione degli oggetti che possono essere usati
   per costruire un sistema in ambiente WinSound.
   La libreria e' espandibile indipendentemente da WinSound.
   Libreria usata da WS,WSWND e WSOBJ.

   Il file WSDLL.RES e' stato suddiviso nei files WSDLL.RES e
   WSDLL1.RES a causa dell'errore 45 del turbo pascal 1.5

   Ver 0.4:   La procedura <GetNumber> e' stata rimossa.
              Introdotta la funzione virtuale <StoreParam>.
              La procedura <Store> non e' piu' virtuale ed
              e' riservata al solo tipo <TBlock>.
}
(*AP1: problemi con blocchi grandi(64K)
  AP2: Side Effects ?
  AP3: la compilazione di questo DLL crea un file piu' grande !?
  AP4: ottimizzare la conversione di tipo
  Ap5: razionalizzare l'uso dei buffers <tiobuf>
  AP6: <bufsize> = 0  <===> analisi <one-shot>--> verificare <Start>
  AP7: rilasciare la memoria impegnata per i colori
  AP8: attenzione agli ingressi non campionati!!!
  AP9: operazioni sui puntatori sono valide solo per blocchi <64K
  AP10: dichiarazione a rischio:dipende dal tipo <RealArray>
  AP11: meglio usare <trunc> o <round> ?
  AP12: fondere i files WSDLL1.PAS e WSDLL.PAS con BP7.0?
  AP13: la procedura <SetDlg> deve essere aggiornata con <GetPString>
  AP14: l'oggetto TVibrato e' incompleto (period = bufsize)
*)
{ ERRORE TPW 1.5: l'esecuzione della seguente istruzione
   genera un errore di protezione quando la stringa
   testo e' di lunghezza nulla:  Val(testo,_ft,code);
   (testo:array[]of char;_ft:real;code:integer)
}
{  Verificare sempre il risultato di: GlobalAlloc,New

}

{ Creazione di un nuovo oggetto:
  1) Creare un nuovo BitMap e, se necessario, un dialogo
     in WSDLL.RES
  2) Aggiungere una nuova costante zOGGETTO con un valore
     uguale a quello successivo a zLast.
  3) Porre zLast=zOGGETTO
  4) Aggiornare le costanti Names,DlgNames,BMPNames considerando che:
       Names:   nome nuovo oggetto
       DlgNames:nome del dialogo che gestisce l'oggetto
       BMPNames:nome del BITMAP associato all'oggetto
  5) Creare un tipo oggetto derivato dalla classe TBlock
     per descrivere il comportamento del nuovo oggetto.
  6) Aggiornare la procedura NewObj con l'inizializzazione
     del nuovo oggetto.

- Tutti gli ingressi campionati di un oggetto devono avere la stessa
  frequenza di campionamento. Questo controllo e' a carico del sistema.
- Ogni oggetto deve supporre che FS sia maggiore o uguale a zero.
  La condizione FS=0 e' associata a dati non campionati.
- Le dimensioni dei buffer in ingresso possono essere diverse.
  Ogni oggetto puo' decidere se troncare i dati oppure riempire con
  zeri le differenze di lunghezza.
  Inoltre gli ingressi non campionati possono avere lunghezza maggiore
  del <bufsize> ===> Attenzione alla gestione dei segnali non campionati!!!
- I buffer di uscita sono definiti, creati e distrutti dall'oggetto
  che gestisce le uscite. La loro dimensione e' definita dalla
  procedura Start().

}

{ ERRORE TPW 1.5: l'esecuzione della seguente istruzione
   genera un errore di protezione quando la stringa
   testo e' di lunghezza nulla:  Val(testo,_ft,code);
   (testo:array[]of char;_ft:real;code:integer)
}

interface
uses WinTypes, WinProcs, WObjects, WSObj, Strings,
     MMSystem, Math, CommDlg, WSFilter, Win31, WSMCI;

const zEmpty=0;
      zReadWave=1;
      zWriteWave=2;
      zRecord=3;
      zPlay=4;
      zFunction=5;
      zFunctionX=6;
      zFunctionXY=7;
      zTConv=8;
      zEco=9;
      zVibrato=10;
      zGenerator=11;
      zScope1=12;
      zScopeXY=13;
      zImage=14;
      zMeter=15;
      zSystem=16;
      zSum=17;
      zProd=18;
      zLimiter=19;
      zSilencer=20;
      zQuantizer=21;
      zCompare=22;
      zSRLimiter=23;
      zZeroHold=24;
      zBFilter=25;
      zHist=26;
      zMean=27;
      zDiff=28;
      zAcc=29;
      zDelay=30;
      zSwitch=31;
      zTextOut=32;
      zFastMod=33;
      zFFTR=34;
      zIFFTR=35;
      zMediaSeq=36;
      zRxy=37;
      zLast=zRxy;

const Names:array[0..zLast]of string[15]=
        ('Undef','ReadWave','WriteWave','Record','Play','Function(n)','Function(x,n)',
         'Function(x,y,n)','TypeConvert','Eco','Vibrato','Generator','Oscilloscope','XY',
         'Image','Meter','System','Sum','Prod','Limiter','Silencer','Quantizer',
         'Compare','SRLimiter','ZeroHold','BuiltInFilter','Hist','Mean','Difference','Accumulator',
         'Delay','Switch','TextOut','FastMod','FFTR','IFFTR','MediaSeq','Rxy');

(* NOTA: IL DIALOGO 'FileName' E' USATO IMPLICITAMENTE DA TMACRO.INIT() *)
      DlgNames:array[0..zLast]of array[0..12]of char=
        ('Info','Filename','Filename','Record','Info','fn2','fnx','fnx','tconv','eco','vibrato','generator',
         'Scope1','ScopeXY','Image','Meter','Macro','Sum','Info','Limiter','Silencer','Quantizer',
         'Comp','SRLimiter','ZeroHold','filter','Hist','Mean','Info','Info','Delay','Switch','TextOut',
         'Info','FFTR','IFFTR','MediaSub','Rxy');
      BMPNames:array[0..zLast]of  array[0..12]of char=
        ('None','ReadWave','WriteWave','Record','Play','fn','fnx',
         'fxyn','TConv','Eco','Vibrato','Generator','Scope1','ScopeXY',
         'Image','Meter','System','Sum','Prod','Limiter','Silencer','Quantizer',
         'Comp','SRLimiter','ZeroHold','Filter','Hist','Mean','Diff','Acc',
         'Delay','Switch','TextOut','FastMod','FFTR','IFFTR','MediaSub','Rxy');

(* La costante <Names> contiene i nomi degli oggetti *)
(* La costante <DlgNames> contiene i nomi dei dialoghi associati agli oggetti *)
(* La costante <zLast> contiene l'identificatore dell'ultimo tipo di oggetto *)

(* Procedure VIRTUALI che caratterizzano un oggetto derivato
   da TBLOCK:

   procedure OBBLIGATORIE:

   Capability:restituisce le caratteristiche dell'oggetto

   Check:   verifica la correttezza delle informazioni
            memorizzate e la capacita' di supportare
            quanto richiesto. Inoltre restituisce <fsample>
            e <attr> delle uscite e verifica le <fsample>
            e <attr> degli ingressi rispetto i valori interni. 
   Start:   verifica che le informazioni memorizzate siano
            corrette, alloca i buffer necessari e azzera le
            variabili interne.Inoltre restituisce <fsample>
            e <attr> delle uscite e verifica le <fsample>
            e <attr> degli ingressi rispetto i valori interni. 

   Stop:    rilascia i buffer e termina eventuali azioni
            sospese
   Transfer: calcola la funzione di trasferimento.

   Procedure OPZIONALI:

   SetDlg:  riempe i campi del dialogo il cui nome e'
            dato dalla variabile <DlgNames>
   GetDlg:  legge i campi del dialogo trasferendoli nella
            stringa <st>
   ProcessDlg: gestione di controlli specifici nel dialogo oggetto

   StoreParam: controlla la correttezza dei dati e, in caso positivo,
               li memorizza nell'oggetto, creando le eventuali
               strutture dati associate all'oggetto.

   GetBufSize: restituisce il valore <bufsize> adatto per l'oggetto

NOTA1: le procedure <Start> e <Transfer> devono essere
       dichiarate nell'oggetto.
NOTA2: un oggetto puo' decidere il tipo di uscita sulla
       base degli ingressi.
NOTA3: un vettore di dati non campionati e' caratterizzato
       da <fsample> = 0.
NOTA4: Il risultato di <Transfer>  normalmente 0. Nel caso di
       sorgenti <Transfer>=0 se ci sono altri campioni da generare.
NOTA5: la procedura <ProcessDlg> non deve modificare direttamente
       il valore dei parametri. Il valore dei parametri deve essere
       aggiornato da <GetDlg>.
NOTA6: Dati dinamici creati da <StoreParam> devono essere liberati
       da <Done>.

I dialoghi degli oggetti hanno i seguenti controlli obbligatori:

         1:      Button 'Ok'
         2:      Button 'Cancel'
       103:      Static Text
       

*)
(* CHECK:result codes
   result = 0 : ok
          = 1 : something has not been defined (e.g.:filename='')
          = 2 : wrong format (e.g. corrupted file )
          = 3 : unsupported format (e.g. 16-bit audio on 8-bit board)
          = 4 : unable to seize buffers/resources
          = 5 : connected terminals are incompatible (fsample/ioattr)
          = 6 : macro internal error
          = 7 : buffer size is incompatible with object
          = 8 : parameter value not supported (e.g. negative timebase)
*)

(* Object Layout, MaxTerminal = 12

        12 11 10
         |  |  |
       +-+--+--+-+
    1 -+         +- 9
       |         |
    2 -+  TBLOCK +- 8
       |         |
    3 -+         +- 7
       +-+--+--+-+
         |  |  |
         4  5  6
*)
const zMaxTitleLength=20;
      zWidth=256;

type  PBlock=^TBlock;
      TBlock=object
               BlockId:integer;
               ownsize:longint;
               param:string;
               PS:pSystem;  (* 5555 *)
               procedure SetDlg(HWindow:HWnd);virtual;
               function GetDlgOk(HWindow:HWnd):boolean;
               function ProcessDlg(HWindow:HWnd;wParam:word):integer;virtual;
               procedure Store(var st:string);
               procedure GetDlg(HWindow:HWnd;var st:string);virtual;
               function StoreParam(HWindow:HWnd;var st:string;ErrString:PChar):boolean;virtual;
               procedure Retrieve(var st:string);
               constructor Init(SystemP:pSystem;Num:integer);
               function Transfer(var iop:aiobuf):integer;virtual;
               destructor Done;virtual;
               procedure Capability(var Attr:TAttrDev;var IOClass:TAIOClass);virtual;
               function Check(var prop:AIOprop):integer;virtual;
               function Start(var prop:AIOprop;bufsize:longint;HWindow:HWnd):integer;virtual;
               procedure Stop;virtual;
               procedure GetBufSize(var bufsize:longint);virtual;
             end;
(* tipo base per un oggetto con un ingresso, una uscita dello stesso tipo,
   che gestisce dati byte/integer/real, sampled/not sampled.
*)
      P1In1Out=^T1In1Out;
      T1In1Out=object(TBlock)
                OwnType:integer;
                MemHandle:THandle;MemPtr:pointer;
                procedure Capability(var Attr:TAttrDev;var IOClass:TAIOClass);virtual;
                function Check(var prop:AIOprop):integer;virtual;
                function Start(var prop:AIOprop;bufsize:longint;HWindow:HWnd):integer;virtual;
                procedure Stop;virtual;
                end;
      TFileWave=object(TBlock)
                fn:TFileName;
                read:boolean; (* read mode ? *)
                fsample,slength:longint;
                constructor Init(SystemP:pSystem;Num:integer;_read:boolean);
                procedure GetDlg(HWindow:HWnd;var st:string);virtual;
                procedure SetDlg(HWindow:HWnd);virtual;
                function ProcessDlg(HWindow:HWnd;wParam:word):integer;virtual;
                function StoreParam(HWindow:HWnd;var st:string;ErrString:PChar):boolean;virtual;
                end;
      PReadWave=^TReadWave;
      TReadWave=object(TFileWave)
                f:integer;
                MemHandle:THandle;MemPtr:pointer;
                residual:longint;
                constructor Init(SystemP:pSystem;Num:integer);
                procedure Capability(var Attr:TAttrDev;var IOClass:TAIOClass);virtual;
                function Check(var prop:AIOprop):integer;virtual;
                function Start(var prop:AIOprop;bufsize:longint;HWindow:HWnd):integer;virtual;
                procedure Stop;virtual;
                function Transfer(var iop:aiobuf):integer;virtual;
                end;
      PWriteWave=^TWriteWave;
      TWriteWave=object(TFileWave)
                f:file;
                constructor Init(SystemP:pSystem;Num:integer);
                procedure Capability(var Attr:TAttrDev;var IOClass:TAIOClass);virtual;
                function Check(var prop:AIOprop):integer;virtual;
                function Start(var prop:AIOprop;bufsize:longint;HWindow:HWnd):integer;virtual;
                procedure Stop;virtual;
                function Transfer(var iop:aiobuf):integer;virtual;
                end;
      PPlay=^TPlay;
      TPlay=object(TBlock)
                InputType:integer; (* used for ACG *)
                MemHandle:THandle; (* used for ACG *)
                Mem:tiobuf;        (* used for ACG *)
                IntGain:integer;RealGain:real;(* used for ACG *)
                f:file;TempFile:TFileName;
                fsample,slength:longint;
                ParentWnd:HWnd;
                function Check(var prop:AIOprop):integer;virtual;
                procedure Capability(var Attr:TAttrDev;var IOClass:TAIOClass);virtual;
                function Start(var prop:AIOprop;bufsize:longint;HWindow:HWnd):integer;virtual;
                procedure Stop;virtual;
                function Transfer(var iop:aiobuf):integer;virtual;
                end;
      PFunction=^TFunction;
      TFunction=object(TBlock)
                funzione:string[128];
                pfx:punt;
                slength,fsample:longint;
                MemHandle:THandle;MemPtr:pointer;
                residual:longint;
                functionType:integer;
                constructor Init(SystemP:pSystem;Num:integer);
                destructor Done;virtual;
                procedure SetDlg(HWindow:HWnd);virtual;
                procedure GetDlg(HWindow:HWnd;var st:string);virtual;
                procedure Capability(var Attr:TAttrDev;var IOClass:TAIOClass);virtual;
                function Check(var prop:AIOprop):integer;virtual;
                function Start(var prop:AIOprop;bufsize:longint;HWindow:HWnd):integer;virtual;
                function Transfer(var iop:aiobuf):integer;virtual;
                procedure Stop;virtual;
                function StoreParam(HWindow:HWnd;var st:string;ErrString:PChar):boolean;virtual;
                end;
      PFunctionX=^TFunctionX;
      TFunctionX=object(TBlock)
                 funzione:string[128];
                 pfx:punt;
                 MemHandle:THandle;MemPtr:pointer;
                 local_n,fs:real;
                 functionType:integer;
                 constructor Init(SystemP:pSystem;Num:integer);
                 destructor Done;virtual;
                 procedure SetDlg(HWindow:HWnd);virtual;
                 procedure GetDlg(HWindow:HWnd;var st:string);virtual;
                 procedure Capability(var Attr:TAttrDev;var IOClass:TAIOClass);virtual;
                 function Check(var prop:AIOprop):integer;virtual;
                 function Start(var prop:AIOprop;bufsize:longint;HWindow:HWnd):integer;virtual;
                 function Transfer(var iop:aiobuf):integer;virtual;
                 procedure Stop;virtual;
                 function StoreParam(HWindow:HWnd;var st:string;ErrString:PChar):boolean;virtual;
                 end;
      PFunctionXY=^TFunctionXY;
      TFunctionXY=object(TBlock)
                 funzione:string[128];
                 pfx:punt;
                 MemHandle:THandle;MemPtr:pointer;
                 local_n,fs:real;
                 functionType:integer;
                 constructor Init(SystemP:pSystem;Num:integer);
                 destructor Done;virtual;
                 procedure SetDlg(HWindow:HWnd);virtual;
                 procedure GetDlg(HWindow:HWnd;var st:string);virtual;
                 procedure Capability(var Attr:TAttrDev;var IOClass:TAIOClass);virtual;
                 function Check(var prop:AIOprop):integer;virtual;
                 function Start(var prop:AIOprop;bufsize:longint;HWindow:HWnd):integer;virtual;
                 function Transfer(var iop:aiobuf):integer;virtual;
                 procedure Stop;virtual;
                 function StoreParam(HWindow:HWnd;var st:string;ErrString:PChar):boolean;virtual;
                 end;
      PGenerator=^TGenerator;
      TGenerator=object(TBlock)
                slength,fsample,period:longint;
                funzione:integer;
                amplitude:real;
                prec:real;
                MemHandle:THandle;MemPtr:pointer;
                functionType:integer;
                residual:longint;
                constructor Init(SystemP:pSystem;Num:integer);
                procedure SetDlg(HWindow:HWnd);virtual;
                procedure GetDlg(HWindow:HWnd;var st:string);virtual;
                procedure Capability(var Attr:TAttrDev;var IOClass:TAIOClass);virtual;
                function Check(var prop:AIOprop):integer;virtual;
                function Start(var prop:AIOprop;bufsize:longint;HWindow:HWnd):integer;virtual;
                function Transfer(var iop:aiobuf):integer;virtual;
                procedure Stop;virtual;
                function StoreParam(HWindow:HWnd;var st:string;ErrString:PChar):boolean;virtual;
                end;
      PSum=^TSum;
      TSum=object(TBlock)
                SumType:integer;
                operation:integer;
                MemHandle:THandle;MemPtr:pointer;
                procedure Capability(var Attr:TAttrDev;var IOClass:TAIOClass);virtual;
                function Check(var prop:AIOprop):integer;virtual;
                function Start(var prop:AIOprop;bufsize:longint;HWindow:HWnd):integer;virtual;
                function Transfer(var iop:aiobuf):integer;virtual;
                procedure Stop;virtual;
                constructor Init(SystemP:pSystem;Num:integer);
                procedure SetDlg(HWindow:HWnd);virtual;
                procedure GetDlg(HWindow:HWnd;var st:string);virtual;
                function StoreParam(HWindow:HWnd;var st:string;ErrString:PChar):boolean;virtual;
                end;
      PProd=^TProd;
      TProd=object(TBlock)
                ProdType,InputType:integer;
                MemHandle:THandle;MemPtr:pointer;
                procedure Capability(var Attr:TAttrDev;var IOClass:TAIOClass);virtual;
                function Check(var prop:AIOprop):integer;virtual;
                function Start(var prop:AIOprop;bufsize:longint;HWindow:HWnd):integer;virtual;
                function Transfer(var iop:aiobuf):integer;virtual;
                procedure Stop;virtual;
                end;
      PBFilter=^TBFilter;
      TBFilter=object(TBlock)
                MemHandle:THandle;MemPtr:pointer;
                filterp:pBuiltIn;
                constructor Init(SystemP:pSystem;Num:integer);
                procedure Capability(var Attr:TAttrDev;var IOClass:TAIOClass);virtual;
                function Check(var prop:AIOprop):integer;virtual;
                function Start(var prop:AIOprop;bufsize:longint;HWindow:HWnd):integer;virtual;
                function Transfer(var iop:aiobuf):integer;virtual;
                procedure Stop;virtual;
                procedure SetDlg(HWindow:HWnd);virtual;
                procedure GetDlg(HWindow:HWnd;var st:string);virtual;
                function StoreParam(HWindow:HWnd;var st:string;ErrString:PChar):boolean;virtual;
                end;
      PTConv=^TTConv;
      TTConv=object(TBlock)
                InputType:integer;
                functionType:integer;
                MemHandle:THandle;MemPtr:pointer;
                constructor Init(SystemP:pSystem;Num:integer);
                procedure Capability(var Attr:TAttrDev;var IOClass:TAIOClass);virtual;
                function Check(var prop:AIOprop):integer;virtual;
                function Start(var prop:AIOprop;bufsize:longint;HWindow:HWnd):integer;virtual;
                function Transfer(var iop:aiobuf):integer;virtual;
                procedure Stop;virtual;
                procedure SetDlg(HWindow:HWnd);virtual;
                procedure GetDlg(HWindow:HWnd;var st:string);virtual;
                function StoreParam(HWindow:HWnd;var st:string;ErrString:PChar):boolean;virtual;
                end;
      PCompare=^TCompare;
      TCompare=object(TBlock)
                state:boolean;
                upper,lower,high,low:real;
                InputType:integer;
                functionType:integer;
                MemHandle:THandle;MemPtr:pointer;
                constructor Init(SystemP:pSystem;Num:integer);
                procedure Capability(var Attr:TAttrDev;var IOClass:TAIOClass);virtual;
                function Check(var prop:AIOprop):integer;virtual;
                function Start(var prop:AIOprop;bufsize:longint;HWindow:HWnd):integer;virtual;
                function Transfer(var iop:aiobuf):integer;virtual;
                procedure Stop;virtual;
                procedure SetDlg(HWindow:HWnd);virtual;
                procedure GetDlg(HWindow:HWnd;var st:string);virtual;
                function StoreParam(HWindow:HWnd;var st:string;ErrString:PChar):boolean;virtual;
                end;
      PEco=^TEco;
      TEco=object(T1In1Out)
                Delay:longint;feedback:integer;
                first:longint;
                EcoHandle:THandle;
                Eco:tiobuf;
                constructor Init(SystemP:pSystem;Num:integer);
                procedure SetDlg(HWindow:HWnd);virtual;
                procedure GetDlg(HWindow:HWnd;var st:string);virtual;
                function Start(var prop:AIOprop;bufsize:longint;HWindow:HWnd):integer;virtual;
                function Transfer(var iop:aiobuf):integer;virtual;
                procedure Stop;virtual;
                function StoreParam(HWindow:HWnd;var st:string;ErrString:PChar):boolean;virtual;
                end;
      PVibrato=^TVibrato;
      TVibrato=object(T1In1Out)
                maxdelay:integer;period:longint;
                constructor Init(SystemP:pSystem;Num:integer);
                function Start(var prop:AIOprop;bufsize:longint;HWindow:HWnd):integer;virtual;
                procedure SetDlg(HWindow:HWnd);virtual;
                procedure GetDlg(HWindow:HWnd;var st:string);virtual;
                function Transfer(var iop:aiobuf):integer;virtual;
                function StoreParam(HWindow:HWnd;var st:string;ErrString:PChar):boolean;virtual;
                end;
      PDisplay1=^TDisplay1;
      TDisplay1=object(TBlock)
                style:integer;
                title:array[0..zMaxTitleLength]of char;
                Wnd:HWnd;
                procedure SetUpPaint(TheDC: HDC; erase:boolean;Window:HWnd);
                procedure Paint(TheDC: HDC; var PaintInfo: TPaintStruct;Window:HWnd);virtual;
                function InitDisplay(HWindow:HWnd;width:integer):HWnd;
                function GetStyle(HWindow:HWnd):integer;virtual;
                function StoreTitle(var st:string;var j:integer;ErrString:PChar):boolean;
                private
                border:boolean;_width:integer;
                end;
      TDisplayImage=object(TDisplay1)
                function InitDisplay(HWindow:HWnd;width,height:integer):HWnd;
                end;
      PScope1=^TScope1;
      TScope1=object(TDisplay1)
                ScopeType:integer;
                MemHandle:THandle;
                Mem:tiobuf;
                autoblank,nchannels:integer;
                autorange:boolean;
                timebase:longint;
                index:word;
                redraw:boolean;
                IntGain:integer;RealGain:real;
                constructor Init(SystemP:pSystem;Num:integer);
                procedure SetDlg(HWindow:HWnd);virtual;
                procedure GetDlg(HWindow:HWnd;var st:string);virtual;
                function StoreParam(HWindow:HWnd;var st:string;ErrString:PChar):boolean;virtual;
                procedure Paint(TheDC: HDC; var PaintInfo: TPaintStruct;Window:HWnd);virtual;
                function Start(var prop:AIOprop;bufsize:longint;HWindow:HWnd):integer;virtual;
                function Check(var prop:AIOprop):integer;virtual;
                procedure Capability(var Attr:TAttrDev;var IOClass:TAIOClass);virtual;
                procedure Stop;virtual;
                function Transfer(var iop:aiobuf):integer;virtual;
                end;

      PScopeXY=^TScopeXY;
      TScopeXY=object(TDisplay1)
                XType,YType:integer;
                MemHandleX,MemHandleY:THandle;
                MemX,MemY:tiobuf;
                autoblank:integer;
                autorange:boolean;
                IntGainX:integer;RealGainX:real;
                IntGainY:integer;RealGainY:real;
                constructor Init(SystemP:pSystem;Num:integer);
                procedure SetDlg(HWindow:HWnd);virtual;
                procedure GetDlg(HWindow:HWnd;var st:string);virtual;
                function StoreParam(HWindow:HWnd;var st:string;ErrString:PChar):boolean;virtual;
                procedure Paint(TheDC: HDC; var PaintInfo: TPaintStruct;Window:HWnd);virtual;
                function Start(var prop:AIOprop;bufsize:longint;HWindow:HWnd):integer;virtual;
                function Check(var prop:AIOprop):integer;virtual;
                procedure Capability(var Attr:TAttrDev;var IOClass:TAIOClass);virtual;
                procedure Stop;virtual;
                function Transfer(var iop:aiobuf):integer;virtual;
               end;

      PImage=^TImage;
      TImage=object(TDisplayImage)
                residual,ValidSize:longint;
                x,width:integer;
                Temp:tiobuf;
                ScopeType:integer;
                MemHandle:THandle;
                Mem:tiobuf;
                autorange:boolean;
                timebase:longint;
                index:word;
                IntGain:integer;RealGain:real;
                procedure PaintBuffer;
                constructor Init(SystemP:pSystem;Num:integer);
                procedure SetDlg(HWindow:HWnd);virtual;
                procedure GetDlg(HWindow:HWnd;var st:string);virtual;
                function StoreParam(HWindow:HWnd;var st:string;ErrString:PChar):boolean;virtual;
                procedure Paint(TheDC: HDC; var PaintInfo: TPaintStruct;Window:HWnd);virtual;
                function Start(var prop:AIOprop;bufsize:longint;HWindow:HWnd):integer;virtual;
                function Check(var prop:AIOprop):integer;virtual;
                procedure Capability(var Attr:TAttrDev;var IOClass:TAIOClass);virtual;
                procedure Stop;virtual;
                function Transfer(var iop:aiobuf):integer;virtual;
                end;
const zMaxValues=8;
type  PMeter=^TMeter;
      TMeter=object(TDisplayImage)
                MeterType:integer;
                value:array[0..zMaxValues-1]of real;
                nvalues:integer;
                nrows:integer;
                constructor Init(SystemP:pSystem;Num:integer);
                procedure SetDlg(HWindow:HWnd);virtual;
                procedure GetDlg(HWindow:HWnd;var st:string);virtual;
                function StoreParam(HWindow:HWnd;var st:string;ErrString:PChar):boolean;virtual;
                procedure Paint(TheDC: HDC; var PaintInfo: TPaintStruct;Window:HWnd);virtual;
                function Start(var prop:AIOprop;bufsize:longint;HWindow:HWnd):integer;virtual;
                function Check(var prop:AIOprop):integer;virtual;
                procedure Capability(var Attr:TAttrDev;var IOClass:TAIOClass);virtual;
                function Transfer(var iop:aiobuf):integer;virtual;
                procedure Stop;virtual;
                end;
      PHist=^THist;
      THist=object(TBlock)
                HistType,OutType:integer;
                Nint:integer;
                Cumulative:integer;
                min,max:real;
                MemHandle:THandle;
                Mem:tiobuf;
                constructor Init(SystemP:pSystem;Num:integer);
                procedure SetDlg(HWindow:HWnd);virtual;
                procedure GetDlg(HWindow:HWnd;var st:string);virtual;
                procedure Capability(var Attr:TAttrDev;var IOClass:TAIOClass);virtual;
                function Check(var prop:AIOprop):integer;virtual;
                function Start(var prop:AIOprop;bufsize:longint;HWindow:HWnd):integer;virtual;
                function Transfer(var iop:aiobuf):integer;virtual;
                procedure Stop;virtual;
                function StoreParam(HWindow:HWnd;var st:string;ErrString:PChar):boolean;virtual;
                end;
      PLimiter=^TLimiter;
      TLimiter=object(T1In1Out)
                min,max:real;
                constructor Init(SystemP:pSystem;Num:integer);
                procedure SetDlg(HWindow:HWnd);virtual;
                procedure GetDlg(HWindow:HWnd;var st:string);virtual;
                function StoreParam(HWindow:HWnd;var st:string;ErrString:PChar):boolean;virtual;
                function Transfer(var iop:aiobuf):integer;virtual;
                end;
      PSilencer=^TSilencer;
      TSilencer=object(T1In1Out)
                upper,lower:real;
                constructor Init(SystemP:pSystem;Num:integer);
                procedure SetDlg(HWindow:HWnd);virtual;
                procedure GetDlg(HWindow:HWnd;var st:string);virtual;
                function StoreParam(HWindow:HWnd;var st:string;ErrString:PChar):boolean;virtual;
                function Transfer(var iop:aiobuf):integer;virtual;
                end;
      PQuantizer=^TQuantizer;
      TQuantizer=object(T1In1Out)
                quanto:real;
                constructor Init(SystemP:pSystem;Num:integer);
                procedure SetDlg(HWindow:HWnd);virtual;
                procedure GetDlg(HWindow:HWnd;var st:string);virtual;
                function StoreParam(HWindow:HWnd;var st:string;ErrString:PChar):boolean;virtual;
                function Transfer(var iop:aiobuf):integer;virtual;
                end;
      PDelay=^TDelay;
      TDelay=object(T1In1Out)
                delay:longint;
                first:longint;
                EcoHandle:THandle;
                Eco:tiobuf;
                constructor Init(SystemP:pSystem;Num:integer);
                procedure SetDlg(HWindow:HWnd);virtual;
                procedure GetDlg(HWindow:HWnd;var st:string);virtual;
                function Start(var prop:AIOprop;bufsize:longint;HWindow:HWnd):integer;virtual;
                function Transfer(var iop:aiobuf):integer;virtual;
                procedure Stop;virtual;
                function StoreParam(HWindow:HWnd;var st:string;ErrString:PChar):boolean;virtual;
                end;
      PSRLimiter=^TSRLimiter;
      TSRLimiter=object(T1In1Out)
                max:real;
                IntegerOldy:integer;
                RealOldy:real;
                constructor Init(SystemP:pSystem;Num:integer);
                procedure SetDlg(HWindow:HWnd);virtual;
                procedure GetDlg(HWindow:HWnd;var st:string);virtual;
                function StoreParam(HWindow:HWnd;var st:string;ErrString:PChar):boolean;virtual;
                function Start(var prop:AIOprop;bufsize:longint;HWindow:HWnd):integer;virtual;
                function Transfer(var iop:aiobuf):integer;virtual;
                end;
      PZeroHold=^TZeroHold;
      TZeroHold=object(T1In1Out)
                period,counter:integer;
                ByteOldy:byte;
                IntegerOldy:integer;
                RealOldy:real;
                constructor Init(SystemP:pSystem;Num:integer);
                procedure SetDlg(HWindow:HWnd);virtual;
                procedure GetDlg(HWindow:HWnd;var st:string);virtual;
                function StoreParam(HWindow:HWnd;var st:string;ErrString:PChar):boolean;virtual;
                function Start(var prop:AIOprop;bufsize:longint;HWindow:HWnd):integer;virtual;
                function Transfer(var iop:aiobuf):integer;virtual;
                end;
      PMean=^TMean;
      TMean=object(TBlock)
                cumulative:integer;nsamples:longint;
                sum,sum2:double;
                mean:array[0..1]of real; (* AP10: RealArray *)
                InputType:integer;
                constructor Init(SystemP:pSystem;Num:integer);
                procedure SetDlg(HWindow:HWnd);virtual;
                procedure GetDlg(HWindow:HWnd;var st:string);virtual;
                function StoreParam(HWindow:HWnd;var st:string;ErrString:PChar):boolean;virtual;
                function Start(var prop:AIOprop;bufsize:longint;HWindow:HWnd):integer;virtual;
                function Check(var prop:AIOprop):integer;virtual;
                procedure Capability(var Attr:TAttrDev;var IOClass:TAIOClass);virtual;
                function Transfer(var iop:aiobuf):integer;virtual;
                end;
      PDiff=^TDiff;
      TDiff=object(T1In1Out)
                IntegerOldx:integer;
                RealOldx:real;
                function Start(var prop:AIOprop;bufsize:longint;HWindow:HWnd):integer;virtual;
                function Transfer(var iop:aiobuf):integer;virtual;
                end;
      PAcc=^TAcc;
      TAcc=object(T1In1Out)
                IntegerOldy:integer;
                RealOldy:real;
                InputType:integer;
                function Check(var prop:AIOprop):integer;virtual;
                function Start(var prop:AIOprop;bufsize:longint;HWindow:HWnd):integer;virtual;
                function Transfer(var iop:aiobuf):integer;virtual;
                end;

procedure GetString(var s,sub:string;var i:integer);
function GetType(var st:string;var j:integer;var t:integer):boolean;
function Type2Char(_type:word):char;
function FileOpen(HWindow:HWND;FileName:PChar;filter:PChar;read:boolean):boolean;
function AllocArray(size:longint;arraytype:integer):THandle;

const   BadFormat='Wrong format';
var     BitMap:array[0..zLast] of HBitmap;
        OldProc:pointer;
        Display1Proc: TFarProc;
        ImageLogPalette: PLogPalette;
        ThePalette: HPalette;
        DeskX,DeskY:integer;

implementation
(* - - - private section - - - *)

procedure GetString(var s,sub:string;var i:integer);
(* This procedure fetch from string <s> a substring <sub> *)
var j:integer;
begin
j:=0;
while (i<=length(s))and(s[i]<>';')
do begin
   inc(j);
   sub[j]:=s[i];
   inc(i);
   end;
sub[0]:=char(j);
end;

  function GetType(var st:string;var j:integer;var t:integer):boolean;
  begin
  GetType:=true;
  case st[j]of
    'B':t:=zByte;
    'I':t:=zInteger;
    'R':t:=zReal;
    else GetType:=false;
    end;
  inc(j,2);
  end;

  function Type2Char(_type:word):char;
  begin
  case _Type of
    zByte:Type2Char:='B';
    zInteger:Type2Char:='I';
    zReal:Type2Char:='R';
    end;
  end;


function FileOpen(HWindow:HWND;FileName:PChar;filter:PChar;read:boolean):boolean;
const
  DefExt = 'wav';
var
  OpenFN      : TOpenFileName;
  FullFileName: array[0..127] of Char;
  i:integer;
begin
  StrCopy(FullFileName, '');


  FillChar(OpenFN, SizeOf(TOpenFileName), #0);
  with OpenFN do
  begin
    hInstance     := HInstance;
    hwndOwner     := HWindow;
    lpstrDefExt   := DefExt;
    lpstrFile     := FileName;
    lpstrFilter   := Filter;
    lpstrFileTitle:= FileName;
    if read
    then flags    := ofn_FileMustExist
    else flags    := ofn_OverWritePrompt;
    lStructSize   := sizeof(TOpenFileName);
    nFilterIndex  := 1;       {Index into Filter String in lpstrFilter}
    nMaxFile      := SizeOf(FullFileName);
  end;
  if read
  then FileOpen:=GetOpenFileName(OpenFN)
  else FileOpen:=GetSaveFileName(OpenFN)
end;

procedure GetCTypeDlg(HWindow:HWnd;pStr:PChar);
begin
  if SendDlgItemMessage(HWindow, 107, bm_GetCheck, 0, 0) = 1
  then StrCopy(pStr,'B')
  else if SendDlgItemMessage(HWindow, 108, bm_GetCheck, 0, 0) = 1
       then StrCopy(pStr,'I')
       else StrCopy(pStr,'R')
end;

procedure SetCTypeDlg(HWindow:HWnd;ch:Char);
var ID:integer;
begin
  case ch of
    'B':ID:=107;
    'I':ID:=108;
    'R':ID:=109;
  end; (* of case *)
  SendDlgItemMessage(HWindow, ID, bm_SetCheck, 1, 0);
end;

procedure SetTypeDlg(HWindow:HWnd;FunctionType:integer);
var ID:integer;
begin
  case FunctionType of
    zByte:ID:=107;
    zInteger:ID:=108;
    zReal:ID:=109;
  end; (* of case *)
  SendDlgItemMessage(HWindow, ID, bm_SetCheck, 1, 0);
end;


function AllocArray(size:longint;arraytype:integer):THandle;
(*AP1: problemi con blocchi grandi(64K) *)
var tsize:longint;
begin
  case ArrayType of
     zByte:tsize:=size;
     zInteger:tsize:=size*sizeof(integer);
     zReal:tsize:=size*sizeof(real);
     end; (* of case *)
  if tsize < 65535
  then AllocArray:=GlobalAlloc(GHnd,tsize)
  else AllocArray:=0;
end;

  procedure ZeroInit(a:tiobuf;OwnType:integer);
  (* azzera a[i] usando come tipo di riferimento <OwnType>
  *)
  var i:longint;
  begin
  case OwnType of
    zByte: for i:=0 to a.size-1
           do ByteArray(a.buf^)[i]:=128;
    zInteger: for i:=0 to a.size-1
           do IntegerArray(a.buf^)[i]:=0;
    zReal: for i:=0 to a.size-1
           do RealArray(a.buf^)[i]:=0;
    end; (* of case *)
  end;

  procedure movebuf(a,b:tiobuf;start,offset,len:longint;ownType:integer);
  (* esegue a[i]:=b[i] partendo da <start> per <len> campioni
     usando come tipo di riferimento <OwnType>
  *)
  var i:longint;
  begin
  case OwnType of
    zByte: for i:=start to start+len-1
           do ByteArray(a.buf^)[i]:=ByteArray(b.buf^)[i+offset];
    zInteger: for i:=start to start+len-1
           do IntegerArray(a.buf^)[i]:=IntegerArray(b.buf^)[i+offset];
    zReal: for i:=start to start+len-1
           do RealArray(a.buf^)[i]:=RealArray(b.buf^)[i+offset];
    end; (* of case *)
  end;

  function square(i:longint;Period:longint;amplitude:real;prec:real):real;far;
  begin
    if (i mod Period) < Period div 2
    then square:=amplitude
    else square:=-amplitude;
  end;

  function triangle(i:longint;Period:longint;amplitude:real;prec:real):real;far;
  begin
    i:=i mod Period;
    if i < Period div 2
    then triangle:=amplitude*(4*i/Period-1)
    else triangle:=amplitude*(3-4*i/Period);
  end;

  function sine(i:longint;Period:longint;amplitude:real;prec:real):real;far;
  begin
    i:=i mod Period;
    sine:=amplitude*sin(i*2*Pi/Period)
  end;

  function noise(i:longint;Period:longint;amplitude:real;prec:real):real;far;
  begin
    if i mod Period = 0
    then noise:=(random*2-1)*amplitude
    else noise:=prec;
  end;

  function L2noise(i:longint;Period:longint;amplitude:real;prec:real):real;far;
  begin
    if i mod Period = 0
    then if random(2)=0
         then L2noise:=amplitude
         else L2noise:=-amplitude
    else L2noise:=prec;
  end;

  procedure MoveInteger(a,b:tiobuf;var IntGain:integer);
  (* ricalcola IntGain, esegue a[i]:=b[i] div IntGain *)
  var i:longint;
      max:integer;
  begin
    (* AUTOMATIC GAIN AMPLIFIER *)
    max:=0;
    for i:=0 to b.size-1
    do if abs(IntegerArray(b.buf^)[i]) > max
       then max:=abs(IntegerArray(b.buf^)[i]);
    if max div 128>=IntGain
    then IntGain:=max div 128+1;
    for i:=0 to b.size-1
    do ByteArray(a.buf^)[i]:=IntegerArray(b.buf^)[i]div IntGain+128;
  end;

  procedure MoveReal(a,b:tiobuf;var RealGain:real);
  (* ricalcola RealGain, esegue a[i]:=b[i]/RealGain
  *)
  var i:longint;
      max:real;
  begin
    max:=0;
    for i:=0 to b.size-1
    do if abs(RealArray(b.buf^)[i]) > max
       then max:=abs(RealArray(b.buf^)[i]);
    if max >= RealGain * 127
    then RealGain:=max / 127;
    if RealGain<>0
    then for i:=0 to b.size-1
         do ByteArray(a.buf^)[i]:=round(RealArray(b.buf^)[i]/RealGain)+128
    else for i:=0 to b.size-1
         do ByteArray(a.buf^)[i]:=128;

  end;

procedure GetNewOrigin(var x,y:integer);
var Rect:TRect;
    Wnd:HWnd;
begin
  Wnd:=GetDeskTopWindow;
  GetWindowRect(Wnd,Rect);
  x:=DeskX;
  y:=DeskY;
  inc(DeskX,128);
  if DeskX + 64 > Rect.right
  then begin
       DeskX:=0;
       inc(DeskY,64);
       end;
end;

function Rnd(m:real):real;far;
begin
  if m = 1
  then Rnd:=random
  else Rnd:=random(round(m));
end;


(* - - - - TBLOCK - - - - *)

constructor TBlock.Init(SystemP:pSystem;Num:integer);
begin
  PS:=SystemP;  (* 5555 *)
  BlockId:=Num;
  Param:='';
end;

destructor TBlock.Done;
begin
end;

procedure TBlock.SetDlg(HWindow:HWnd);
var testo:array[0..31]of char;
begin
  StrPCopy(Testo,Names[BlockID]);
  SetDlgItemText(HWindow, 103, Testo);
end;

function TBlock.GetDlgOk(HWindow:HWnd):boolean;
var  ErrStr:array[0..127]of char;
     st:string;
begin
  GetDlgOk:=True;
  GetDlg(HWindow,st);
  if st<>'' (* 4444 *)
  then if StoreParam(HWindow,st,ErrStr)
       then param:=st
       else begin
            GetDlgOk:=false;
            MessageBeep(MB_ICONEXCLAMATION);
            MessageBox(HWindow,ErrStr,'Error in parameter(s)',MB_ICONEXCLAMATION or MB_OK);
            end;
end;


procedure TBlock.Capability(var Attr:TAttrDev;var IOClass:TAIOClass);
var i:integer;
begin
  Attr:=zNone;
  for i:=1 to MaxTerminal
  do IOClass[i]:=zNone;
end;

procedure TBlock.GetDlg(HWindow:HWnd;var st:string);
begin
  st[0]:=#0; (*4444*)
end;

function TBlock.StoreParam(HWindow:HWnd;var st:string;ErrString:PChar):boolean;
begin
(*4444*)
  StoreParam:=true;
  ErrString[0]:=#0;
end;

procedure TBlock.Store(var st:string);
var  ErrStr:array[0..127]of char;
begin
(*4444*)
  Param:=st;               (* E' giusto ????? *)
  if StoreParam(0,st,ErrStr)
  then Param:=st               (* E' giusto ????? *)
  else (*if ErrStr[0] <> #0
       then*) MessageBox(0,ErrStr,'Store',MB_ICONEXCLAMATION or MB_OK);
end;

procedure TBlock.Retrieve(var st:string);
begin
  st:=Names[BlockID]+';'+Param(* 4444*);
end;

function TBlock.Check(var prop:AIOprop):integer;
begin
  Abstract;
end;

function TBlock.Start(var prop:AIOprop;bufsize:longint;HWindow:HWnd):integer;
(* <bufsize> = 0 significa che l'analisi e' del tipo <one-shot>,
   in questo caso l'oggetto deve allocare tutta la memoria necessaria
   all'elaborazione.*)
begin
  Abstract;
end;

procedure TBlock.Stop;
begin
end;

function TBlock.Transfer(var iop:aiobuf):integer;
(* <Transfer> = 0 indica che l'oggetto gestisce ulteriori dati *)
(* <Transfer> = 1 indica che l'oggetto ha terminato di gestire dati *)
begin
  Abstract;
end;

function TBlock.ProcessDlg(HWindow:HWnd;wParam:word):integer;
begin
  ProcessDlg:=0;
end;

procedure TBlock.GetBufSize(var bufsize:longint);
(* This procedure should be overriden only if special condition
   are applicable, e.g. FFT is block-oriented *)
(* NOTES:
   -  bufsize = 0 <-> no condition on value of bufsize
   -  return value must be greater or equal to given <bufsize>
*)
begin
end;


(* - - - - T1In1Out - - - *)
procedure T1In1Out.Capability(var Attr:TAttrDev;var IOClass:TAIOClass);
var i:integer;
begin
  TBlock.Capability(Attr,IOClass);
  IOClass[2]:=zInput;
  IOClass[8]:=zOutput;
end;

function T1In1Out.Check(var prop:AIOprop):integer;
begin
  if  (prop[2].attr and (zMaskComplex) <> zSimple)
  then begin
          Check:=5;
          exit;
       end;
  OwnType:=prop[2].attr and zMaskType; (* questa assegnazione si deve trovare *)
                                       (* in 'Check'. Da ci dipende l'oggetto*)
                                       (* TAcc                                *)
  Check:=0;
  prop[8]:=prop[2];
end;

function T1In1Out.Start(var prop:AIOprop;bufsize:longint;HWindow:HWnd):integer;
var result:integer;
begin
result:=Check(prop);
if result = 0
then begin
     ownsize:=bufsize;
(*AP6*)     MemHandle:=AllocArray(bufsize,OwnType);
     if MemHandle = 0
     then begin
          start:=4;
          exit;
          end;
     MemPtr:=GlobalLock(MemHandle);
     end;
Start:=result;
end;


procedure T1In1Out.Stop;
begin
if MemHandle <> 0
then begin
     GlobalUnLock(MemHandle);
     GlobalFree(MemHandle);
     end;
end;

(* template for an object derived from <T1In1Out>

BEGIN_TEMPLATE(TDerived)

function TDerived.Transfer(var iop:aiobuf):integer;

   procedure TransferByte(var input,output:tiobuf);
   var i:longint;
   begin
     for i:=0 to input.size - 1
     do ByteArray(output.buf^)[i]:=ByteArray(input.buf^)[i]
   end;

   procedure TransferInteger(var input,output:tiobuf);
   var i:longint;
   begin
     for i:=0 to input.size - 1
     do IntegerArray(output.buf^)[i]:=IntegerArray(input.buf^)[i]
   end;

   procedure TransferReal(var input,output:tiobuf);
   var i:longint;
   begin
     for i:=0 to input.size - 1
     do RealArray(output.buf^)[i]:=RealArray(input.buf^)[i]
   end;

begin
  Transfer:=0;
  with iop[8]
  do begin
       size:=iop[2].size;
       buf:=MemPtr;
       case OwnType of
         zByte:TransferByte(iop[2],iop[8]);
         zInteger:TransferInteger(iop[2],iop[8]);
         zReal:TransferReal(iop[2],iop[8]);
       end; 
     end;
end;

END_TEMPLATE(TDerived)
*)

(* - - - - TFileWave - - - - *)

function TFileWave.StoreParam(HWindow:HWnd;var st:string;ErrString:PChar):boolean;
var sub:string;j:integer;
begin
  StoreParam:=false;StrCopy(ErrString,BadFormat);
  j:=1;
  GetString(st,sub,j);inc(j);
  if length(sub) = 0   (*??????????????*)
  then begin
         StrCopy(ErrString,'Invalid or incompatible wave file');
         exit;
       end;
  StrPCopy(fn,sub);
  StoreParam:=true;
end;

procedure TFileWave.SetDlg(HWindow:HWnd); 
var  testo:array[0..31]of char;
     j:integer;
begin
  TBlock.SetDlg(HWindow);
  j:=1;
  GetPString(param,testo,j);inc(j);
  SetDlgItemText(HWindow, 104, testo);
end;

function TFileWave.ProcessDlg(HWindow:HWnd;wParam:word):integer;
var  Filter      : array [0..31] of Char;
     tempfn:TFilename;
begin
  if wParam=104
  then begin
       FillChar(Filter, SizeOf(Filter), #0);  { Set up for double null at end }
       StrCopy(Filter, 'Wave Files');
       StrCopy(@Filter[StrLen(Filter)+1], '*.wav');
       GetDlgItemText(HWindow, 104, tempfn, sizeof(tempfn));
       if FileOpen(HWindow,tempfn,Filter,read)
       then SetDlgItemText(HWindow, 104, tempfn);
       end;
  ProcessDlg:=0;
end;

procedure TFileWave.GetDlg(HWindow:HWnd;var st:string);
var  testo:array[0..127]of char;
begin
  GetDlgItemText(HWindow, 104, testo, sizeof(testo));
  st:=StrPas(testo);
end;

constructor TFileWave.Init(SystemP:pSystem;Num:integer;_read:boolean);
begin
  TBlock.Init(SystemP,Num);
  fn[0]:=#0;
  Param:='';
  read:=_read;
end;



(* - - - - TREADWAVE - - - - *)

procedure TReadWave.Capability(var Attr:TAttrDev;var IOClass:TAIOClass);
var i:integer;
begin
  TBlock.Capability(Attr,IOClass);
  IOClass[8]:=zOutput;
end;

function TReadWave.Check(var prop:AIOprop):integer;
var result:integer;
begin
  result:=OpenWave(f,fn,fsample,slength);
  if result = 0
  then _lclose(f);
  prop[8].fsample:=fsample;
  prop[8].attr:=zByte or zSimple or zSampled;
  check:=result;
end;


function TReadWave.Start(var prop:AIOprop;bufsize:longint;HWindow:HWnd):integer;
var result:integer;
begin
result:=OpenWave(f,fn,fsample,slength);
if result = 0
then begin
     prop[8].fsample:=fsample;
     prop[8].attr:=zByte or zSimple or zSampled;
     residual:=slength;
     if bufsize = 0
     then ownsize:=slength
     else ownsize:=bufsize;
     MemHandle:=GlobalAlloc(GHnd,ownsize);
     if MemHandle = 0
     then begin
          start:=4;
          _lclose(f);
          exit;
          end;
     MemPtr:=GlobalLock(MemHandle);
     end
else _lclose(f);
Start:=result;
end;

function TReadWave.Transfer(var iop:aiobuf):integer;
begin
  with iop[8]
  do begin
     if ownsize < residual
     then begin
          _LongRead(f,MemPtr,ownsize);
          size:=ownsize;
          dec(residual,ownsize);
          Transfer:=0;
          end
     else if residual<> 0
          then begin
               _LongRead(f,MemPtr,residual);
               size:=residual;
               residual:=0;
               Transfer:=1;
               end
          else begin
               size:=0;
               Transfer:=1;
               end;
     buf:=MemPtr;
     end;
end;

procedure TReadWave.Stop;
begin
if MemHandle <> 0
then begin
     GlobalUnLock(MemHandle);
     GlobalFree(MemHandle);
     end;
_lclose(f);
end;

constructor TReadWave.Init(SystemP:pSystem;Num:integer);
begin
  TFileWave.Init(SystemP,Num,true);
end;

(* - - - - TWriteWAVE - - - - *)

procedure TWriteWave.Capability(var Attr:TAttrDev;var IOClass:TAIOClass);
var i:integer;
begin
  TBlock.Capability(Attr,IOClass);
  IOClass[2]:=zInput;
end;

function TWriteWave.Check(var prop:AIOprop):integer;
begin
  if strlen(fn)=0
  then Check:=1
  else if prop[2].attr = zByte or zSimple or zSampled
       then Check:=0
       else Check:=5

end;

function TWriteWave.Start(var prop:AIOprop;bufsize:longint;HWindow:HWnd):integer;
var result:integer;
begin
  fsample:=prop[2].fsample;
  result:=Check(prop);
  if result <> 0
  then begin
       start:=result;
       exit;
       end;
  if bufsize > 65535
  then begin
       start:=4;
       exit;
       end;
  ownsize:=bufsize;
  if WriteHeader(f,fn,fsample,0) <> 0
  then begin
       start:=4;
       exit;
       end;
  start:=0;
  slength:=0;
end;

function TWriteWave.Transfer(var iop:aiobuf):integer;
begin
  Transfer:=0;
  with iop[2]
  do begin
     inc(slength,size);
     BlockWrite(f,buf^,size);
     end;
end;

procedure TWriteWave.Stop;
var flength:longint;
begin
     flength:=slength+36;
     Seek(f,4);
     blockwrite(f,flength,4);
     Seek(f,40);
     blockwrite(f,slength,4);
     Seek(f,filesize(f));
     Close(f);
end;

constructor TWriteWave.Init(SystemP:pSystem;Num:integer);
begin
  TFileWave.Init(SystemP,Num,false);
end;

(* - - - - TPlay - - - - *)

procedure TPlay.Capability(var Attr:TAttrDev;var IOClass:TAIOClass);
var i:integer;
begin
  TBlock.Capability(Attr,IOClass);
  IOClass[2]:=zInput;
end;

function TPlay.Check(var prop:AIOprop):integer;
begin
  InputType:=prop[2].attr and zMaskType;
  if  (prop[2].attr and (zMaskComplex or zMaskSampled) <> (zSimple or zSampled))
  then Check:=5
  else Check:=0;
end;

function TPlay.Start(var prop:AIOprop;bufsize:longint;HWindow:HWnd):integer;
var result:integer;
begin
  fsample:=prop[2].fsample;
  result:=Check(prop);
  if result <> 0
  then begin
       start:=result;
       exit;
       end;
  if bufsize > 65535
  then begin
       start:=4;
       exit;
       end;
  ownsize:=bufsize;
  ParentWnd:=HWindow;
  if InputType <> zByte
  then begin (* used for ACG *)
  (*AP6*)
       MemHandle:=AllocArray(bufsize,zByte);
       if MemHandle = 0
       then begin
            start:=4;
            exit;
            end;
       Mem.buf:=GlobalLock(MemHandle);
       Mem.size:=0;
       IntGain:=1;RealGain:=0;
       end
  else MemHandle:=0;
  GetTempFileName(GetTempDrive('C'),'LC',0,TempFile);
  if WriteHeader(f,TempFile,fsample,0) <> 0
  then begin
         Start:=4;
         exit;
       end;
  start:=0;
  slength:=0;
end;

function TPlay.Transfer(var iop:aiobuf):integer;
begin
  
  Transfer:=0;
  inc(slength,iop[2].size);
  case InputType of
    zByte:BlockWrite(f,iop[2].buf^,iop[2].size);
    zInteger:begin
             Mem.size:=iop[2].size;
             MoveInteger(Mem,iop[2],IntGain);
             BlockWrite(f,Mem.buf^,Mem.size);
             end;
    zReal:begin
          Mem.size:=iop[2].size;
          MoveReal(Mem,iop[2],RealGain);
          BlockWrite(f,Mem.buf^,Mem.size);
          end;
    end; (* of case *)
end;

procedure TPlay.Stop;
var res:integer;
    ErrMsg:array[0..255]of char;
begin
  Seek(f,40);
  blockwrite(f,slength,4);
  Seek(f,filesize(f));
  Close(f);
  Res:=PlayWave(ParentWnd,TempFile);
  if Res <> 0
  then begin
         mciGetErrorString(Res, ErrMsg, SizeOf(ErrMsg));
(* prova a riprodurre il file quando l'errore e' dovuto
   alla assenza di una periferica del tipo MCIWAVE *)
         if Res = mcierr_Wave_OutputsUnsuitable
         then sndPlaySound(TempFile,0);
         MessageBox(ParentWnd, ErrMsg, 'Play Wave', mb_OK);
       end;
  Erase(f);
  if MemHandle <> 0
  then begin
       GlobalUnLock(MemHandle);
       GlobalFree(MemHandle);
       end;
end;

(* - - - - TFunction - - - *)
procedure TFunction.Capability(var Attr:TAttrDev;var IOClass:TAIOClass);
var i:integer;
begin
  TBlock.Capability(Attr,IOClass);
  IOClass[8]:=zOutput;
end;

constructor TFunction.Init(SystemP:pSystem;Num:integer);
begin
  TBlock.Init(SystemP,Num);
  FunctionType:=zByte;
  funzione:='';(*????*)
  fsample:=1;
  slength:=1;
  pFx:=nil;
  Param:='B;;1;1';
end;

function TFunction.Check(var prop:AIOprop):integer;
begin
  prop[8].fsample:=fsample;
  prop[8].attr:=zSimple or FunctionType;
  if fsample <> 0
  then prop[8].attr:=zSimple or FunctionType or zSampled
  else prop[8].attr:=zSimple or FunctionType;
  if pFx=nil
  then Check:=1
  else Check:=0;
end;

function TFunction.Start(var prop:AIOprop;bufsize:longint;HWindow:HWnd):integer;
var result:integer;
begin
result:=Check(prop);
if result = 0
then begin
     residual:=slength;
     if bufsize = 0
     then ownsize:=slength
     else ownsize:=bufsize;
     MemHandle:=AllocArray(ownsize,FunctionType);
     if MemHandle = 0
     then begin
          start:=4;
          exit;
          end;
     MemPtr:=GlobalLock(MemHandle);
     end;
Start:=result;
end;

function TFunction.Transfer(var iop:aiobuf):integer;
var local_n,fs:real;
    AVar:array[0..1]of ^real;
  procedure xxx_byte(len:longint);
  var i:longint;
      fault:integer;
  begin
     local_n:=slength-residual;
     for i:=0 to len-1
     do begin
        ByteArray(MemPtr^)[i]:=128 + trunc(_value2(pFx,AVar,fault));
        local_n:=local_n+1;(*local_n is a real variable...*)
        end;

  end;

  procedure xxx_integer(len:longint);
  var i:longint;
      fault:integer;
  begin
     local_n:=slength-residual;
     for i:=0 to len-1
     do begin
        IntegerArray(MemPtr^)[i]:=trunc(_value2(pFx,AVar,fault));
        local_n:=local_n+1;(*local_n is a real variable...*)
        end;

  end;

  procedure xxx_real(len:longint);
  var i:longint;
      fault:integer;
  begin
     local_n:=slength-residual;
     for i:=0 to len-1
     do begin
        RealArray(MemPtr^)[i]:=_value2(pFx,AVar,fault);
        local_n:=local_n+1;(*local_n is a real variable...*)
        end;

  end;

begin
  with iop[8]
  do begin
     AVar[0]:=@local_n;
     fs:=fsample; (*longint-->real*)
     AVar[1]:=@fs;
     if ownsize < residual
     then begin
          case FunctionType of
            zByte:xxx_byte(ownsize);
            zInteger:xxx_integer(ownsize);
            zReal:xxx_real(ownsize);
            end; (* of case *)
          size:=ownsize;
          dec(residual,ownsize);
          Transfer:=0;
          end
     else if residual<> 0
          then begin
               case FunctionType of
                 zByte:xxx_byte(residual);
                 zInteger:xxx_integer(residual);
                 zReal:xxx_real(residual);
                 end; (* of case *)
               size:=residual;
               residual:=0;
               Transfer:=1;
               end
          else begin
               size:=0;
               Transfer:=1;
               end;
     buf:=MemPtr;
     end;
end;


procedure TFunction.Stop;
begin
if MemHandle <> 0
then begin
     GlobalUnLock(MemHandle);
     GlobalFree(MemHandle);
     end;
end;


procedure TFunction.SetDlg(HWindow:HWnd); 
var  testo:array[0..127]of char;
     j:integer;
begin
  TBlock.SetDlg(HWindow);
  j:=1;
  GetPString(param,testo,j);inc(j);
  SetCTypeDlg(HWindow,testo[0]);
  GetPString(param,testo,j);inc(j);
  SetDlgItemText(HWindow, 104, testo);
  GetPString(param,testo,j);inc(j);
  SetDlgItemText(HWindow,105,testo);
  GetPString(param,testo,j);inc(j);
  SetDlgItemText(HWindow,106,testo);
end;

procedure TFunction.GetDlg(HWindow:HWnd;var st:string);
var  testo:array[0..127]of char;
begin
  GetCTypeDlg(HWindow,testo);
  st:=StrPas(testo);
  GetDlgItemText(HWindow, 104, testo, sizeof(testo));
  st:=st+';'+StrPas(testo);
  GetDlgItemText(HWindow, 105, testo, sizeof(testo));
  st:=st+';'+StrPas(testo);
  GetDlgItemText(HWindow, 106, testo, sizeof(testo));
  st:=st+';'+StrPas(testo);
end;


destructor TFunction.Done;
begin
  TBlock.Done;
  if pFx<>nil
  then Clear(pFx);
end;

function TFunction.StoreParam(HWindow:HWnd;var st:string;ErrString:PChar):boolean;
var j:integer;
    err:error_info;
    _slength,_fsample:longint;
    _funzione:string;
    _functiontype:integer;
    _pfx:punt;
begin
  StoreParam:=false;StrCopy(ErrString,BadFormat);
  j:=1;
  GetType(st,j,_FunctionType);
  GetString(st,_funzione,j);inc(j);
  if not GetLValue(PS,st,j,_slength)then exit;inc(j);
  if not GetLValue(PS,st,j,_fsample)then exit;inc(j);
  if _slength <= 0
  then begin
       StrCopy(ErrString,'<nsamples> must be a positive integer');
       exit;
       end;
  if _fsample < 0
  then begin
       StrCopy(ErrString,'<fsample> must be a positive integer');
       exit;
       end;
  if funzione = _funzione
  then _pfx:=pFX
  else begin
       analizza2(_pFX,'real n,fs',_funzione,err);
       if err.no <> 0
       then begin
            if HWindow <> 0
            then SendDlgItemMessage(HWindow, 104, Em_SetSel, 0, MakeLong(err.pos,err.pos));
            StrPCopy(ErrString,error(err.no));
            exit;
            end;
       end;
  funzione:=_funzione;
  slength:=_slength;
  pFX:=_pfx;
  functionType:=_FunctionType;
  fsample:=_fsample;
  StoreParam:=true;
end;

(* - - - - TFunctionX - - - *)
procedure TFunctionX.Capability(var Attr:TAttrDev;var IOClass:TAIOClass);
var i:integer;
begin
  TBlock.Capability(Attr,IOClass);
  IOClass[2]:=zInput;
  IOClass[8]:=zOutput;
end;

constructor TFunctionX.Init(SystemP:pSystem;Num:integer);
begin
  TBlock.Init(SystemP,Num);
  functionType:=zByte; (* CORR 05-94 *)
  funzione:='';
  pFx:=nil;
  Param:='B;';
end;

function TFunctionX.Check(var prop:AIOprop):integer;
begin
  FunctionType:=prop[2].attr and zMaskType;
  if  (prop[2].attr and (zMaskComplex) <> zSimple)
  then begin
          Check:=5;
          exit;
       end;
  if pFx=nil
  then Check:=1
  else Check:=0;
  prop[8]:=prop[2];
end;

function TFunctionX.Start(var prop:AIOprop;bufsize:longint;HWindow:HWnd):integer;
var result:integer;
begin
result:=Check(prop);
if result = 0
then begin
     ownsize:=bufsize;
(*AP6*)     MemHandle:=AllocArray(bufsize,FunctionType);
     if MemHandle = 0
     then begin
          start:=4;
          exit;
          end;
     MemPtr:=GlobalLock(MemHandle);
     Local_n:=0;fs:=prop[2].fsample;
     end;
Start:=result;
end;

function TFunctionX.Transfer(var iop:aiobuf):integer;
var x:real;
    AVar:array[0..2]of ^real;
  procedure xxx_byte(a:tiobuf);
  var i:longint;
      fault:integer;
  begin
     for i:=0 to a.size-1
     do begin
        x:=ByteArray(a.buf^)[i]-128;
        ByteArray(MemPtr^)[i]:=128 + trunc(_value2(pFx,AVar,fault));
        local_n:=local_n+1;(*local_n is a real variable...*)
        end;

  end;

  procedure xxx_integer(a:tiobuf);
  var i:longint;
      fault:integer;
  begin
     for i:=0 to a.size-1
     do begin
        x:=IntegerArray(a.buf^)[i];
        IntegerArray(MemPtr^)[i]:=trunc(_value2(pFx,AVar,fault));
        local_n:=local_n+1;(*local_n is a real variable...*)
        end;

  end;

  procedure xxx_real(a:tiobuf);
  var i:longint;
      fault:integer;
  begin
     for i:=0 to a.size-1
     do begin
        x:=RealArray(a.buf^)[i];
        RealArray(MemPtr^)[i]:=_value2(pFx,AVar,fault);
        local_n:=local_n+1;(*local_n is a real variable...*)
        end;

  end;

begin
  Transfer:=0;
  with iop[8]
  do begin
     AVar[0]:=@local_n;
     AVar[1]:=@fs;
     AVar[2]:=@x;
     case FunctionType of
       zByte:xxx_byte(iop[2]);
       zInteger:xxx_integer(iop[2]);
       zReal:xxx_real(iop[2]);
       end; (* of case *)
     size:=iop[2].size;
     buf:=MemPtr;
     end;
end;


procedure TFunctionX.Stop;
begin
if MemHandle <> 0
then begin
     GlobalUnLock(MemHandle);
     GlobalFree(MemHandle);
     end;
end;


procedure TFunctionX.SetDlg(HWindow:HWnd);
var  testo:array[0..127]of char;
     j:integer;
begin
  TBlock.SetDlg(HWindow);
  j:=1;
  GetPString(param,testo,j);inc(j);
  GetPString(param,testo,j);inc(j);
  SetDlgItemText(HWindow, 104, testo);
end;

procedure TFunctionX.GetDlg(HWindow:HWnd;var st:string);
var  testo:array[0..127]of char;
begin
  GetDlgItemText(HWindow, 104, testo, sizeof(testo));
  st:=Type2Char(functionType)+';'+StrPas(testo);
end;

destructor TFunctionX.Done;
begin
  TBlock.Done;
  if pFx<>nil
  then Clear(pFx);
end;

function TFunctionX.StoreParam(HWindow:HWnd;var st:string;ErrString:PChar):boolean;
var j:integer;
    err:error_info;
    _funzione:string;
    _functiontype:integer;
    _pfx:punt;
begin
  StoreParam:=false;StrCopy(ErrString,BadFormat);
  j:=1;
  GetType(st,j,_FunctionType);
  GetString(st,_funzione,j);inc(j);
  if funzione = _funzione
  then _pfx:=pFX
  else begin
       analizza2(_pFX,'real n,fs,x',_funzione,err);
       if err.no <> 0
       then begin
            if HWindow <> 0
            then SendDlgItemMessage(HWindow, 104, Em_SetSel, 0, MakeLong(err.pos,err.pos));
            StrPCopy(ErrString,error(err.no));
            exit;
            end;
       end;
  funzione:=_funzione;
  pFX:=_pfx;
  StoreParam:=true;
end;



(* - - - - TFunctionXY - - - *)
procedure TFunctionXY.Capability(var Attr:TAttrDev;var IOClass:TAIOClass);
var i:integer;
begin
  TBlock.Capability(Attr,IOClass);
  IOClass[1]:=zInput;
  IOClass[3]:=zInput;
  IOClass[8]:=zOutput;
end;

constructor TFunctionXY.Init(SystemP:pSystem;Num:integer);
begin
  TBlock.Init(SystemP,Num);
  funzione:='';
  functionType:=zByte; (* CORR 05-94 *)
  pFx:=nil;
  Param:='B;';
end;

function TFunctionXY.Check(var prop:AIOprop):integer;
begin
  FunctionType:=prop[1].attr and zMaskType;
  if (prop[1].attr <> prop[3].attr)or(prop[1].attr and (zMaskComplex) <> zSimple)
     then begin
          Check:=5;
          exit;
          end;
  if pFX=nil
  then Check:=1
  else Check:=0;
  prop[8]:=prop[1];
end;

function TFunctionXY.Start(var prop:AIOprop;bufsize:longint;HWindow:HWnd):integer;
var result:integer;
begin
result:=Check(prop);
if result = 0
then begin
     ownsize:=bufsize;
(*AP6*)     MemHandle:=AllocArray(bufsize,FunctionType);
     if MemHandle = 0
     then begin
          start:=4;
          exit;
          end;
     MemPtr:=GlobalLock(MemHandle);
     Local_n:=0;fs:=prop[1].fsample;
     end;
Start:=result;
end;

function TFunctionXY.Transfer(var iop:aiobuf):integer;
var x,y:real;
    AVar:array[0..3]of ^real;

  function shortest(var iop:aiobuf):longint;
  var size:longint;
      i:integer;
  begin
    size:=iop[1].size;
    if iop[3].size < size
    then size:=iop[3].size;
    shortest:=size;
  end;

  procedure xxx_byte(a,b,c:tiobuf);
  var i:longint;
      fault:integer;
  begin
     for i:=0 to a.size-1
     do begin
        x:=ByteArray(b.buf^)[i]-128;
        y:=ByteArray(c.buf^)[i]-128;
        ByteArray(a.buf^)[i]:=128 + trunc(_value2(pFx,AVar,fault));
        local_n:=local_n+1;(*local_n is a real variable...*)
        end;

  end;

  procedure xxx_integer(a,b,c:tiobuf);
  var i:longint;
      fault:integer;
  begin
     for i:=0 to a.size-1
     do begin
        x:=IntegerArray(b.buf^)[i];
        y:=IntegerArray(c.buf^)[i];
        IntegerArray(a.buf^)[i]:=trunc(_value2(pFx,AVar,fault));
        local_n:=local_n+1;(*local_n is a real variable...*)
        end;

  end;

  procedure xxx_real(a,b,c:tiobuf);
  var i:longint;
      fault:integer;
  begin
     for i:=0 to a.size-1
     do begin
        x:=RealArray(b.buf^)[i];
        y:=RealArray(c.buf^)[i];
        RealArray(a.buf^)[i]:=_value2(pFx,AVar,fault);
        local_n:=local_n+1;(*local_n is a real variable...*)
        end;

  end;

begin
  Transfer:=0;
  with iop[8]
  do begin
     AVar[0]:=@local_n;
     AVar[1]:=@fs;
     AVar[2]:=@x;
     AVar[3]:=@y;
     size:=shortest(iop);
     buf:=MemPtr;
     case FunctionType of
       zByte:xxx_byte(iop[8],iop[1],iop[3]);
       zInteger:xxx_integer(iop[8],iop[1],iop[3]);
       zReal:xxx_real(iop[8],iop[1],iop[3]);
       end; (* of case *)
     end;
end;


procedure TFunctionXY.Stop;
begin
if MemHandle <> 0
then begin
     GlobalUnLock(MemHandle);
     GlobalFree(MemHandle);
     end;
end;


procedure TFunctionXY.SetDlg(HWindow:HWnd);
var  testo:array[0..127]of char;
     j:integer;
begin
  TBlock.SetDlg(HWindow);
  j:=1;
  GetPString(param,testo,j);inc(j);
  GetPString(param,testo,j);inc(j);
  SetDlgItemText(HWindow, 104, testo);
end;

procedure TFunctionXY.GetDlg(HWindow:HWnd;var st:string);
var  testo:array[0..127]of char;
begin
  GetDlgItemText(HWindow, 104, testo, sizeof(testo));
  st:=Type2Char(functionType)+';'+StrPas(testo);
end;


destructor TFunctionXY.Done;
begin
  TBlock.Done;
  if pFx<>nil
  then Clear(pFx);
end;

function TFunctionXY.StoreParam(HWindow:HWnd;var st:string;ErrString:PChar):boolean;
var j:integer;
    err:error_info;
    _funzione:string;
    _functiontype:integer;
    _pfx:punt;
begin
  StoreParam:=false;StrCopy(ErrString,BadFormat);
  j:=1;
  GetType(st,j,_FunctionType);
  GetString(st,_funzione,j);inc(j);
  if funzione = _funzione
  then _pfx:=pFX
  else begin
       analizza2(_pFX,'real n,fs,x,y',_funzione,err);
       if err.no <> 0
       then begin
            if HWindow <> 0
            then SendDlgItemMessage(HWindow, 104, Em_SetSel, 0, MakeLong(err.pos,err.pos));
            StrPCopy(ErrString,error(err.no));
            exit;
            end;
       end;
  funzione:=_funzione;
  pFX:=_pfx;
  StoreParam:=true;
end;


(* - - - - tGenerator - - - *)
const zSquare=1;zTriangle=2;zSine=3;zNoise=4;zL2Noise=5; (* <funzione> *)
type tFunGen=function(i:longint;Period:longint;amplitude:real;prec:real):real;

const FunGen:array[zSquare..zL2Noise]of tFunGen=(square,triangle,sine,noise,l2noise);

procedure tGenerator.Capability(var Attr:TAttrDev;var IOClass:TAIOClass);
var i:integer;
begin
  TBlock.Capability(Attr,IOClass);
  IOClass[8]:=zOutput;
end;

constructor tGenerator.Init(SystemP:pSystem;Num:integer);
begin
  TBlock.Init(SystemP,Num);
  FunctionType:=zByte;
  funzione:=zSquare;
  amplitude:=127;
  fsample:=1;
  slength:=1;
  period:=1;
  Param:='B;1;1;127;1;1';
end;

function tGenerator.Check(var prop:AIOprop):integer;
begin
  prop[8].fsample:=fsample;
  prop[8].attr:=zSimple or FunctionType or zSampled;
  if period = 0
  then Check:=1
  else Check:=0;
end;

function tGenerator.Start(var prop:AIOprop;bufsize:longint;HWindow:HWnd):integer;
var result:integer;
begin
result:=Check(prop);
if result = 0
then begin
     residual:=slength;
     if bufsize = 0
     then ownsize:=slength
     else ownsize:=bufsize;
     MemHandle:=AllocArray(ownsize,FunctionType);
     if MemHandle = 0
     then begin
          start:=4;
          exit;
          end;
     MemPtr:=GlobalLock(MemHandle);
     prec:=0;
     end;
Start:=result;
end;

function tGenerator.Transfer(var iop:aiobuf):integer;
var n:longint;

  procedure xxx_byte(len:longint);
  var i:longint;
  begin
     n:=slength-residual;
     for i:=0 to len-1
     do begin
        prec:=FunGen[funzione](i+n,Period,Amplitude,prec);
        ByteArray(MemPtr^)[i]:=128 + round(prec);
        end;

  end;

  procedure xxx_integer(len:longint);
  var i:longint;
  begin
     n:=slength-residual;
     for i:=0 to len-1
     do begin
        prec:=FunGen[funzione](i+n,Period,Amplitude,prec);
        IntegerArray(MemPtr^)[i]:=round(prec);
        end;

  end;

  procedure xxx_real(len:longint);
  var i:longint;
  begin
     n:=slength-residual;
     for i:=0 to len-1
     do begin
        prec:=FunGen[funzione](i+n,Period,Amplitude,prec);
        RealArray(MemPtr^)[i]:=prec;
        end;

  end;

begin
  with iop[8]
  do begin
     if ownsize < residual
     then begin
          case FunctionType of
            zByte:xxx_byte(ownsize);
            zInteger:xxx_integer(ownsize);
            zReal:xxx_real(ownsize);
            end; (* of case *)
          size:=ownsize;
          dec(residual,ownsize);
          Transfer:=0;
          end
     else if residual<> 0
          then begin
               case FunctionType of
                 zByte:xxx_byte(residual);
                 zInteger:xxx_integer(residual);
                 zReal:xxx_real(residual);
                 end; (* of case *)
               size:=residual;
               residual:=0;
               Transfer:=1;
               end
          else begin
               size:=0;
               Transfer:=1;
               end;
     buf:=MemPtr;
     end;
end;


procedure tGenerator.Stop;
begin
if MemHandle <> 0
then begin
     GlobalUnLock(MemHandle);
     GlobalFree(MemHandle);
     end;
end;


procedure tGenerator.SetDlg(HWindow:HWnd);
var  testo:array[0..127]of char;
     j:integer;fun,code:integer;
begin
  TBlock.SetDlg(HWindow);
  j:=1;
  GetPString(param,testo,j);inc(j);
  SetCTypeDlg(HWindow,testo[0]);
  GetPString(param,testo,j);inc(j);
  Val(testo,fun,code);
  SendDlgItemMessage(HWindow, 111+fun, bm_SetCheck, 1, 0);
  GetPString(param,testo,j);inc(j);
  SetDlgItemText(HWindow, 104, testo);
  GetPString(param,testo,j);inc(j);
  SetDlgItemText(HWindow,110,testo);
  GetPString(param,testo,j);inc(j);
  SetDlgItemText(HWindow,105,testo);
  GetPString(param,testo,j);inc(j);
  SetDlgItemText(HWindow,106,testo);
end;

procedure tGenerator.GetDlg(HWindow:HWnd;var st:string);
var  testo:array[0..127]of char;
     _funzione:integer;
begin
  GetCTypeDlg(HWindow,testo);
  st:=StrPas(testo);
  if SendDlgItemMessage(HWindow, 112, bm_GetCheck, 0, 0) = 1
  then _funzione:=zSquare
  else if SendDlgItemMessage(HWindow, 113, bm_GetCheck, 0, 0) = 1
       then _funzione:=zTriangle
       else if SendDlgItemMessage(HWindow, 114, bm_GetCheck, 0, 0) = 1
            then _funzione:=zSine
            else if SendDlgItemMessage(HWindow, 115, bm_GetCheck, 0, 0) = 1
                 then _funzione:=zNoise
                 else _funzione:=zL2Noise;
  Str(_funzione,testo);
  st:=st+';'+StrPas(testo);
  GetDlgItemText(HWindow, 104, testo, sizeof(testo));
  st:=st+';'+StrPas(testo);
  GetDlgItemText(HWindow, 110, testo, sizeof(testo));
  st:=st+';'+StrPas(testo);
  GetDlgItemText(HWindow, 105, testo, sizeof(testo));
  st:=st+';'+StrPas(testo);
  GetDlgItemText(HWindow, 106, testo, sizeof(testo));
  st:=st+';'+StrPas(testo);
end;

function tGenerator.StoreParam(HWindow:HWnd;var st:string;ErrString:PChar):boolean;
var j:integer;
     _slength,_fsample,_period:longint;
     _amplitude:real;
     _funzione,_FunctionType:integer;
begin
  StoreParam:=false;StrCopy(ErrString,BadFormat);
  j:=1;
  GetType(st,j,_FunctionType);
  if not GetIValue(PS,st,j,_funzione)then exit;inc(j);
  if not GetLValue(PS,st,j,_period)then exit;inc(j);
  if not GetRValue(PS,st,j,_amplitude)then exit;inc(j);
  if not GetLValue(PS,st,j,_slength)then exit;inc(j);
  if not GetLValue(PS,st,j,_fsample)then exit;inc(j);
  if _amplitude <= 0
  then begin
       StrCopy(ErrString,'<amplitude> must be a positive real');
       exit;
       end;
  if _fsample <= 0
  then begin
       StrCopy(ErrString,'<fsample> must be a positive integer');
       exit;
       end;
  if _slength <= 0
  then begin
       StrCopy(ErrString,'<nsamples> must be a positive integer');
       exit;
       end;
  if _period <= 0
  then begin
       StrCopy(ErrString,'<period> must be a positive integer');
       exit;
       end;
  amplitude:=_amplitude;
  slength:=_slength;
  period:=_period;
  fsample:=_fsample;
  functionType:=_functiontype;
  funzione:=_funzione;
  StoreParam:=true;
end;


(* - - - - TSum - - - - *)
const zAddition=1; zSubtraction=2;

constructor TSum.Init(SystemP:pSystem;Num:integer);
begin
  TBlock.Init(SystemP,Num);
  operation:=zAddition;
  Param:='1';
end;

procedure TSum.Capability(var Attr:TAttrDev;var IOClass:TAIOClass);
var i:integer;
begin
  TBlock.Capability(Attr,IOClass);
  IOClass[1]:=zInput;
  IOClass[3]:=zInput;
  IOClass[8]:=zOutput;
end;

function TSum.Check(var prop:AIOprop):integer;
var i:integer;
begin
  SumType:=prop[1].attr and zMaskType;
  if (prop[1].attr <> prop[3].attr)
     then begin
          Check:=5;
          exit;
          end;
  Check:=0;
  prop[8]:=prop[1];
end;

function TSum.Start(var prop:AIOprop;bufsize:longint;HWindow:HWnd):integer;
var result:integer;
begin
  result:=Check(prop);
  if result = 0
  then begin
(*AP6*)MemHandle:=AllocArray(bufsize,SumType);
       if MemHandle = 0
       then begin
            start:=4;
            exit;
            end;
       MemPtr:=GlobalLock(MemHandle);
       end;
  Start:=result;
end;

function TSum.Transfer(var iop:aiobuf):integer;
  function shortest(var iop:aiobuf):longint;
  var size:longint;
      i:integer;
  begin
    size:=iop[1].size;
    if iop[3].size < size
    then size:=iop[3].size;
    shortest:=size;
  end;

  procedure xxx_byte(len:longint);
  var i:longint;
  begin
     if operation=zAddition
     then for i:=0 to len-1
          do ByteArray(MemPtr^)[i]:=ByteArray(iop[1].buf^)[i]+ByteArray(iop[3].buf^)[i]-128
     else for i:=0 to len-1
          do ByteArray(MemPtr^)[i]:=ByteArray(iop[1].buf^)[i]-ByteArray(iop[3].buf^)[i]+128;
  end;

  procedure xxx_integer(len:longint);
  var i:longint;
  begin
     if operation=zAddition
     then for i:=0 to len-1
          do IntegerArray(MemPtr^)[i]:=IntegerArray(iop[1].buf^)[i]+IntegerArray(iop[3].buf^)[i]
     else for i:=0 to len-1
          do IntegerArray(MemPtr^)[i]:=IntegerArray(iop[1].buf^)[i]-IntegerArray(iop[3].buf^)[i];
  end;

  procedure xxx_real(len:longint);
  var i:longint;
  begin
     if operation=zAddition
     then for i:=0 to len-1
          do RealArray(MemPtr^)[i]:=RealArray(iop[1].buf^)[i]+RealArray(iop[3].buf^)[i]
     else for i:=0 to len-1
          do RealArray(MemPtr^)[i]:=RealArray(iop[1].buf^)[i]-RealArray(iop[3].buf^)[i];
  end;

begin
  Transfer:=0;
  iop[8].buf:=MemPtr;
  iop[8].size:=shortest(iop);
  case SumType of
    zByte:xxx_byte(Shortest(iop));
    zInteger:xxx_integer(Shortest(iop));
    zReal:xxx_real(Shortest(iop));
    end; (* of case *)
end;


procedure TSum.Stop;
begin
if MemHandle <> 0
then begin
     GlobalUnLock(MemHandle);
     GlobalFree(MemHandle);
     end;
end;

procedure TSum.SetDlg(HWindow:HWnd); { AP13 }
(* id-list:       115: title
*)
var  testo:array[0..127]of char;
     j:integer;
     ID:integer;
begin
  TBlock.SetDlg(HWindow);
  j:=1;
  GetPString(param,testo,j);inc(j);
  case ord(testo[0])-ord('0') of
    zAddition:ID:=107;
    zSubtraction:ID:=108;
  end; (* of case *)
  SendDlgItemMessage(HWindow, ID, bm_SetCheck, 1, 0);
end;

procedure TSum.GetDlg(HWindow:HWnd;var st:string);
var _operation:integer;
begin
  if SendDlgItemMessage(HWindow, 107, bm_GetCheck, 0, 0) = 1
  then _operation:=zAddition
  else _operation:=zSubtraction;
  Str(_operation,st); 
end;

function TSum.StoreParam(HWindow:HWnd;var st:string;ErrString:PChar):boolean;
var j:integer;
begin
  StoreParam:=false;StrCopy(ErrString,BadFormat);
  j:=1;
  if not GetIValue(PS,st,j,operation)then exit;inc(j);
  StoreParam:=true;
end;

(* - - - - TProd - - - - *)

procedure TProd.Capability(var Attr:TAttrDev;var IOClass:TAIOClass);
var i:integer;
begin
  TBlock.Capability(Attr,IOClass);
  IOClass[1]:=zInput;
  IOClass[3]:=zInput;
  IOClass[8]:=zOutput;
end;

function TProd.Check(var prop:AIOprop):integer;
var i:integer;
begin
  if (prop[1].attr <> prop[3].attr)
     then begin
          Check:=5;
          exit;
          end;
  InputType:=prop[1].attr and zMaskType;
  if InputType = zByte
  then ProdType:=zInteger
  else ProdType:=InputType;
  Check:=0;
  prop[8].attr:=prop[1].attr and not zMaskType or Prodtype;
  prop[8].fsample:=prop[1].fsample;
end;

function TProd.Start(var prop:AIOprop;bufsize:longint;HWindow:HWnd):integer;
var result:integer;
begin
  result:=Check(prop);
  if result = 0
  then begin
(*AP6*)MemHandle:=AllocArray(bufsize,ProdType);
       if MemHandle = 0
       then begin
            start:=4;
            exit;
            end;
       MemPtr:=GlobalLock(MemHandle);
       end;
  Start:=result;
end;

function TProd.Transfer(var iop:aiobuf):integer;
  function shortest(var iop:aiobuf):longint;
  var size:longint;
      i:integer;
  begin
    size:=iop[1].size;
    if iop[3].size < size
    then size:=iop[3].size;
    shortest:=size;
  end;

  procedure xxx_byte(len:longint);
  var i:longint;
      ris:integer;
  begin
     for i:=0 to len-1
     do begin
        ris:=(ByteArray(iop[1].buf^)[i]-128)*(ByteArray(iop[3].buf^)[i]-128);
        IntegerArray(MemPtr^)[i]:=ris;
        end;
  end;

  procedure xxx_integer(len:longint);
  var i:longint;
      ris:longint;
  begin
     for i:=0 to len-1
     do begin
        ris:=IntegerArray(iop[1].buf^)[i]*IntegerArray(iop[3].buf^)[i];
        if ris > 32767
        then ris:=32767
        else if ris < -32767
             then ris:= -32767;
        IntegerArray(MemPtr^)[i]:=ris;
        end;

  end;
  procedure xxx_real(len:longint);
  var i:longint;
  begin
     for i:=0 to len-1
     do begin
        RealArray(MemPtr^)[i]:=RealArray(iop[1].buf^)[i]*
                          RealArray(iop[3].buf^)[i];
        end;

  end;

begin
  Transfer:=0;
  iop[8].buf:=MemPtr;
  iop[8].size:=shortest(iop);
  case InputType of
    zByte:xxx_byte(Shortest(iop));
    zInteger:xxx_integer(Shortest(iop));
    zReal:xxx_real(Shortest(iop));
    end; (* of case *)
end;


procedure TProd.Stop;
begin
if MemHandle <> 0
then begin
     GlobalUnLock(MemHandle);
     GlobalFree(MemHandle);
     end;
end;

(* - - - - tbfilter - - - - *)

constructor tbfilter.Init(SystemP:pSystem;Num:integer);
begin
  TBlock.Init(SystemP,Num);
  filterp:=nil;
  Param:='';
end;

procedure tbfilter.Capability(var Attr:TAttrDev;var IOClass:TAIOClass);
var i:integer;
begin
  TBlock.Capability(Attr,IOClass);
  IOClass[2]:=zInput;
  IOClass[8]:=zOutput;
end;

function tbfilter.Check(var prop:AIOprop):integer;
var i:integer;
begin
  if filterp=nil
  then Check:=1
  else
       if prop[2].attr=zReal or zSimple or zSampled
       then Check:=0
       else Check:=5;
  prop[8]:=prop[2];
end;

function tbfilter.Start(var prop:AIOprop;bufsize:longint;HWindow:HWnd):integer;
var result:integer;
begin
  result:=Check(prop);
  if result = 0
  then begin
(*AP6*)MemHandle:=AllocArray(bufsize,zReal);
       if MemHandle = 0
       then begin
            start:=4;
            exit;
            end;
       MemPtr:=GlobalLock(MemHandle);
       filterp^.Reset;
       end;
  Start:=result;
end;

function TBFilter.Transfer(var iop:aiobuf):integer;
begin
  Transfer:=0;
  iop[8].buf:=MemPtr;
  iop[8].size:=iop[2].size;
  filterp^.ExecFilter(iop[2],iop[8]);
end;


procedure tbfilter.Stop;
begin
if MemHandle <> 0
then begin
     GlobalUnLock(MemHandle);
     GlobalFree(MemHandle);
     end;
end;

procedure tbfilter.SetDlg(HWindow:HWnd); { AP13 }
begin
  TBlock.SetDlg(HWindow);
  SetUpFilterDialog(HWindow,111,filterp);
end;



procedure tbfilter.GetDlg(HWindow:HWnd;var st:string);
begin
  GetFilterDlg(HWindow,111,st);
end;

function tbFilter.StoreParam(HWindow:HWnd;var st:string;ErrString:PChar):boolean;
var sub:string;j:integer;
    code:integer;
begin
  StoreParam:=StoreFilterParam(PS,filterp,HWindow,st,Errstring);
end;

(* - - - - TTConv - - - - *)

constructor TTConv.Init(SystemP:pSystem;Num:integer);
begin
  TBlock.Init(SystemP,Num);
  FunctionType:=zByte;
  Param:='B';
end;

procedure TTConv.Capability(var Attr:TAttrDev;var IOClass:TAIOClass);
var i:integer;
begin
  TBlock.Capability(Attr,IOClass);
  IOClass[2]:=zInput;
  IOClass[8]:=zOutput;
end;

function TTConv.Check(var prop:AIOprop):integer;
var i:integer;
begin
  if prop[2].attr and zMaskComplex=zSimple
  then Check:=0
  else Check:=5;
  prop[8].fsample:=prop[2].fsample;
  prop[8].attr:=prop[2].attr and (not zMaskType) or FunctionType;
end;

function TTConv.Start(var prop:AIOprop;bufsize:longint;HWindow:HWnd):integer;
var result:integer;
begin
  result:=Check(prop);
  if result = 0
  then begin
       InputType:=prop[2].attr and zMaskType;
(*AP6*)MemHandle:=AllocArray(bufsize,FunctionType);
       if MemHandle = 0
       then begin
            start:=4;
            exit;
            end;
       MemPtr:=GlobalLock(MemHandle);
       end;
  Start:=result;
end;

function TTConv.Transfer(var iop:aiobuf):integer;
  procedure xxx_byte;
  var i:longint;
      ris:integer;
  begin
     for i:=0 to iop[2].size-1
     do begin
(*  AP4: ottimizzare la conversione di tipo *)
        case InputType of
          zByte:ris:=ByteArray(iop[2].buf^)[i]-128;
          zInteger:ris:=IntegerArray(iop[2].buf^)[i];
          zReal:ris:=Round(RealArray(iop[2].buf^)[i]);
          end;
        if ris > 127
        then ris:=127
        else if ris < -127
             then ris:= -127;
        ByteArray(MemPtr^)[i]:=ris+128;
        end;

  end;
  procedure xxx_integer;
  var i:longint;
      ris:longint;
  begin
     for i:=0 to iop[2].size-1
     do begin
(*  AP4: ottimizzare la conversione di tipo *)
        case InputType of
          zByte:ris:=ByteArray(iop[2].buf^)[i]-128;
          zInteger:ris:=IntegerArray(iop[2].buf^)[i];
          zReal:ris:=Round(RealArray(iop[2].buf^)[i]);
          end;
        if ris > 32767
        then ris:=32767
        else if ris < -32767
             then ris:= -32767;
        IntegerArray(MemPtr^)[i]:=ris;
        end;

  end;
  procedure xxx_real;
  var i:longint;
      ris:real;
  begin
     for i:=0 to iop[2].size-1
     do begin
(*  AP4: ottimizzare la conversione di tipo *)
        case InputType of
          zByte:ris:=ByteArray(iop[2].buf^)[i]-128;
          zInteger:ris:=IntegerArray(iop[2].buf^)[i];
          zReal:ris:=RealArray(iop[2].buf^)[i];
          end;
        RealArray(MemPtr^)[i]:=ris;
        end;

  end;

begin
  Transfer:=0;
  iop[8].buf:=MemPtr;
  iop[8].size:=iop[2].size;
  case FunctionType of
    zByte:xxx_byte;
    zInteger:xxx_integer;
    zReal:xxx_real;
    end; (* of case *)
end;


procedure TTConv.Stop;
begin
if MemHandle <> 0
then begin
     GlobalUnLock(MemHandle);
     GlobalFree(MemHandle);
     end;
end;

function TTConv.StoreParam(HWindow:HWnd;var st:string;ErrString:PChar):boolean;
var j:integer;
begin
  j:=1;
  GetType(st,j,FunctionType);
  StoreParam:=true;
end;

procedure TTConv.GetDlg(HWindow:HWnd;var st:string);
var  testo:array[0..127]of char;
begin
  GetCTypeDlg(HWindow,testo);
  st:=StrPas(testo);
end;

procedure TTConv.SetDlg(HWindow:HWnd);
var  testo:array[0..31]of char;
     j:integer;
begin
  TBlock.SetDlg(HWindow);
  j:=1;
  GetPString(param,testo,j);inc(j);
  SetCTypeDlg(HWindow,testo[0]);
end;

(* - - - - TCompare - - - - *)

constructor TCompare.Init(SystemP:pSystem;Num:integer);
begin
  TBlock.Init(SystemP,Num);
  FunctionType:=zByte;
  upper:=1;
  lower:=-1;
  high:=1;
  low:=-1;
  Param:='B;-1.0000;1.0000;-1.0000;1.0000';
end;

procedure TCompare.Capability(var Attr:TAttrDev;var IOClass:TAIOClass);
var i:integer;
begin
  TBlock.Capability(Attr,IOClass);
  IOClass[2]:=zInput;
  IOClass[8]:=zOutput;
end;

function TCompare.Check(var prop:AIOprop):integer;
var i:integer;
begin
  if prop[2].attr and zMaskComplex=zSimple
  then Check:=0
  else Check:=5;
  prop[8].fsample:=prop[2].fsample;
  prop[8].attr:=prop[2].attr and (not zMaskType) or FunctionType;
end;

function TCompare.Start(var prop:AIOprop;bufsize:longint;HWindow:HWnd):integer;
var result:integer;
begin
  result:=Check(prop);
  if result = 0
  then begin
       InputType:=prop[2].attr and zMaskType;
(*AP6*)MemHandle:=AllocArray(bufsize,FunctionType);
       if MemHandle = 0
       then begin
            start:=4;
            exit;
            end;
       MemPtr:=GlobalLock(MemHandle);
       state:=false;
       end;
  Start:=result;
end;

function TCompare.Transfer(var iop:aiobuf):integer;
var _lower,_upper:integer;

  procedure NewStateInteger(x:integer);
  begin
    if state
    then begin
         if x < _lower
         then state:=false;
         end
    else if x >= _upper
         then state:=true;
  end;

  procedure NewStateReal(x:real);
  begin
    if state
    then begin
         if x < lower
         then state:=false;
         end
    else if x >= upper
         then state:=true;
  end;

  procedure xxx_byte;
  var i:longint;
      _high,_low:integer;
  begin
     _lower:=trunc(lower);
     _upper:=trunc(upper);
     _low:=trunc(low);
     _high:=trunc(high);
     for i:=0 to iop[2].size-1
     do begin
(*  AP4: ottimizzare la conversione di tipo *)
        case InputType of
          zByte:NewStateInteger(ByteArray(iop[2].buf^)[i]-128);
          zInteger:NewStateInteger(IntegerArray(iop[2].buf^)[i]);
          zReal:NewStateReal(RealArray(iop[2].buf^)[i]);
          end;
        if state
        then ByteArray(MemPtr^)[i]:=_high+128
        else ByteArray(MemPtr^)[i]:=_low+128
        end;

  end;
  procedure xxx_integer;
  var i:longint;
      _high,_low:integer;
  begin
     _lower:=trunc(lower);
     _upper:=trunc(upper);
     _low:=trunc(low);
     _high:=trunc(high);
     for i:=0 to iop[2].size-1
     do begin
(*  AP4: ottimizzare la conversione di tipo *)
        case InputType of
          zByte:NewStateInteger(ByteArray(iop[2].buf^)[i]-128);
          zInteger:NewStateInteger(IntegerArray(iop[2].buf^)[i]);
          zReal:NewStateReal(RealArray(iop[2].buf^)[i]);
          end;
        if state
        then IntegerArray(MemPtr^)[i]:=_high
        else IntegerArray(MemPtr^)[i]:=_low;
        end;

  end;
  procedure xxx_real;
  var i:longint;
  begin
     _lower:=trunc(lower);
     _upper:=trunc(upper);
     for i:=0 to iop[2].size-1
     do begin
(*  AP4: ottimizzare la conversione di tipo *)
        case InputType of
          zByte:NewStateInteger(ByteArray(iop[2].buf^)[i]-128);
          zInteger:NewStateInteger(IntegerArray(iop[2].buf^)[i]);
          zReal:NewStateReal(RealArray(iop[2].buf^)[i]);
          end;
        if state
        then RealArray(MemPtr^)[i]:=high
        else RealArray(MemPtr^)[i]:=low;
        end;

  end;

begin
  Transfer:=0;
  iop[8].buf:=MemPtr;
  iop[8].size:=iop[2].size;
  case FunctionType of
    zByte:xxx_byte;
    zInteger:xxx_integer;
    zReal:xxx_real;
    end; (* of case *)
end;


procedure TCompare.Stop;
begin
if MemHandle <> 0
then begin
     GlobalUnLock(MemHandle);
     GlobalFree(MemHandle);
     end;
end;

function TCompare.StoreParam(HWindow:HWnd;var st:string;ErrString:PChar):boolean;
var sub:string;j:integer;
    code:integer;
    _functionType:integer;
    _lower,_upper:real;
    _low,_high:real;
begin
  StoreParam:=false;StrCopy(ErrString,BadFormat);
  j:=1;
  GetType(st,j,_FunctionType);
  if not GetRValue(PS,st,j,_lower)then exit;inc(j);
  if not GetRValue(PS,st,j,_upper)then exit;inc(j);
  if not GetRValue(PS,st,j,_low)then exit;inc(j);
  if not GetRValue(PS,st,j,_high)then exit;inc(j);
  if _high <= _low
  then begin
       StrCopy(ErrString,'high > low');
       exit;
       end;
  if _upper < _lower
  then begin
       StrCopy(ErrString,'upper >= lower');
       exit;
       end;

  functionType:=_FunctionType;
  lower:=_lower;
  upper:=_upper;
  low:=_low;
  high:=_high;
  StoreParam:=true;
end;

procedure TCompare.GetDlg(HWindow:HWnd;var st:string);
var  testo:array[0..127]of char;
begin
  GetCTypeDlg(HWindow,testo);
  st:=StrPas(testo);
  GetDlgItemText(HWindow, 104, testo, sizeof(testo));
  st:=st+';'+StrPas(testo);
  GetDlgItemText(HWindow, 105, testo, sizeof(testo));
  st:=st+';'+StrPas(testo);
  GetDlgItemText(HWindow, 110, testo, sizeof(testo));
  st:=st+';'+StrPas(testo);
  GetDlgItemText(HWindow, 111, testo, sizeof(testo));
  st:=st+';'+StrPas(testo);
end;

procedure TCompare.SetDlg(HWindow:HWnd);
var  testo:array[0..127]of char;
     j:integer;
begin
  TBlock.SetDlg(HWindow);
  j:=1;
  GetPString(param,testo,j);inc(j);
  SetCTypeDlg(HWindow,testo[0]);
  GetPString(param,testo,j);inc(j);
  SetDlgItemText(HWindow,104,testo);
  GetPString(param,testo,j);inc(j);
  SetDlgItemText(HWindow,105,testo);
  GetPString(param,testo,j);inc(j);
  SetDlgItemText(HWindow,110,testo);
  GetPString(param,testo,j);inc(j);
  SetDlgItemText(HWindow,111,testo);
end;

(* - - - - TEco - - - - *)

constructor TEco.Init(SystemP:pSystem;Num:integer);
begin
  TBlock.Init(SystemP,Num);
  feedback:=10;
  delay:=512;
  Param:='10;512';
end;

function TEco.Start(var prop:AIOprop;bufsize:longint;HWindow:HWnd):integer;
var result:integer;


begin
  result:=T1In1Out.Start(prop,bufsize,HWindow);
  if result = 0
  then begin
(*AP6*)EcoHandle:=AllocArray(delay,OwnType);
       if EcoHandle = 0
       then begin
            T1In1Out.Stop; (* free seized memory *)
            start:=4;
            exit;
            end;
       Eco.buf:=GlobalLock(EcoHandle);
       Eco.size:=delay;
       ZeroInit(Eco,OwnType);First:=0;
       end;
  Start:=result;
end;

function TEco.Transfer(var iop:aiobuf):integer;

  procedure abcp(a,b,c:tiobuf;p:integer;start,offset,len:longint);
  (* calcola a[i]=b[i]+c[i+offset]*p/100 partendo da <start> per <len> campioni
     usando come tipo di riferimento <OwnType>
  *)
      procedure abcp_byte;
      var i:longint;
          ris:integer;

      begin
         for i:=start to start+len-1
         do begin
            ris:=ByteArray(b.buf^)[i]-128+(ByteArray(c.buf^)[i+offset]-128)*p div 100;
            if ris > 127
            then ris:=127
            else if ris < -127
                 then ris:= -127;
            ByteArray(a.buf^)[i]:=ris+128;
            end;

      end;
      procedure abcp_integer;
      var i:longint;
          ris:longint;
      begin
         for i:=start to start+len-1
         do begin
            ris:=IntegerArray(b.buf^)[i]+IntegerArray(c.buf^)[i+offset]*p div 100;
            if ris > 32767
            then ris:=32767
            else if ris < -32767
                 then ris:= -32767;
            IntegerArray(a.buf^)[i]:=ris;
            end;

      end;
      procedure abcp_real;
      var i:longint;
          p100:real;
      begin
         p100:=p/100;
         for i:=start to start+len-1
         do begin
            RealArray(a.buf^)[i]:=RealArray(b.buf^)[i]+
                              RealArray(c.buf^)[i+offset]*p100;
            end;

      end;
  begin
  case OwnType of
    zByte:abcp_byte;
    zInteger:abcp_integer;
    zReal:abcp_real;
    end; (* of case *)
  end;


begin
  Transfer:=0;
  iop[8].buf:=MemPtr;
  iop[8].size:=iop[2].size;
  if delay <= iop[2].size
  then begin
       abcp(iop[8],iop[2],Eco,feedback,0,0,delay);
       abcp(iop[8],iop[2],iop[8],feedback,delay,-delay,iop[2].size-delay);
       movebuf(Eco,iop[8],0,iop[2].size-delay,delay,OwnType);
       end
  else begin
       if first+iop[2].size > delay
       then begin
            abcp(iop[8],iop[2],Eco,feedback,0,first,delay-first);
            movebuf(Eco,iop[8],first,-first,delay-first,OwnType);

            abcp(iop[8],iop[2],Eco,feedback,delay-first,first-delay,iop[2].size-delay+first);
            movebuf(Eco,iop[8],0,delay-first,iop[2].size-delay+first,OwnType);
            end
       else begin
            abcp(iop[8],iop[2],Eco,feedback,0,first,iop[2].size);
            movebuf(Eco,iop[8],first,-first,iop[2].size,OwnType);
            end;
       first:=(first+iop[2].size)mod delay;
       end; 
end;


procedure TEco.Stop;
begin
if EcoHandle <> 0
then begin
     GlobalUnLock(EcoHandle);
     GlobalFree(EcoHandle);
     end;
T1In1Out.Stop;
end;

procedure TEco.SetDlg(HWindow:HWnd);
var  testo:array[0..127]of char;
     j:integer;
begin
  TBlock.SetDlg(HWindow);
  j:=1;
  GetPString(param,testo,j);inc(j);
  SetDlgItemText(HWindow,105,testo);
  GetPString(param,testo,j);inc(j);
  SetDlgItemText(HWindow,104,testo);
end;

procedure TEco.GetDlg(HWindow:HWnd;var st:string);
var  testo:array[0..127]of char;
begin
  GetDlgItemText(HWindow, 105, testo, sizeof(testo));
  st:=StrPas(testo);
  GetDlgItemText(HWindow, 104, testo, sizeof(testo));
  st:=st+';'+StrPas(testo);
end;

function TEco.StoreParam(HWindow:HWnd;var st:string;ErrString:PChar):boolean;
var sub:string;j:integer;
    _delay:longint;_feedback:integer;
    code:integer;
begin
  StoreParam:=false;StrCopy(ErrString,BadFormat);
  j:=1;
  if not GetIValue(PS,st,j,_feedback)then exit;inc(j);
  if not GetLValue(PS,st,j,_delay)then exit;inc(j);
  if (_feedback < 0)or (_feedback > 99)
  then begin
       StrCopy(ErrString,'<feedback> must an integer in [0..99]');
       exit;
       end;
  if (_delay <= 0)
  then begin
       StrCopy(ErrString,'<delay> must be a positive integer');
       exit;
       end;
  feedback:=_feedback;
  delay:=_delay;
  StoreParam:=true;
end;

(* - - - - TVibrato - - - - *)

constructor tVibrato.Init(SystemP:pSystem;Num:integer);
begin
  TBlock.Init(SystemP,Num);
  maxdelay:=10;
  period:=1024;
  Param:='10;0';
end;

function tVibrato.Start(var prop:AIOprop;bufsize:longint;HWindow:HWnd):integer;
begin
  Start:=t1In1Out.Start(prop,bufsize,HWindow);
  period:=bufsize;
end;

function TVibrato.Transfer(var iop:aiobuf):integer;
var i:longint;

  function delay(a:real):integer;
  (* RIFORMULARE <delay> PER RIDURRE IL CARICO ELABORATIVO *)
  begin
    delay:=round((1-cos(a))*maxdelay/2);
  end;

begin
  Transfer:=0;
  iop[8].buf:=MemPtr;
  iop[8].size:=iop[2].size;
  case OwnType of
    zByte: for i:=0 to iop[2].size-1
           do ByteArray(iop[8].buf^)[i]:=ByteArray(iop[2].buf^)[i-delay(i*Pi*2/Period)];
    zInteger: for i:=0 to iop[2].size-1
           do IntegerArray(iop[8].buf^)[i]:=IntegerArray(iop[2].buf^)[i-delay(i*Pi*2/Period)];
    zReal: for i:=0 to iop[2].size-1
           do RealArray(iop[8].buf^)[i]:=RealArray(iop[2].buf^)[i-delay(i*Pi*2/Period)];
    end; (* of case *)
end;


procedure tVibrato.SetDlg(HWindow:HWnd);
var  testo:array[0..127]of char;
     j:integer;
begin
  TBlock.SetDlg(HWindow);
  j:=1;
  GetPString(param,testo,j);inc(j);
  SetDlgItemText(HWindow,105,testo);
(*  GetPString(param,testo,j);inc(j);
  SetDlgItemText(HWindow,104,testo);*)
end;

procedure tVibrato.GetDlg(HWindow:HWnd;var st:string);
var  testo:array[0..127]of char;
begin
  GetDlgItemText(HWindow, 105, testo, sizeof(testo));
  st:=StrPas(testo);
(*  GetDlgItemText(HWindow, 104, testo, sizeof(testo));
  st:=st+';'+StrPas(testo);*)
  st:=st+';0';
end;

function tVibrato.StoreParam(HWindow:HWnd;var st:string;ErrString:PChar):boolean;
var sub:string;j:integer;
    code:integer;
     _delay:longint;_maxdelay:integer;
begin
  StoreParam:=false;StrCopy(ErrString,BadFormat);
  j:=1;
  if not GetIValue(PS,st,j,_maxdelay)then exit;inc(j);
(*  if not GetLValue(PS,st,j,_delay)then exit;inc(j);*)
  if (_maxdelay >= 100) or (_maxdelay <= 0)
  then begin
       StrCopy(ErrString,'<maxdelay> must less then Period/(2*Pi)');
       exit;
       end;
(*       end
  else StrCopy(ErrString,'<delay> must be a positive integer');*)
  maxdelay:=_maxdelay;
  StoreParam:=true;
end;

(* - - - - THist - - - - *)

constructor THist.Init(SystemP:pSystem;Num:integer);
begin
  TBlock.Init(SystemP,Num);
  Nint:=16;
  min:=-128;max:=128;
  OutType:=zInteger;
  cumulative:=1;
  Param:='I;16;1;-128.0000;128.0000';
end;

procedure THist.Capability(var Attr:TAttrDev;var IOClass:TAIOClass);
var i:integer;
begin
  TBlock.Capability(Attr,IOClass);
  IOClass[2]:=zInput;
  IOClass[8]:=zOutput;
end;

function THist.Check(var prop:AIOprop):integer;
var i:integer;
begin
  HistType:=prop[2].attr and zMaskType;
  if  (prop[2].attr and (zMaskComplex or zMaskSampled) <> zSimple or zSampled)
  then begin
          Check:=5;
          exit;
       end;
  Check:=0;
  prop[8].attr:=zInteger or zSimple;
  prop[8].fsample:=0;
end;

procedure zero(a:tiobuf);
var i:longint;
begin
  for i:=0 to a.size-1
  do IntegerArray(a.buf^)[i]:=0;
end;

function THist.Start(var prop:AIOprop;bufsize:longint;HWindow:HWnd):integer;
var result:integer;

begin
  result:=Check(prop);
  if result = 0
  then begin
(*AP6*)MemHandle:=AllocArray(Nint,zInteger);
       if MemHandle = 0
       then begin
            start:=4;
            exit;
            end;
       Mem.buf:=GlobalLock(MemHandle);
       Mem.size:=Nint;
       if cumulative <> 0
       then zero(Mem);
       end;
  Start:=result;
end;

function THist.Transfer(var iop:aiobuf):integer;

  procedure ClassByte(a:tiobuf);
  var i:longint;k:integer;delta:integer;
      lmin,lmax:integer;
  begin
  lmin:=trunc(min);lmax:=trunc(max);
(*  delta:=(lmax-lmin)div Nint; CORR 05-94 *)
  for i:=0 to a.size-1
  do begin
     k:=integer(ByteArray(a.buf^)[i])-128;
     if (k>=lmin)and(k<lmax)
     then Inc(IntegerArray(Mem.buf^)[Nint*(k-lmin)div (lmax-lmin)])
     end;
  end;

  procedure ClassInteger(a:tiobuf);
  var i:longint;k:integer;delta:longint;
      lmin,lmax:longint;
  begin
  lmin:=trunc(min);lmax:=trunc(max);
(*  delta:=(lmax-lmin)div Nint; CORR 05-94 *)
  for i:=0 to a.size-1
  do begin
     k:=IntegerArray(a.buf^)[i];
     if (k>=lmin)and(k<lmax)
     then Inc(IntegerArray(Mem.buf^)[Nint*(k-lmin)div (lmax-lmin)])
     end;
  end;

(*AP7*)  procedure ClassReal(a:tiobuf);
  var i:longint;k:real;delta:real;
  begin
  delta:=(max-min)/Nint;
  for i:= 0 to a.size-1
  do begin
     k:= RealArray(a.buf^)[i];
     if (k >= min) and (k < max)
     then Inc(IntegerArray(Mem.buf^)[trunc((k-min) / delta)])
     end;
  end;

begin
  Transfer:=0;
  if cumulative = 0
  then zero(Mem);
  iop[8].buf:=Mem.buf;
  iop[8].size:=Mem.size;
  case HistType of
    zByte: ClassByte(iop[2]);
    zInteger: ClassInteger(iop[2]);
    zReal: ClassReal(iop[2]);
    end; (* of case *)
end;


procedure THist.Stop;
begin
if MemHandle <> 0
then begin
     GlobalUnLock(MemHandle);
     GlobalFree(MemHandle);
     end;
end;

procedure THist.SetDlg(HWindow:HWnd);
var  testo:array[0..127]of char;
     j:integer;
begin
  TBlock.SetDlg(HWindow);
  j:=1;
  GetPString(param,testo,j);inc(j);
  SetCTypeDlg(HWindow,testo[0]);
  GetPString(param,testo,j);inc(j);
  SetDlgItemText(HWindow,104,testo);
  GetPString(param,testo,j);inc(j);
  if testo[0] <> '0'
  then SendDlgItemMessage(HWindow, 110, bm_SetCheck, 1, 0);
  GetPString(param,testo,j);inc(j);
  SetDlgItemText(HWindow,105,testo);
  GetPString(param,testo,j);inc(j);
  SetDlgItemText(HWindow,106,testo);
end;

procedure THist.GetDlg(HWindow:HWnd;var st:string);
var  testo:array[0..127]of char;
begin
  GetCTypeDlg(HWindow,testo);
  st:=StrPas(testo);
  GetDlgItemText(HWindow, 104, testo, sizeof(testo));
  st:=st+';'+StrPas(testo);
  Str(SendDlgItemMessage(HWindow, 110, bm_GetCheck, 0, 0),testo);
  st:=st+';'+StrPas(testo);
  GetDlgItemText(HWindow, 105, testo, sizeof(testo));
  st:=st+';'+StrPas(testo);
  GetDlgItemText(HWindow, 106, testo, sizeof(testo));
  st:=st+';'+StrPas(testo);
end;

function THist.StoreParam(HWindow:HWnd;var st:string;ErrString:PChar):boolean;
var sub:string;j:integer;
    code:integer;
    _max,_min:real;_Nint:integer;
    _cumulative,_outtype:integer;
begin
  StoreParam:=false;StrCopy(ErrString,BadFormat);
  j:=1;
  GetType(st,j,_OutType);
  if not GetIValue(PS,st,j,_Nint)then exit;inc(j);
  if not GetIValue(PS,st,j,_cumulative)then exit;inc(j);
  if not GetRValue(PS,st,j,_min)then exit;inc(j);
  if not GetRValue(PS,st,j,_max)then exit;inc(j);
  if _min >= _max
  then begin
       StrCopy(ErrString,'<max> must be a real greater than <min>');
       exit;
       end;
  if (_Nint>100)or(_Nint<2)
  then begin
       StrCopy(ErrString,'<N intervals> must an integer in [2..100]');
       exit;
       end;
  Nint:=_Nint;
  min:=_min;
  max:=_max;
  cumulative:=_cumulative;
  OutType:=_OutType;
  StoreParam:=true;
end;


(* - - - - TDisplay1 - - - - *)

const zDot=1;zLine=2;zBar=3;

function TDisplay1.InitDisplay(HWindow:HWnd;width:integer):HWnd;
var result:integer;
    x,y:integer;
begin
  (* Crea TDisplay1 *)
  border:=false;_width:=width;
  Wnd:=CreateDialogParam(HInstance,'Display',HWindow,Display1Proc,longint(@Self));
  SetWindowText(Wnd,title);
  GetNewOrigin(x,y);
  MoveWindow(Wnd,x,y,_width,256+GetSystemMetrics(SM_CYCaption),false);
  InitDisplay:=Wnd;
end;


procedure TDisplay1.Paint(TheDC: HDC; var PaintInfo: TPaintStruct;Window:HWnd);
(* Questa procedura gestisce il rendering della finestra
   oscilloscopio. MUST BE OVERRIDEN
*)
begin
  Abstract;
end;



function Display1(HWindow: HWnd; Message, WParam: Word;
  LParam: Longint): Bool; export;
var
  PS: TPaintStruct;
  Rect:Trect;
  

  procedure Paint(TheDC: HDC; var PaintInfo: TPaintStruct;Window:HWnd);
  begin
    pDisplay1(GetWindowLong(HWindow,DWL_User))^.Paint(TheDC,PaintInfo,Window);
  end;


begin
  Display1 := True;
  case Message of
    wm_InitDialog:
      begin
(* La seguente procedura e' valida solo per i dialoghi! *)
        SetWindowLong(HWindow,DWL_USER,LParam);
        Exit;
      end;
    wm_EraseBkGnd:Exit;
    wm_Destroy:begin
             DeskX:=0;DeskY:=0;
             end;
    wm_Paint:
      begin
      if GetUpdateRect(HWindow,Rect,false)
      then begin
	     BeginPaint(HWindow, PS);
	     Paint(PS.hDC,PS,HWindow);
	     EndPaint(HWindow, PS);
           end;
      end;
  end;
  Display1 := False;
end;

procedure tDisplay1.SetUpPaint(TheDC: HDC; erase:boolean;Window:HWnd);
var
  Rect: TRect;

    procedure Frame(TheDC:HDC;var IRect:TRect);
    var OldBr,TheBr:HBrush;
        OldPen,Pen1,Pen2:HPen;
        i:integer;
        Rect:TRect;
        Rgn:HRgn;
    begin
    Rect:=IRect;
    if border
    then begin
         TheBr:=CreateSolidBrush(GetSysColor(Color_BTNFace));
         OldBr:=SelectObject(TheDC,TheBr);
         for i:=1 to 3
         do begin
            InflateRect(Rect,-1,-1);
            FrameRect(TheDC,Rect,TheBr);
            end;
         DeleteObject(SelectObject(TheDC,OldBr));
         Rect:=IRect;
         Pen1:=CreatePen(PS_Solid,1,GetSysColor(Color_BTNHighLight));
         Pen2:=CreatePen(PS_Solid,1,GetSysColor(Color_BTNShadow));
         OldPen:=SelectObject(TheDC,Pen1);
         MoveTo(TheDC,Rect.left,Rect.bottom-1);LineTo(TheDC,Rect.left,Rect.top);
         LineTo(TheDC,Rect.right-1,Rect.top);
         SelectObject(TheDC,Pen2);
         LineTo(TheDC,Rect.right-1,Rect.bottom-1);
         LineTo(TheDC,Rect.left,Rect.bottom-1);
         InflateRect(Rect,-4,-4);
         MoveTo(TheDC,Rect.left,Rect.bottom-1);LineTo(TheDC,Rect.left,Rect.top);
         LineTo(TheDC,Rect.right-1,Rect.top);
         SelectObject(TheDC,Pen1);
         LineTo(TheDC,Rect.right-1,Rect.bottom-1);
         LineTo(TheDC,Rect.left,Rect.bottom-1);
         SelectObject(TheDC,OldPen);
         DeleteObject(Pen1);
         DeleteObject(Pen2);
         InflateRect(Rect,-1,-1);
         end;
    TheBr:=CreateSolidBrush(RGB(0,128,64));
    OldBr:=SelectObject(TheDC,TheBr);
    Rgn:=CreateRectRgnIndirect(Rect);
    PaintRgn(TheDC,Rgn);
    DeleteObject(Rgn);
    DeleteObject(SelectObject(TheDC,OldBr));
    end;

  begin
  GetClientRect(Window, Rect);
  if erase
  then Frame(TheDC,Rect);
  SetMapMode(TheDC,MM_Anisotropic);
  if border
  then begin
       SetViewPortOrg(TheDC,5,Rect.Bottom-6);
       SetViewPortExt(TheDC,1,-1)
       end
  else begin
       SetViewPortOrg(TheDC,0,Rect.Bottom-1);
       SetWindowExt(TheDC,_width,zWidth);    
       SetViewPortExt(TheDC,Rect.right,-Rect.bottom);
       end;
end;


function tDisplay1.GetStyle(HWindow:HWnd):integer;
var  testo:array[0..127]of char;
begin
  if SendDlgItemMessage(HWindow, 107, bm_GetCheck, 0, 0) = 1
  then GetStyle:=zDot
  else if SendDlgItemMessage(HWindow, 108, bm_GetCheck, 0, 0) = 1
       then GetStyle:=zLine
       else GetStyle:=zBar;
end;

function tDisplay1.StoreTitle(var st:string;var j:integer;ErrString:PChar):boolean;
var  sub:string;
begin
  StoreTitle:=false;
  GetString(st,sub,j);inc(j);
  if Pos(';',sub) <> 0
  then begin
       StrCopy(ErrString,'do not use '';'' in title');
       exit;
       end;
  StrPCopy(title,sub);
  StoreTitle:=true;
end;

(* - - - - TDisplayImage - - - - *)

function TDisplayImage.InitDisplay(HWindow:HWnd;width,height:integer):HWnd;
var x,y:integer;
begin
  (* Crea TDisplayImage *)
  border:=true;_width:=width+12;
  Wnd:=CreateDialogParam(HInstance,'DisplayImage',HWindow,Display1Proc,longint(@Self));
  SetWindowText(Wnd,title);
  GetNewOrigin(x,y);
  MoveWindow(Wnd,x,y,_width,height+GetSystemMetrics(SM_CYCaption)+11,false);
  InvalidateRect(Wnd,nil,true);
  InitDisplay:=Wnd;
end;

(* - - - - TImage - - - - *)

constructor TImage.Init(SystemP:pSystem;Num:integer);
begin
  TBlock.Init(SystemP,Num);
  StrCopy(title,'Image');
  style:=4;     (* image *)
  timebase:=128;  (*  *)
  width:=128;
  autorange:=true;
  Param:='Image;;4;128;128;;';
end;

procedure TImage.Capability(var Attr:TAttrDev;var IOClass:TAIOClass);
var i:integer;
begin
  TBlock.Capability(Attr,IOClass);
  IOClass[2]:=zInput;
end;

function TImage.Check(var prop:AIOprop):integer;
begin
  ScopeType:=prop[2].attr and zMaskType;
  if  (prop[2].attr and zMaskComplex <> zSimple)
  then Check:=5
  else Check:=0;
end;

procedure TImage.Paint(TheDC: HDC; var PaintInfo: TPaintStruct;Window:HWnd);
(* Questa procedura gestisce il rendering della finestra
   oscilloscopio
*)
var k:integer;
    OldPen:HPen;
    Rect:TRect;
    OldPalette: HPalette;
    xx,y:byte;
begin
  SetUpPaint(TheDC,PaintInfo.fErase,Window);
  OldPalette := SelectPalette(TheDC, ThePalette, False);
  RealizePalette(TheDC);
  if ValidSize<>0
  then begin
       GetClientRect(Wnd, Rect);
       xx:=0;index:=0;
       for k:=0 to ValidSize-1
       do begin
          y:=ByteArray(Mem.buf^)[k];
          if y>=128
          then SetPixel(TheDC,xx,index,PaletteIndex(y-128))
          else SetPixel(TheDC,xx,index,PaletteIndex(0));
          inc(index);
          if index=timebase
          then begin
               index:=0;inc(xx);
               end;
          end;
       end;
  SelectPalette(TheDC, OldPalette, False);
end;

procedure TImage.PaintBuffer;
var k:integer;
    OldPen:HPen;
    TheDC:HDC;
    Rect:TRect;
    OldPalette: HPalette;
    y:byte;
begin
  TheDC:=GetDC(Wnd);
  SetUpPaint(TheDC,false,Wnd);
  OldPalette := SelectPalette(TheDC, ThePalette, False);
  RealizePalette(TheDC);
  GetClientRect(Wnd, Rect);
  for k:=0 to Temp.size-1
  do begin
     y:=ByteArray(Temp.buf^)[k];
     if y>=128
     then SetPixel(TheDC,x,index,PaletteIndex(y-128))
     else SetPixel(TheDC,x,index,PaletteIndex(0));
     inc(index);
     if index=timebase
     then begin
          index:=0;inc(x);
          end;
     end;
  inc(longint(Temp.buf),Temp.size);(* sposta puntatore iniziale *)
  dec(residual,Temp.size);
  SelectPalette(TheDC, OldPalette, False);
  ReleaseDC(Wnd,TheDC);
end;


function TImage.Start(var prop:AIOprop;bufsize:longint;HWindow:HWnd):integer;
var result:integer;
begin
  result:=Check(prop);
  if result <> 0
  then begin
       start:=result;
       exit;
       end;
  (*AP8*)
  ownsize:=timebase*width;(*AP1*)
  residual:=ownsize;
  (*AP6*)
  MemHandle:=AllocArray(ownsize,zByte);
  if MemHandle = 0
  then begin
       start:=4;
       exit;
       end;
  Mem.buf:=GlobalLock(MemHandle);
  Mem.size:=0;
  Temp:=Mem;
  start:=result;
  index:=0;IntGain:=1;RealGain:=0;
  x:=0;ValidSize:=0;
  (* Crea TDisplay1 *)
  InitDisplay(HWindow,width,timebase);
end;

function TImage.Transfer(var iop:aiobuf):integer;
var ptemp:pointer;
begin
  Transfer:=0;
  if residual >= iop[2].size
  then begin
       Temp.size:=iop[2].size;
       case ScopeType of
         zByte:Move(iop[2].buf^,Temp.buf^,iop[2].size);
         zInteger:MoveInteger(Temp,iop[2],IntGain);
         zReal:MoveReal(Temp,iop[2],RealGain);
         end; (* of case *)
       end
  else begin
       Temp.buf:=Mem.buf;
       case ScopeType of
         zByte:Move(iop[2].buf^,Temp.buf^,iop[2].size);
         zInteger:MoveInteger(Temp,iop[2],IntGain);
         zReal:MoveReal(Temp,iop[2],RealGain);
         end; (* of case *)
       Temp.size:=iop[2].size-residual;
(*AP9*)       longint(ptemp):=longint(Temp.buf)+residual;
       Move(ptemp^,Temp.buf^,Temp.size);
       residual:=ownsize;
       x:=0;
       end;
  PaintBuffer;
  if ValidSize<ownsize-residual
  then ValidSize:=ownsize-residual;
end;

procedure TImage.Stop;
begin
  (* Elimina TDisplay1 *)
  DestroyWindow(Wnd);
  if MemHandle <> 0
  then begin
       GlobalUnLock(MemHandle);
       GlobalFree(MemHandle);
       end;
end;

function TImage.StoreParam(HWindow:HWnd;var st:string;ErrString:PChar):boolean;
(* FORMAT: title;;style;timebase;width;range

           style:4       (image)
           timebase:     integer
           range:min,max   (Nota: se range non e' specificato allora AUTORANGE)
*)
var sub:string;j:integer;
    code:integer;
    twidth:integer;
    _timebase:longint;
    _style:integer;
begin
  StoreParam:=false;StrCopy(ErrString,BadFormat);
  j:=1;
  if not StoreTitle(st,j,ErrString)
  then exit;
  inc(j);
  if not GetIValue(PS,st,j,_style)then exit;inc(j);
  if not GetLValue(PS,st,j,_timebase)then exit;inc(j);
  if not GetIValue(PS,st,j,twidth)then exit;inc(j);
(*  if not GetRValue(PS,st,j,_range)then exit;inc(j);*)
  if (_timebase <= 2)
  then begin
       StrCopy(ErrString,'<timebase> must be an integer greater than 2');
       exit;
       end;
  if (twidth <= 2) or not (twidth <= longint(65535)div longint(_timebase))
  then begin
       StrCopy(ErrString,'<width*timebase> must be less than 64K');
       exit;
       end;
  width:=twidth;
  timebase:=_timebase;
  autorange:=true;
  style:=4;
  StoreParam:=true;
end;

procedure TImage.SetDlg(HWindow:HWnd); 
var
  testo:array[0..31]of char;
  j:integer;
(* id-list:
              114: timebase
              115: title
              116: width
*)
begin
  TBlock.SetDlg(HWindow);
  j:=1;
  GetPString(param,testo,j);inc(j);
  SetDlgItemText(HWindow,115,testo);
  inc(j,3);
  GetPString(param,testo,j);inc(j);
  SetDlgItemText(HWindow,114,testo);
  GetPString(param,testo,j);inc(j);
  SetDlgItemText(HWindow,116,testo);
end;

procedure TImage.GetDlg(HWindow:HWnd;var st:string);
var  testo:array[0..127]of char;
begin
  GetDlgItemText(HWindow, 115, testo, sizeof(title));
  st:=StrPas(testo)+';;4';
  GetDlgItemText(HWindow, 114, testo, sizeof(testo));
  st:=st+';'+StrPas(testo);
  GetDlgItemText(HWindow, 116, testo, sizeof(testo));
  st:=st+';'+StrPas(testo);
  st:=st+';;'; (* AUTORANGE *)
end;


(* - - - - TMeter - - - - *)

const zHeight = 32;

constructor TMeter.Init(SystemP:pSystem;Num:integer);
begin
  TBlock.Init(SystemP,Num);
  StrCopy(title,'Meter');
  style:=5;     (* valore numerico *)
  nrows:=2;     (* 2 rows *)
  Param:='Meter;5;2';
end;

procedure TMeter.Capability(var Attr:TAttrDev;var IOClass:TAIOClass);
var i:integer;
begin
  TBlock.Capability(Attr,IOClass);
  IOClass[2]:=zInput;
end;

function TMeter.Check(var prop:AIOprop):integer;
begin
  MeterType:=prop[2].attr and zMaskType;
  if  (prop[2].attr and zMaskComplex <> zSimple)
  then Check:=5
  else Check:=0;
end;

procedure TMeter.Paint(TheDC: HDC; var PaintInfo: TPaintStruct;Window:HWnd);
(* Questa procedura gestisce il rendering della finestra
   oscilloscopio
*)
var
  int:integer;
  Str,Str2: array[0..31] of Char;
  hOld: HFont;
  Rect:TRect;
  i:integer;
begin
  SetUpPaint(TheDC,PaintInfo.fErase,Window);
  SetBkMode(TheDC,Transparent);
  SetTextColor(TheDC,RGB(255,255,255));
  hOld := SelectObject(TheDC, GetStockObject(SYSTEM_FONT));
  for i:=0 to nvalues-1
  do begin
       System.Str(value[i]:13:5,Str);
       TextOut(TheDC, 0, zHeight*(nrows-i)-6,Str, strlen(Str));
     end;
  SelectObject(TheDC, hOld);
end;

function TMeter.Start(var prop:AIOprop;bufsize:longint;HWindow:HWnd):integer;
var result:integer;
begin
  result:=Check(prop);
  if result <> 0
  then begin
       start:=result;
       exit;
       end;
  ownsize:=bufsize;
  start:=result;
  nvalues:=0;
  (* Crea TDisplay1 *)
  InitDisplay(HWindow,128,zHeight*nrows);
end;

function TMeter.Transfer(var iop:aiobuf):integer;

  procedure storeVal(a:tiobuf);
  var i:longint;
  begin
  if a.size > nrows
  then nvalues:=nrows
  else nvalues:=a.size;
  case MeterType of
    zByte: for i:=0 to nvalues-1
           do value[i]:=ByteArray(a.buf^)[i]-128;
    zInteger: for i:=0 to nvalues-1
           do value[i]:=IntegerArray(a.buf^)[i];
    zReal: for i:=0 to nvalues-1
           do value[i]:=RealArray(a.buf^)[i];
    end; (* of case *)
  end;

begin
  Transfer:=0;
  storeVal(iop[2]);
  InvalidateRect(Wnd,nil,true);
end;

procedure TMeter.Stop;
begin
  (* Elimina TDisplay1 *)
  DestroyWindow(Wnd);
end;


function TMeter.StoreParam(HWindow:HWnd;var st:string;ErrString:PChar):boolean;
(* FORMAT: title;style;nrows

           style:5       (valore numerico)
           nrows:integer
*)
var sub:string;j:integer;
    code:integer;
     _nrows,_style:integer;
begin
  StoreParam:=false;StrCopy(ErrString,BadFormat);
  j:=1;
  GetString(st,sub,j);inc(j);
  if not GetIValue(PS,st,j,_style)then exit;inc(j);
  if not GetIValue(PS,st,j,_nrows)then exit;inc(j);
  if (_nrows > zMaxValues)or (_nrows <= 0)
  then begin
       StrCopy(ErrString,'<nrows> must an integer in [1..8]');
       exit;
       end;
  nrows:=_nrows;
  style:=_style;
  StrPCopy(title,Copy(sub,1,zMaxTitleLength));
  StoreParam:=true;
end;

procedure tMeter.SetDlg(HWindow:HWnd); 
var
  testo:array[0..31]of char;
  j:integer;
begin
  TBlock.SetDlg(HWindow);
  j:=1;
  GetPString(param,testo,j);inc(j);
  SetDlgItemText(HWindow,115,testo);
  inc(j,2);
  GetPString(param,testo,j);inc(j);
  SetDlgItemText(HWindow,114,testo);
end;

procedure tMeter.GetDlg(HWindow:HWnd;var st:string);
var  testo:array[0..127]of char;
begin
  GetDlgItemText(HWindow, 115, testo, sizeof(title));
  st:=StrPas(testo)+';5';
  GetDlgItemText(HWindow, 114, testo, sizeof(testo));
  st:=st+';'+StrPas(testo);
end;


(* - - - - TScope1 - - - - *)

constructor TScope1.Init(SystemP:pSystem;Num:integer);
begin
  TBlock.Init(SystemP,Num);
  StrCopy(title,'Oscilloscope');
  autoblank:=1; (* on *)
  nchannels:=1;
  style:=1;     (* dot *)
  timebase:=256;  (*  *)
  autorange:=true;
  Param:='Oscilloscope;1;1;256;1;;';
end;

procedure TScope1.Capability(var Attr:TAttrDev;var IOClass:TAIOClass);
var i:integer;
begin
  TBlock.Capability(Attr,IOClass);
  IOClass[2]:=zInput;
end;

function TScope1.Check(var prop:AIOprop):integer;
begin
  ScopeType:=prop[2].attr and zMaskType;
  if  (prop[2].attr and zMaskComplex <> zSimple)(*AP8*)
  then Check:=5
  else Check:=0;
end;

procedure TScope1.Paint(TheDC: HDC; var PaintInfo: TPaintStruct;Window:HWnd);
(* Questa procedura gestisce il rendering della finestra
   oscilloscopio
*)
var k,min:integer;
    OldPen:HPen;
    Rect:TRect;
begin
  SetUpPaint(TheDC,PaintInfo.fErase,Window);
  redraw:=false;
  if Mem.size<>0
  then case style of
        zDot:for k:=0 to Mem.size-1
          do begin
             SetPixel(TheDC,index,ByteArray(Mem.buf^)[k],RGB(0,255,0));
             inc(index);
             if index=timebase
             then begin
                  index:=0;
                  redraw:=true;
                  end;
             end;
        zLine:begin
          OldPen:=SelectObject(TheDC,CreatePen(PS_Solid,1,RGB(0,255,0)));
          MoveTo(TheDC,index,ByteArray(Mem.buf^)[0]);
          for k:=0 to Mem.size-1
          do begin
             LineTo(TheDC,index,ByteArray(Mem.buf^)[k]);
             inc(index);
             if index=timebase
             then begin
                  index:=0;
                  redraw:=true;
                  MoveTo(TheDC,0,ByteArray(Mem.buf^)[k]);
                  end;
             end;
          DeleteObject(SelectObject(TheDC,OldPen));
          end;
        zBar:begin
          OldPen:=SelectObject(TheDC,CreatePen(PS_Solid,1,RGB(0,255,0)));
          MoveTo(TheDC,index,ByteArray(Mem.buf^)[0]);
          GetClientRect(Wnd,Rect);
          if Mem.size<timebase
          then min:=Mem.size
          else min:=timebase;
          for k:=0 to min-1
          do Rectangle(TheDC,k,128,k+1,ByteArray(Mem.buf^)[k]);
          DeleteObject(SelectObject(TheDC,OldPen));
          redraw:=true;
          end;
       end; (* of case *)
end;

function TScope1.Start(var prop:AIOprop;bufsize:longint;HWindow:HWnd):integer;
var result:integer;
begin
  result:=Check(prop);
  if result <> 0
  then begin
       start:=result;
       exit;
       end;
  (*AP8*)
  if bufsize < timebase
  then ownsize:=timebase
  else ownsize:=bufsize;
  (*AP6*)
  MemHandle:=AllocArray(ownsize,zByte);
  if MemHandle = 0
  then begin
       start:=4;
       exit;
       end;
  Mem.buf:=GlobalLock(MemHandle);
  Mem.size:=0;
  start:=result;
  index:=0;IntGain:=1;RealGain:=0;
  redraw:=false;
  (* Crea TDisplay1 *)
  InitDisplay(HWindow,timebase);
end;

function TScope1.Transfer(var iop:aiobuf):integer;


begin
  (* Aggiorna TDisplay1 *)
  Transfer:=0;
  Mem.size:=iop[2].size;
  case ScopeType of
    zByte:Move(iop[2].buf^,Mem.buf^,iop[2].size);
    zInteger:MoveInteger(Mem,iop[2],IntGain);
    zReal:MoveReal(Mem,iop[2],RealGain);
    end; (* of case *)

  InvalidateRect(Wnd,nil,(autoblank=1)and redraw);
end;

procedure TScope1.Stop;
begin
  (* Elimina TDisplay1 *)
  DestroyWindow(Wnd);
  if MemHandle <> 0
  then begin
       GlobalUnLock(MemHandle);
       GlobalFree(MemHandle);
       end;
end;

function TScope1.StoreParam(HWindow:HWnd;var st:string;ErrString:PChar):boolean;
(* FORMAT: title;#channels;style;timebase;autoblanking;range

           #channels:1-2
           style:1-3       (dot/line/bar)
           timebase:     integer
           autoblanking: 0-1  (off/on)
           range:min,max   (Nota: se range non e' specificato allora AUTORANGE)
*)
var sub:string;j:integer;
    code:integer;
    _timebase:longint;
    _style,_nchannels:integer;
begin
  StoreParam:=false;StrCopy(ErrString,BadFormat);
  j:=1;
  if not StoreTitle(st,j,ErrString)
  then exit;
  if not GetIValue(PS,st,j,_nchannels)then exit;inc(j);
  if not GetIValue(PS,st,j,_style)then exit;inc(j);
  if not GetLValue(PS,st,j,_timebase)then exit;inc(j);
  if (_timebase <= 2)
  then begin
       StrCopy(ErrString,'<timebase> must be an integer greater than 2');
       exit;
       end;
  if not GetIValue(PS,st,j,autoblank)then exit;inc(j);
(*  if not GetRValue(PS,st,j,_range)then exit;inc(j);*)
  timebase:=_timebase;
  style:=_style;nchannels:=_nchannels;
  autorange:=true;
  StoreParam:=true;
end;


procedure tScope1.SetDlg(HWindow:HWnd); { AP13 }
var
  testo:array[0..31]of char;
  ID:integer;
  j:integer;
  _style,code:integer;
(* id-list:   105: single channel
              106: dual channel
              107: dot
              108: line
              109: bar
              104: autoblank
              114: timebase
              115: title
*)
begin
  TBlock.SetDlg(HWindow);
  j:=1;
  GetPString(param,testo,j);inc(j);
  SetDlgItemText(HWindow,115,testo);
  inc(j,2);
  GetPString(param,testo,j);inc(j);
  Val(testo,_style,code);
  case _style of
    zDot:ID:=107;
    zLine:ID:=108;
    zBar:ID:=109;
  end; (* of case *)
  SendDlgItemMessage(HWindow, ID, bm_SetCheck, 1, 0);
  GetPString(param,testo,j);inc(j);
  SetDlgItemText(HWindow,114,testo);
  GetPString(param,testo,j);inc(j);
  if testo[0] = '1'
  then SendDlgItemMessage(HWindow, 104, bm_SetCheck, 1, 0);
  SendDlgItemMessage(HWindow, 105, bm_SetCheck, 1, 0);
end;

procedure tScope1.GetDlg(HWindow:HWnd;var st:string);
var  testo:array[0..127]of char;
begin
  GetDlgItemText(HWindow, 115, testo, sizeof(title));
  st:=StrPas(testo)+';1'; (* nchannels=1 *)
  Str(GetStyle(HWindow),testo);
  st:=st+';'+StrPas(testo);
  GetDlgItemText(HWindow, 114, testo, sizeof(testo));
  st:=st+';'+StrPas(testo);
  Str(SendDlgItemMessage(HWindow, 104, bm_GetCheck, 0, 0),testo);
  st:=st+';'+StrPas(testo);
  st:=st+';;'; (* AUTORANGE *)
end;

(* - - - - TScopeXY - - - - *)

constructor TScopeXY.Init(SystemP:pSystem;Num:integer);
begin
  TBlock.Init(SystemP,Num);
  StrCopy(title,'Oscilloscope');
  autoblank:=1; (* on *)
  style:=1;     (* dot *)
  autorange:=true;
  Param:='Oscilloscope;;1;;1;;';
end;

procedure TScopeXY.Capability(var Attr:TAttrDev;var IOClass:TAIOClass);
var i:integer;
begin
  TBlock.Capability(Attr,IOClass);
  IOClass[2]:=zInput;
  IOClass[5]:=zInput;
end;

function TScopeXY.Check(var prop:AIOprop):integer;
begin
  YType:=prop[2].attr and zMaskType;
  XType:=prop[5].attr and zMaskType;
  if (prop[2].attr and zMaskComplex = zSimple)and
     (prop[5].attr and zMaskComplex = zSimple)
  then Check:=0
  else Check:=5
end;

procedure TScopeXY.Paint(TheDC: HDC; var PaintInfo: TPaintStruct;Window:HWnd);
(* Questa procedura gestisce il rendering della finestra
   oscilloscopio
*)
var k,min:word;
    OldPen:HPen;
begin
  SetUpPaint(TheDC,PaintInfo.fErase,window);
  if MemX.size>MemY.size
  then min:=MemY.size
  else min:=MemX.size;
  if min<>0
  then case style of
        zDot:for k:=0 to min-1
             do SetPixel(TheDC,ByteArray(MemX.buf^)[k],ByteArray(MemY.buf^)[k],RGB(0,255,0));
        zLine:begin
          OldPen:=SelectObject(TheDC,CreatePen(PS_Solid,1,RGB(0,255,0)));
          MoveTo(TheDC,ByteArray(MemX.buf^)[0],ByteArray(MemY.buf^)[0]);
          for k:=0 to min-1
          do LineTo(TheDC,ByteArray(MemX.buf^)[k],ByteArray(MemY.buf^)[k]);
          DeleteObject(SelectObject(TheDC,OldPen));
          end;
       end; (* of case *)
end;

function TScopeXY.Start(var prop:AIOprop;bufsize:longint;HWindow:HWnd):integer;
var result:integer;
begin
  result:=Check(prop);
  if result <> 0
  then begin
       start:=result;
       exit;
       end;
  (*AP6*)
  MemHandleX:=AllocArray(bufsize,zByte);
  if MemHandleX = 0
  then begin
       start:=4;
       exit;
       end;
  MemHandleY:=AllocArray(bufsize,zByte);
  if MemHandleY = 0
  then begin
       GlobalFree(MemHandleX);
       start:=4;
       exit;
       end;
  MemX.buf:=GlobalLock(MemHandleX);
  MemY.buf:=GlobalLock(MemHandleY);
  MemX.size:=0;
  MemY.size:=0;
  IntGainX:=1;RealGainX:=0;IntGainY:=1;RealGainY:=0;
  start:=result;
  ownsize:=bufsize;
  (* Crea TDisplay1 *)
  InitDisplay(HWindow,256);
end;

function TScopeXY.Transfer(var iop:aiobuf):integer;
begin
     (* Aggiorna TDisplay1 *)
  Transfer:=0;
     MemY.size:=iop[2].size;
     case YType of
       zByte:Move(iop[2].buf^,MemY.buf^,iop[2].size);
       zInteger:MoveInteger(MemY,iop[2],IntGainY);
       zReal:MoveReal(MemY,iop[2],RealGainY);
       end; (* of case *)
     MemX.size:=iop[5].size;
     case XType of
       zByte:Move(iop[5].buf^,MemX.buf^,iop[5].size);
       zInteger:MoveInteger(MemX,iop[5],IntGainX);
       zReal:MoveReal(MemX,iop[5],RealGainX);
       end; (* of case *)
     InvalidateRect(Wnd,nil,(autoblank=1));
end;

procedure TScopeXY.Stop;
begin
  (* Elimina TDisplay1 *)
  DestroyWindow(Wnd);
  if MemHandleX <> 0
  then begin
       GlobalUnLock(MemHandleX);
       GlobalFree(MemHandleX);
       end;
  if MemHandleY <> 0
  then begin
       GlobalUnLock(MemHandleY);
       GlobalFree(MemHandleY);
       end;
end;

function TScopeXY.StoreParam(HWindow:HWnd;var st:string;ErrString:PChar):boolean;
(* FORMAT: title;;style;;autoblanking;range

           style:1-2       (dot/line)
           autoblanking: 0-1  (off/on)
           range:min,max   (Nota: se range non e' specificato allora AUTORANGE)
*)
var sub:string;j:integer;
    code:integer;
begin
  StoreParam:=false;StrCopy(ErrString,BadFormat);
  j:=1;
  if not StoreTitle(st,j,ErrString)
  then exit;
  inc(j);
  if not GetIValue(PS,st,j,style)then exit;inc(j);
  inc(j);
  if not GetIValue(PS,st,j,autoblank)then exit;inc(j);
  autorange:=true;
(*  if not GetRValue(PS,st,j,range)then exit;inc(j);*)
  StoreParam:=true;
end;

procedure TScopeXY.SetDlg(HWindow:HWnd); { AP13 }
var
  testo:array[0..31]of char;
  ID:integer;
  j:integer;
  _style,code:integer;
(* id-list:   107: dot
              108: line
              104: autoblank
              115: title
*)
begin
  TBlock.SetDlg(HWindow);
  j:=1;
  GetPString(param,testo,j);inc(j);
  SetDlgItemText(HWindow,115,testo);
  inc(j);
  GetPString(param,testo,j);inc(j);
  Val(testo,_style,code);
  case Style of
    zDot:ID:=107;
    zLine:ID:=108;
  end; (* of case *)
  SendDlgItemMessage(HWindow, ID, bm_SetCheck, 1, 0);
  inc(j);
  GetPString(param,testo,j);inc(j);
  if testo[0] = '1'
  then SendDlgItemMessage(HWindow, 104, bm_SetCheck, 1, 0);
end;

procedure tScopeXY.GetDlg(HWindow:HWnd;var st:string);
var  testo:array[0..127]of char;
begin
  GetDlgItemText(HWindow, 115, testo, sizeof(title));
  st:=StrPas(testo);
  Str(GetStyle(HWindow),testo);
  st:=st+';;'+StrPas(testo);
  Str(SendDlgItemMessage(HWindow, 104, bm_GetCheck, 0, 0),testo);
  st:=st+';;'+StrPas(testo);
  st:=st+';;'; (* AUTORANGE *)
end;


(* - - - - Limiter  - - - - *)
constructor tLimiter.Init(SystemP:pSystem;Num:integer);
begin
  TBlock.Init(SystemP,Num);
  owntype:=zReal;
  min:=-1;
  max:=1;
  Param:='-1.0000;1.0000';
end;

procedure TLimiter.SetDlg(HWindow:HWnd);
var  testo:array[0..127]of char;
     j:integer;
begin
  TBlock.SetDlg(HWindow);
  j:=1;
  GetPString(param,testo,j);inc(j);
  SetDlgItemText(HWindow,104,testo);
  GetPString(param,testo,j);inc(j);
  SetDlgItemText(HWindow,105,testo);
end;

procedure TLimiter.GetDlg(HWindow:HWnd;var st:string);
var  testo:array[0..127]of char;
begin
  GetDlgItemText(HWindow, 104, testo, sizeof(testo));
  st:=StrPas(testo);
  GetDlgItemText(HWindow, 105, testo, sizeof(testo));
  st:=st+';'+StrPas(testo);
end;

function TLimiter.StoreParam(HWindow:HWnd;var st:string;ErrString:PChar):boolean;
var sub:string;j:integer;
    code:integer;
    _min,_max:real;
begin
  StoreParam:=false;StrCopy(ErrString,BadFormat);
  j:=1;
  if not GetRValue(PS,st,j,_min)then exit;inc(j);
  if not GetRValue(PS,st,j,_max)then exit;inc(j);
  if (_max <= _min)
  then begin
       StrCopy(ErrString,'<max> must be greater then <min>');
       exit;
       end;
  min:=_min;
  max:=_max;
  StoreParam:=true;
end;

function TLimiter.Transfer(var iop:aiobuf):integer;

   procedure TransferByte(var input,output:tiobuf);
   var i:longint;
       _min,_max,x,y:byte;
   begin
     if min>-127
     then _min:=trunc(min)+128
     else _min:=1;  (* -127 *)
     if max<127
     then _max:=trunc(max)+128
     else _max:=255; (* +127 *)
     for i:=0 to input.size - 1
     do begin
        x:=ByteArray(input.buf^)[i];
        if (x<=_min)
        then y:=_min
        else if (x>=_max)
             then y:=_max
             else y:=x;
        ByteArray(output.buf^)[i]:=y
        end;
   end;

   procedure TransferInteger(var input,output:tiobuf);
   var i:longint;
       _min,_max,x,y:integer;
   begin
     _min:=trunc(min);
     _max:=trunc(max);
     for i:=0 to input.size - 1
     do begin
        x:=IntegerArray(input.buf^)[i];
        if (x<=_min)
        then y:=_min
        else if (x>=_max)
             then y:=_max
             else y:=x;
        IntegerArray(output.buf^)[i]:=y
        end;
   end;

   procedure TransferReal(var input,output:tiobuf);
   var i:longint;
       x,y:real;
   begin
     for i:=0 to input.size - 1
     do begin
        x:=RealArray(input.buf^)[i];
        if (x<=min)
        then y:=min
        else if (x>=max)
             then y:=max
             else y:=x;
        RealArray(output.buf^)[i]:=y
        end;
   end;

begin
  Transfer:=0;
  with iop[8]
  do begin
       size:=iop[2].size;
       buf:=MemPtr;
       case OwnType of
         zByte:TransferByte(iop[2],iop[8]);
         zInteger:TransferInteger(iop[2],iop[8]);
         zReal:TransferReal(iop[2],iop[8]);
       end; (* of case *)
     end
end;

(* - - - - Silencer - - - - *)
constructor tSilencer.Init(SystemP:pSystem;Num:integer);
begin
  TBlock.Init(SystemP,Num);
  owntype:=zReal;
  upper:=1;
  lower:=-1;
  Param:='-1.0000;1.0000';
end;

procedure tSilencer.SetDlg(HWindow:HWnd);
var  testo:array[0..127]of char;
     j:integer;
begin
  TBlock.SetDlg(HWindow);
  j:=1;
  GetPString(param,testo,j);inc(j);
  SetDlgItemText(HWindow,104,testo);
  GetPString(param,testo,j);inc(j);
  SetDlgItemText(HWindow,105,testo);
end;

procedure tSilencer.GetDlg(HWindow:HWnd;var st:string);
var  testo:array[0..127]of char;
begin
  GetDlgItemText(HWindow, 104, testo, sizeof(testo));
  st:=StrPas(testo);
  GetDlgItemText(HWindow, 105, testo, sizeof(testo));
  st:=st+';'+StrPas(testo);
end;

function tSilencer.StoreParam(HWindow:HWnd;var st:string;ErrString:PChar):boolean;
var sub:string;j:integer;
    code:integer;
     _lower,_upper:real;
begin
  StoreParam:=false;StrCopy(ErrString,BadFormat);
  j:=1;
  if not GetRValue(PS,st,j,_lower)then exit;inc(j);
  if not GetRValue(PS,st,j,_upper)then exit;inc(j);
  if (_upper <= _lower)
  then begin
       StrCopy(ErrString,'<upper> must be greater then <lower>');
       exit;
       end;
  lower:=_lower;
  upper:=_upper;
  StoreParam:=true;
end;

function TSilencer.Transfer(var iop:aiobuf):integer;

   procedure TransferByte(var input,output:tiobuf);
   var i:longint;
       _lower,_upper,x,y:byte;
   begin
     if lower>-127
     then _lower:=trunc(lower)+128
     else _lower:=1;  (* -127 *)
     if upper<127
     then _upper:=trunc(upper)+128
     else _upper:=255; (* +127 *)
     for i:=0 to input.size - 1
     do begin
        x:=ByteArray(input.buf^)[i];
        if (x<_lower)
        then y:=x-_lower
        else if (x>_upper)
             then y:=x-_upper
             else y:=0; (* 0 *)
        ByteArray(output.buf^)[i]:=y+128
        end;
   end;

   procedure TransferInteger(var input,output:tiobuf);
   var i:longint;
       _lower,_upper,x,y:integer;
   begin
     _lower:=trunc(lower);
     _upper:=trunc(upper);
     for i:=0 to input.size - 1
     do begin
        x:=IntegerArray(input.buf^)[i];
        if (x<_lower)
        then y:=x-_lower
        else if (x>_upper)
             then y:=x-_upper
             else y:=0;
        IntegerArray(output.buf^)[i]:=y
        end;
   end;

   procedure TransferReal(var input,output:tiobuf);
   var i:longint;
       x,y:real;
   begin
     for i:=0 to input.size - 1
     do begin
        x:=RealArray(input.buf^)[i];
        if (x<lower)
        then y:=x-lower
        else if (x>upper)
             then y:=x-upper
             else y:=0;
        RealArray(output.buf^)[i]:=y
        end;
   end;

begin
  Transfer:=0;
  with iop[8]
  do begin
       size:=iop[2].size;
       buf:=MemPtr;
       case OwnType of
         zByte:TransferByte(iop[2],iop[8]);
         zInteger:TransferInteger(iop[2],iop[8]);
         zReal:TransferReal(iop[2],iop[8]);
       end; (* of case *)
     end
end;

(* - - - - Quantizer - - - - *)
constructor tQuantizer.Init(SystemP:pSystem;Num:integer);
begin
  TBlock.Init(SystemP,Num);
  owntype:=zReal;
  quanto:=1;
  Param:='1.0000';
end;

procedure tQuantizer.SetDlg(HWindow:HWnd);
var  testo:array[0..127]of char;
     j:integer;
begin
  TBlock.SetDlg(HWindow);
  j:=1;
  GetPString(param,testo,j);inc(j);
  SetDlgItemText(HWindow,104,testo);
end;

procedure tQuantizer.GetDlg(HWindow:HWnd;var st:string);
var  testo:array[0..127]of char;
begin
  GetDlgItemText(HWindow, 104, testo, sizeof(testo));
  st:=StrPas(testo);
end;

function tQuantizer.StoreParam(HWindow:HWnd;var st:string;ErrString:PChar):boolean;
var sub:string;j:integer;
    code:integer;
    _quanto:real;
begin
  StoreParam:=false;StrCopy(ErrString,BadFormat);
  j:=1;
  if not GetRValue(PS,st,j,_quanto)then exit;inc(j);
  if _quanto <= 0
  then begin
       StrCopy(ErrString,'<quantum> must be a positive number');
       exit;
       end;
  quanto:=_quanto;
  StoreParam:=true;
end;

function TQuantizer.Transfer(var iop:aiobuf):integer;

   procedure TransferByte(var input,output:tiobuf);
   var i:longint;
       _quanto,half,x,y:integer;
   begin
     _quanto:=trunc(quanto);half:=_quanto div 2;
     for i:=0 to input.size - 1
     do begin
        x:=ByteArray(input.buf^)[i]-128;
        if x> 0
        then y:=((x+half)div _quanto)*_quanto
        else y:=-((half-x)div _quanto)*_quanto;
        ByteArray(output.buf^)[i]:=y+128
        end;
   end;

   procedure TransferInteger(var input,output:tiobuf);
   var i:longint;
       _quanto,half,x,y:integer;
   begin
     _quanto:=trunc(quanto);half:=_quanto div 2;
     for i:=0 to input.size - 1
     do begin
        x:=IntegerArray(input.buf^)[i];
        if x> 0
        then y:=((x+half)div _quanto)*_quanto
        else y:=-((half-x)div _quanto)*_quanto;
        IntegerArray(output.buf^)[i]:=y
        end;
   end;

   procedure TransferReal(var input,output:tiobuf);
   var i:longint;
   begin
     for i:=0 to input.size - 1
     do begin
        RealArray(output.buf^)[i]:=
                  round(RealArray(input.buf^)[i]/quanto)*quanto;
        end;
   end;

begin
  Transfer:=0;
  with iop[8]
  do begin
       size:=iop[2].size;
       buf:=MemPtr;
       case OwnType of
         zByte:TransferByte(iop[2],iop[8]);
         zInteger:TransferInteger(iop[2],iop[8]);
         zReal:TransferReal(iop[2],iop[8]);
       end; (* of case *)
     end
end;

(* - - - - Delay     - - - - *)
constructor tDelay.Init(SystemP:pSystem;Num:integer);
begin
  TBlock.Init(SystemP,Num);
  delay:=1;
  Param:='1';
end;

procedure tDelay.SetDlg(HWindow:HWnd);
var  testo:array[0..127]of char;
     j:integer;
begin
  TBlock.SetDlg(HWindow);
  j:=1;
  GetPString(param,testo,j);inc(j);
  SetDlgItemText(HWindow,104,testo);
end;

procedure tDelay.GetDlg(HWindow:HWnd;var st:string);
var  testo:array[0..127]of char;
begin
  GetDlgItemText(HWindow, 104, testo, sizeof(testo));
  st:=StrPas(testo);
end;

function tDelay.StoreParam(HWindow:HWnd;var st:string;ErrString:PChar):boolean;
var sub:string;j:integer;
     _delay:longint;
    code:integer;
begin
  StoreParam:=false;StrCopy(ErrString,BadFormat);
  j:=1;
  if not GetLValue(PS,st,j,_delay)then exit;inc(j);
  if _delay <= 0
  then begin
       StrCopy(ErrString,'<delay> must be a positive integer');
       exit;
       end;
  delay:=_delay;
  StoreParam:=true;
end;

function TDelay.Start(var prop:AIOprop;bufsize:longint;HWindow:HWnd):integer;
var result:integer;


begin
  result:=T1In1Out.Start(prop,bufsize,HWindow);
  if result = 0
  then begin
(*AP6*)EcoHandle:=AllocArray(delay,OwnType);
       if EcoHandle = 0
       then begin
            T1In1Out.Stop; (* free seized memory *)
            start:=4;
            exit;
            end;
       Eco.buf:=GlobalLock(EcoHandle);
       Eco.size:=delay;
       ZeroInit(Eco,OwnType);First:=0;
       end;
  Start:=result;
end;

function TDelay.Transfer(var iop:aiobuf):integer;
begin
  Transfer:=0;
  with iop[8]
  do begin
       size:=iop[2].size;
       buf:=MemPtr;
       if delay <= iop[2].size
       then begin
            movebuf(iop[8],Eco,0,0,delay,OwnType);
            movebuf(iop[8],iop[2],delay,-delay,iop[2].size-delay,OwnType);
            movebuf(Eco,iop[2],0,iop[2].size-delay,delay,OwnType);
            end
       else begin
            if first+iop[2].size > delay
            then begin
                 movebuf(iop[8],Eco,0,first,delay-first,OwnType);
                 movebuf(Eco,iop[2],first,-first,delay-first,OwnType);
                 movebuf(iop[8],Eco,delay-first,first-delay,iop[2].size-delay+first,OwnType);
                 movebuf(Eco,iop[2],0,delay-first,iop[2].size-delay+first,OwnType);
                 end
            else begin
                 movebuf(iop[8],Eco,0,first,iop[2].size,OwnType);
                 movebuf(Eco,iop[2],first,-first,iop[2].size,OwnType);
                 end;
            first:=(first+iop[2].size)mod delay;
            end
     end;
end;

procedure TDelay.Stop;
begin
if EcoHandle <> 0
then begin
     GlobalUnLock(EcoHandle);
     GlobalFree(EcoHandle);
     end;
T1In1Out.Stop;
end;

(* - - - - SRLimiter - - - - *)
constructor tSRLimiter.Init(SystemP:pSystem;Num:integer);
begin
  TBlock.Init(SystemP,Num);
  owntype:=zReal;
  max:=1;
  Param:='1.0000';
end;

procedure tSRLimiter.SetDlg(HWindow:HWnd); 
var  testo:array[0..127]of char;
     j:integer;
begin
  TBlock.SetDlg(HWindow);
  j:=1;
  GetPString(param,testo,j);inc(j);
  SetDlgItemText(HWindow,104,testo);
end;

procedure tSRLimiter.GetDlg(HWindow:HWnd;var st:string);
var  testo:array[0..127]of char;
begin
  GetDlgItemText(HWindow, 104, testo, sizeof(testo));
  st:=StrPas(testo);
end;

function tSRLimiter.StoreParam(HWindow:HWnd;var st:string;ErrString:PChar):boolean;
var sub:string;j:integer;
    code:integer;
    _max:real;
begin
  StoreParam:=false;StrCopy(ErrString,BadFormat);
  j:=1;
  if not GetRValue(PS,st,j,_max)then exit;inc(j);
  if _max <= 0
  then begin
       StrCopy(ErrString,'<max_slope> must be a positive number');
       exit;
       end;
  max:=_max;
  StoreParam:=true;
end;

function tSRLimiter.Start(var prop:AIOprop;bufsize:longint;HWindow:HWnd):integer;

begin
  Start:=T1In1Out.Start(prop,bufsize,HWindow);
  IntegerOldy:=0;RealOldy:=0;
end;

function tSRLimiter.Transfer(var iop:aiobuf):integer;

   procedure TransferByte(var input,output:tiobuf);
   var i:longint;
       x,_max:integer;
   begin
     _max:=trunc(max);
     for i:=0 to input.size - 1
     do begin
        x:=ByteArray(input.buf^)[i]-128;
        if abs(x-IntegerOldy) <= _max
        then IntegerOldy:=x
        else if x > IntegerOldy
             then Inc(IntegerOldy,_max)
             else Dec(IntegerOldy,_max);
        ByteArray(output.buf^)[i]:=IntegerOldy+128;
        end;
   end;

   procedure TransferInteger(var input,output:tiobuf);
   var i:longint;
       x,_max:integer;
   begin
     _max:=trunc(max);
     for i:=0 to input.size - 1
     do begin
        x:=IntegerArray(input.buf^)[i];
        if abs(x-IntegerOldy) <= _max
        then IntegerOldy:=x
        else if x > IntegerOldy
             then Inc(IntegerOldy,_max)
             else Dec(IntegerOldy,_max);
        IntegerArray(output.buf^)[i]:=IntegerOldy
        end;
   end;

   procedure TransferReal(var input,output:tiobuf);
   var i:longint;
       x:real;
   begin
     for i:=0 to input.size - 1
     do begin
        x:=RealArray(input.buf^)[i];
        if abs(x-RealOldy) <= max
        then RealOldy:=x
        else if x > RealOldy
             then RealOldy:=RealOldy+max
             else RealOldy:=RealOldy-max;
        RealArray(output.buf^)[i]:=RealOldy
        end;
   end;

begin
  Transfer:=0;
  with iop[8]
  do begin
       size:=iop[2].size;
       buf:=MemPtr;
       case OwnType of
         zByte:TransferByte(iop[2],iop[8]);
         zInteger:TransferInteger(iop[2],iop[8]);
         zReal:TransferReal(iop[2],iop[8]);
       end; (* of case *)
     end
end;


(* - - - - ZeroHold  - - - - *)
constructor tZeroHold.Init(SystemP:pSystem;Num:integer);
begin
  TBlock.Init(SystemP,Num);
  period:=1;
  Param:='1';
end;

procedure TZeroHold.SetDlg(HWindow:HWnd);
var  testo:array[0..127]of char;
     j:integer;
begin
  TBlock.SetDlg(HWindow);
  j:=1;
  GetPString(param,testo,j);inc(j);
  SetDlgItemText(HWindow,104,testo);
end;

procedure TZeroHold.GetDlg(HWindow:HWnd;var st:string);
var  testo:array[0..127]of char;
begin
  GetDlgItemText(HWindow, 104, testo, sizeof(testo));
  st:=StrPas(testo);
end;

function tZeroHold.StoreParam(HWindow:HWnd;var st:string;ErrString:PChar):boolean;
var sub:string;j:integer;
     _period:longint;
    code:integer;
begin
  StoreParam:=false;StrCopy(ErrString,BadFormat);
  j:=1;
  if not GetLValue(PS,st,j,_period)then exit;inc(j);
  if _period <= 0
  then begin
       StrCopy(ErrString,'<period> must be a positive integer');
       exit;
       end;
  period:=_period;
  StoreParam:=true;
end;

function TZeroHold.Start(var prop:AIOprop;bufsize:longint;HWindow:HWnd):integer;

begin
  Start:=T1In1Out.Start(prop,bufsize,HWindow);
  counter:=0;
end;

function TZeroHold.Transfer(var iop:aiobuf):integer;

   procedure TransferByte(var input,output:tiobuf);
   var i:longint;
   begin
     for i:=0 to input.size - 1
     do begin
        if counter = 0
        then begin
             ByteOldy:=ByteArray(input.buf^)[i];
             counter:=period;
             end;
        dec(counter);
        ByteArray(output.buf^)[i]:=byteOldy
        end;
   end;

   procedure TransferInteger(var input,output:tiobuf);
   var i:longint;
   begin
     for i:=0 to input.size - 1
     do begin
        if counter = 0
        then begin
             IntegerOldy:=IntegerArray(input.buf^)[i];
             counter:=period;
             end;
        dec(counter);
        IntegerArray(output.buf^)[i]:=IntegerOldy
        end;
   end;

   procedure TransferReal(var input,output:tiobuf);
   var i:longint;
   begin
     for i:=0 to input.size - 1
     do begin
        if counter = 0
        then begin
             RealOldy:=RealArray(input.buf^)[i];
             counter:=period;
             end;
        dec(counter);
        RealArray(output.buf^)[i]:=RealOldy
        end;
   end;

begin
  Transfer:=0;
  with iop[8]
  do begin
       size:=iop[2].size;
       buf:=MemPtr;
       case OwnType of
         zByte:TransferByte(iop[2],iop[8]);
         zInteger:TransferInteger(iop[2],iop[8]);
         zReal:TransferReal(iop[2],iop[8]);
       end; (* of case *)
     end
end;



(* - - - - TMean - - - - *)

const zNMean=2;

constructor TMean.Init(SystemP:pSystem;Num:integer);
begin
  TBlock.Init(SystemP,Num);
  cumulative:=1; (* cumulativo *)
  Param:='1';
end;

procedure TMean.Capability(var Attr:TAttrDev;var IOClass:TAIOClass);
var i:integer;
begin
  TBlock.Capability(Attr,IOClass);
  IOClass[2]:=zInput;
  IOClass[8]:=zOutput;
end;

function TMean.Check(var prop:AIOprop):integer;
begin
  if  (prop[2].attr and zMaskComplex <> zSimple)
  then Check:=5
  else Check:=0;
  prop[8].fsample:=0;
  prop[8].attr:=zSimple or zSampled or zReal;
end;

function TMean.Start(var prop:AIOprop;bufsize:longint;HWindow:HWnd):integer;
var result:integer;
begin
  result:=Check(prop);
  if result = 0
  then begin
       InputType:=prop[2].attr and zMaskType;
       ownsize:=bufsize;
       sum:=0;sum2:=0;nsamples:=0;
       end;
  start:=result;
end;

function TMean.Transfer(var iop:aiobuf):integer;

  procedure median(a:tiobuf);
  (* calcola il valor medio di <a>
  *)
  var i:longint;
      x:real;
  begin
  if cumulative = 0
  then begin
       nsamples:=0;
       sum:=0;
       sum2:=0;
       end;
  case InputType of
    zByte: for i:=0 to a.size-1
           do begin
                x:=ByteArray(a.buf^)[i]-128;
                sum:=sum+x;
                sum2:=sum2+sqr(x);
              end;
    zInteger: for i:=0 to a.size-1
           do begin
                x:=IntegerArray(a.buf^)[i];
                sum:=sum+x;
                sum2:=sum2+sqr(x);
              end;
    zReal: for i:=0 to a.size-1
           do begin
                x:=RealArray(a.buf^)[i];
                sum:=sum+x;
                sum2:=sum2+sqr(x);
              end;
    end; (* of case *)
    inc(nsamples,a.size);
  end;

begin
  Transfer:=0;
  median(iop[2]);
  iop[8].size:=zNMean;
  iop[8].buf:=@Mean;
  Mean[0]:=sum/nsamples;
  Mean[1]:=sqrt(sum2/nsamples-sqr(sum/nsamples));
end;

function TMean.StoreParam(HWindow:HWnd;var st:string;ErrString:PChar):boolean;
(* FORMAT: title;cumulative;mode

           cumulative:0-1
           mode:2       (valor medio e deviazione standard)
*)
var sub:string;j:integer;
    code:integer;
begin
  StoreParam:=false;StrCopy(ErrString,BadFormat);
  j:=1;
  if not GetIValue(PS,st,j,cumulative)then exit;inc(j);
  StoreParam:=true;
end;

procedure TMean.SetDlg(HWindow:HWnd); { AP13 }
var  testo:array[0..127]of char;
     j:integer;
begin
  TBlock.SetDlg(HWindow);
  j:=1;
  GetPString(param,testo,j);inc(j);
  SendDlgItemMessage(HWindow, 104, bm_SetCheck, ord(testo[0])-ord('0'), 0);
end;

procedure TMean.GetDlg(HWindow:HWnd;var st:string);
begin
  Str(SendDlgItemMessage(HWindow, 104, bm_GetCheck, 0, 0),st);
end;


(* - - - - TDiff  - - - - *)

function TDiff.Start(var prop:AIOprop;bufsize:longint;HWindow:HWnd):integer;

begin
  Start:=T1In1Out.Start(prop,bufsize,HWindow);
  RealOldx:=0;
  IntegerOldx:=0;
end;

function TDiff.Transfer(var iop:aiobuf):integer;

   procedure TransferByte(var input,output:tiobuf);
   var i:longint;
       x:integer;
   begin
     for i:=0 to input.size - 1
     do begin
        x:=ByteArray(input.buf^)[i]-128;
        ByteArray(output.buf^)[i]:=x-Integeroldx+128;
        Integeroldx:=x;
        end;
   end;

   procedure TransferInteger(var input,output:tiobuf);
   var i:longint;
       x:integer;
   begin
     for i:=0 to input.size - 1
     do begin
        x:=IntegerArray(input.buf^)[i];
        IntegerArray(output.buf^)[i]:=x-Integeroldx;
        Integeroldx:=x;
        end;
   end;

   procedure TransferReal(var input,output:tiobuf);
   var i:longint;
       x:real;
   begin
     for i:=0 to input.size - 1
     do begin
        x:=RealArray(input.buf^)[i];
        RealArray(output.buf^)[i]:=x-Realoldx;
        Realoldx:=x;
        end;
   end;

begin
  Transfer:=0;
  with iop[8]
  do begin
       size:=iop[2].size;
       buf:=MemPtr;
       case OwnType of
         zByte:TransferByte(iop[2],iop[8]);
         zInteger:TransferInteger(iop[2],iop[8]);
         zReal:TransferReal(iop[2],iop[8]);
       end; (* of case *)
     end
end;

(* - - - - TAcc  - - - - *)

function TAcc.Start(var prop:AIOprop;bufsize:longint;HWindow:HWnd):integer;

begin
  Start:=T1In1Out.Start(prop,bufsize,HWindow);
  RealOldy:=0;
  IntegerOldy:=0;
end;


function TAcc.Check(var prop:AIOprop):integer;
var result:integer;
begin
  result:=T1In1Out.Check(prop);
  if result = 0
  then begin
       InputType:=prop[2].attr and zMaskType;
       if InputType = zByte
       then OwnType:=zInteger
       else OwnType:=InputType;
       prop[8].attr:=prop[2].attr and not zMaskType or Owntype;
       prop[8].fsample:=prop[2].fsample;
       end;
  Check:=result;
end;

function TAcc.Transfer(var iop:aiobuf):integer;

   procedure TransferByte(var input,output:tiobuf);
   var i:longint;
   begin
     for i:=0 to input.size - 1
     do begin
        inc(IntegerOldy,ByteArray(input.buf^)[i]-128);
        IntegerArray(output.buf^)[i]:=IntegerOldy;
        end;
   end;

   procedure TransferInteger(var input,output:tiobuf);
   var i:longint;
   begin
     for i:=0 to input.size - 1
     do begin
        inc(IntegerOldy,IntegerArray(input.buf^)[i]);
        IntegerArray(output.buf^)[i]:=Integeroldy;
        end;
   end;

   procedure TransferReal(var input,output:tiobuf);
   var i:longint;
   begin
     for i:=0 to input.size - 1
     do begin
        RealOldy:=RealOldy+RealArray(input.buf^)[i];
        RealArray(output.buf^)[i]:=Realoldy;
        end;
   end;

begin
  Transfer:=0;
  with iop[8]
  do begin
       size:=iop[2].size;
       buf:=MemPtr;
       case InputType of
         zByte:TransferByte(iop[2],iop[8]);
         zInteger:TransferInteger(iop[2],iop[8]);
         zReal:TransferReal(iop[2],iop[8]);
       end; (* of case *)
     end
end;


begin
  Display1Proc := MakeProcInstance(@Display1, HInstance);
  DeskX:=0;DeskY:=0;
  Register_Function('random',rnd);
end.