unit WSobj;
(* 5555: aggiunte per il supporto argomenti MACRO *)

{ AP2: Ottimizzare TSystem.BuildMBranch.Update
  AP3: rimuovere l'uso dell'array <Objs>
  AP4: il flag deve essere ripristinato al vecchio valore
  AP5: La procedura .FirstThat deve essere potenziata 
  AP6: verificare la priorita' degli errori
  AP7: estendere le strutture array oltre i 64K  (BP 7.0?)
  AP8: gestire il caso in cui <@Self> sia spostato sull'altro estremo di un branch
  AP9: ObjIdPeak tende a crescere senza controllo
  AP10: usare un <PChar> invece del tipo <String>
}
{
 This unit contains the basic element of a WinSound
 SYSTEM: objects, hooks and branches

 L.C. 6-1994 Ver 0.4

 Used by WSwnd.PAS, WSDLL.PAS

 Last revision date: 16-3-1997
   Ver 0.4:   Le procedure <GetIValue>, <GetLValue>
              e <GetRValue> sono state introdotte
              per il parsing della stringa param.
   Ver 0.41:  La procedure <OpenWave> e' stata
              migliorata. 
}

interface
uses WObjects, WinTypes, WinProcs, WinDos, Strings;

const zStep = 8; (* usato come minima distanza fra due entita' *)
      zStep2 = 4; (* zStep div 2 *)
      zSizeX = 8; zSizeY=zSizeX; (* dimensione BITMAP oggetti rapportata a <zStep> *)
      MaxTerminal = 12; (* Numero massimo di terminali per oggetto *)
      zTerminal = $8000; (* Il codice di un terminale e' pari a
                            numero_oggetto + zTerminal *) 
      zTooManyBranches = 1;
      zCollision = 2;
      zNoOutput = 3;
      zEmpty = 4;
      zVacantInput = 5;
      zShortedIO = 6;
      zVacantIO = 7;
      zLoop = 8;

{ TIOClass e' una variabile strutturata contenente
  le proprieta' invarianti dei terminali:
  Bit 0: Input
  Bit 1: Output
}
type tIOClass = word;
     TAIOClass = array[1..MaxTerminal]of TIOClass;

{ TAttrDev e' una variabile strutturata contenente
  le proprieta' base dell'oggetto:
}
type TAttrDev = word;
{ TIOAttr e' una variabile strutturata contenente
  le proprieta' base dei terminali:
  Bits 0-1: 0=byte,1:integer,2:real
  Bit 3: 0=not sampled, 1=sampled
  Bit 4: 0=simple,1=complex
  Bits 5-7: reserved=0

}
     TAttr = word;
     TAttrIO = array[1..MaxTerminal]of TAttr;

const zInput = 1;
      zOutput = 2;

      zMaskType = 3;
      zMaskSampled = 8;
      zMaskComplex = $10;

(* il valore 0 e' riservato a 'tipo non definito' *)
      zByte = 1;
      zInteger = 2;
      zReal = 3;

      zSimple = 0;
      zComplex = 16;

      zSampled = 8;

      zNone = 0;

type TFileName = array[0..fsPathName] of Char;
(* begin: 5555*)
const MaxSizeOfList=4;                   { Dimensione della tavola degli identificatori }
type namet=string[15];                   { tipo di identificatore  }

type Item=record                         { Elemento della tavola degli identificatori }
            Name:namet;
            value:real
          end; { of Item }
     List=array[1..MaxSizeOfList]of Item;
(* end: 5555*)

(* AP7: estendere le strutture array oltre i 64K*)
type RealArray = array[0..10921]of Real;
     IntegerArray = array[0..32766]of Integer;
     ByteArray = array[0..65534]of Byte;

(* tiobuf e' usato per individuare un buffer di analisi *)
type  tiobuf=record
              buf:pointer;
              size:longint;
            end;
      Aiobuf=array[1..MaxTerminal]of tiobuf;
      TProp = record
              fsample:longint;
              attr:TAttr;
              end;
      AIOprop = array[1..MaxTerminal]of TProp;

type pBase=^tBase;
     pSystem=^tSystem;
     tBase=object(TObject)   { Tipo base per gli oggetti tHook e tObj }
            num:word;           (* READ-ONLY *)
            IsLinkable:boolean; (* READ-ONLY *)
            x,y:integer;        (* READ-ONLY *)
            constructor Init(xx,yy:integer;id:word;system:PSystem);
            procedure Draw(PaintDC:HDC);virtual; (* Must be overriden !*)
(* <TestPoint> and <DrawFocus> should be overriden for SELECT function *)
            function TestPoint(xx,yy:integer):boolean;virtual; 
            procedure DrawFocus(HandleDC:HDC;var Pos:TPoint);virtual;
(* <DBLCLK> should be overriden to activate the DOUBLE-CLICK function. DOUBLE-CLICK requires the SELECT *)
            procedure DBLCLK(WinP:pWindow);virtual;
            procedure Move(newx,newy:integer);virtual;
(* <Delete> should be overriden for CUT function *)
            procedure Delete;virtual;
            procedure Unbind;virtual;
            procedure Copy;virtual;
           private
            sys:pSystem;
           end;
     pHook=^tHook;
     tHook=object(TBase)
(* per questi oggetti il campo <num> ha i seguenti significati:
       1..12:             System IO terminal
       13..zTerminal-1:   hook
       zTerminal..:       Object IO terminal (Obj.num+zTerminal)
*)
            mark:integer; (* used only for m-brach marking *)
            constructor Init(xx,yy:integer;id:word;system:PSystem);
            destructor Done;virtual;
            procedure Move(newx,newy:integer);virtual;
            procedure Draw(PaintDC:HDC);virtual;
            function TestPoint(xx,yy:integer):boolean;virtual;
            procedure DrawFocus(HandleDC:HDC;var Pos:TPoint);virtual;
            procedure Delete;virtual;
            procedure DBLCLK(WinP:pWindow);virtual;
            procedure Unbind;virtual;
           end;
     pLink=^tLink;
     tLink=object(TBase)
            link:pLink;
            constructor Init(xx,yy:integer;id:word;system:PSystem;lnk:pLink);
            destructor Done;virtual;
            procedure Move(newx,newy:integer);virtual;
           private
            moved:boolean; (* Flag necessario per evitare un LOOP nella MOVE di oggetti LINKED *)
           end;
     pText=^tText;
     tText=object(tLink)
            Str:PChar;
            procedure Draw(PaintDC:HDC);virtual;
            function TestPoint(xx,yy:integer):boolean;virtual;
            procedure DrawFocus(HandleDC:HDC;var Pos:TPoint);virtual;
            procedure DBLCLK(WinP:pWindow);virtual;
            destructor Done;virtual;
            procedure Delete;virtual;
            procedure Copy;virtual;
           private
            _width,_height:integer;
           end;
     pObj= ^tObj;
(* TOut puo' avere is seguenti significati:

   obj=nil ,terminal=0   <==> nothing
   obj=nil ,terminal<>0  <==> system input
   obj<>nil              <==> object output
*)   
     TOut=record
             obj:pObj;
             terminal:integer;
             end;
     tObj= object(tLink)
             pqwe:pointer;
             iobuf:AIObuf; (*used only for analysis *)
             ioprop:AIOprop; (*used only for analysis *)
             Terminal:array[1..MaxTerminal]of phook;
             backward:array[1..MaxTerminal]of TOut;
             next:pObj; (* used only for analysis *)
             procedure Draw(PaintDC:HDC);virtual;
             function TestPoint(xx,yy:integer):boolean;virtual;
             procedure DrawFocus(HandleDC:HDC;var Pos:TPoint);virtual;
             procedure Unbind;virtual;
             procedure Move(newx,newy:integer);virtual;
             constructor Init(xx,yy:integer;id:word;qwe:pointer;system:PSystem);
             destructor Done;virtual;
             procedure DBLCLK(WinP:pWindow);virtual;
             procedure Delete;virtual;
             procedure Copy;virtual;
           end;
     pBranch=^tBranch;
     tBranch=object(TObject)
            pA,pB:pHook;
            procedure Draw(PaintDC:HDC);
            constructor Init(A,B:pHook);
           end;

     tSystem=object
          pobjlist,phooklist,pbranchlist,ptextlist:pCollection;
(* begin: Aggiunto per il supporto MACRO *)
          Terminal:array[1..MaxTerminal]of pHook;
          TypeIO:TAIOClass;
          Back:array[1..MaxTerminal]of tOut;
          MacroVar:List; (* 5555 *)
          LastVar:integer; (* 5555 *)
(* end: Aggiunto per il supporto MACRO *)

          blockSize:longint;
          HookIdPeak:integer; (* used as next value for <id> of an hook *)
          ObjIdPeak:integer; (* used as next value for <id> of an obj *)

          function Find_Id(name:namet):integer; (*5555*)
          function RegisterVar(var s:string):boolean; (*5555*)

          constructor Init;
          procedure ReadObj(var s:string);
          procedure ReadHook(var s:string);
          procedure ReadText(var s:string);
          function WriteSystem(fn:PChar):boolean;
          function ReadSystem(fn:PChar):boolean;
          procedure ReadBranch(var s:string);
          destructor Done;virtual;

          function IOCount:integer;

          function CheckSystem(var start:pObj):integer;
          function BuildMBranch:integer;
          function SystemSort:pobj;
        end;

type  TResult = Word;
const zReUndef = 1;
      zReWrongFormat = 2;
      zReUnsupported = 3;
      zReCongestion  = 4;
      zReIncompatible = 5;
      zReMacroError = 6;

(* result = 0 : ok
          = 1 : something has not been defined (e.g.:filename='')
          = 2 : wrong format (e.g. corrupted file )
          = 3 : unsupported format (e.g. 16-bit audio on 8-bit board)
          = 4 : unable to seize buffers/resources
          = 5 : connected terminals are incompatible (fsample/ioattr)
          = 6 : macro internal error
*)

function GetIValue(PS:pSystem;var s:string;var i:integer;var value:integer):boolean;
function GetLValue(PS:pSystem;var s:string;var i:integer;var value:longint):boolean;
function GetRValue(PS:pSystem;var s:string;var i:integer;var value:real):boolean;
procedure GetPString(var s:string;pSub:pChar;var i:integer);


procedure _LongRead(TheFile: integer;
  MemPtr: Pointer; BitsByteSize: Longint);
function OpenWave(var f:integer;fn:pChar;var fsample,nsample:longint):integer;
procedure LongWrite(var TheFile: file;
  MemPtr: Pointer; BitsByteSize: Longint);
function WriteHeader(var f:file;fn:TFileName;fsample,nsample:longint):integer;
function CheckSys(var scan:pObj;prop:AIOprop):integer;
function StartSys(var scan:pObj;prop:AIOprop;BlockSize:longint;HWindow:HWnd):integer;

var SystemBuffer:string;  (* used for Copy/Paste in TSystemWindow *)

implementation


(*-------------- External ---------------*)
{ __ahIncr, ordinal 114, is a 'magic' function. Defining this
  function causes Windows to patch the value into the passed
  reference.  This makes it a type of global variable. To use
  the value of AHIncr, use Ofs(AHIncr). }
procedure AHIncr; far; external 'KERNEL' index 114;
procedure NewFromStr(var p:pointer;var st:string;j:integer;SystemP:pSystem);far;external 'WSDLL';
procedure Capability(p:pointer;var Attr:TAttrDev;var IOClass:TAIOClass);far;external 'WSDLL';
procedure DisposeObj(var p:pointer);far;external 'WSDLL';
procedure Obj2Str(p:pointer;var Dest:string);far;external 'WSDLL';
function DialogObj(HWindow:HWnd;pqwe:pointer):integer;far;external 'WSDLL';
procedure DrawObj(p:Pointer; DC: HDC; BMP: TPoint);far;external 'WSDLL';
function CheckObj(p:pointer;var prop:AIOprop):TResult;far;external 'WSDLL';
function StartAnalysis(p:pointer;var prop:AIOprop;bufsize:longint;HWindow:HWnd):TResult;far;external 'WSDLL';
procedure StopAnalysis(p:pointer);far;external 'WSDLL';

type
  PTTextDialog = ^TTextDialog;
  TTextDialog = object(TDialog)
    TextP:pText;
    constructor Init(AParent: PWindowsObject; AName: PChar; p:pText);
    procedure SetUpWindow; virtual;
    procedure Ok(var Msg:TMessage);virtual id_first+id_ok;
  end;

  PTHookDialog = ^THookDialog;
  THookDialog = object(TDialog)
    HookP:pHook;
    constructor Init(AParent: PWindowsObject; AName: PChar; p:pHook);
    procedure SetUpWindow; virtual;
    procedure Ok(var Msg:TMessage);virtual id_first+id_ok;
  end;


{--------------- TBase -------------}
constructor tBase.Init(xx,yy:integer;id:word;system:PSystem);
begin
  x:=xx;y:=yy;
  num:=id;
  sys:=system;
  IsLinkable:=false;
end;

procedure tBase.Delete;
begin
end;

procedure tBase.Unbind;
begin
end;

procedure tBase.Copy;
begin
end;

procedure tBase.Move(newx,newy:integer);
begin
  x:=newx;
  y:=newy;
end;

function tBase.TestPoint(xx,yy:integer):boolean;
begin
  TestPoint:=false; (* NO SELECT *)
end;

procedure tBase.DBLCLK(WinP:pWindow);
begin
  (* NO DBLCLK *)
end;

procedure tBase.DrawFocus(HandleDC:HDC;var Pos:TPoint);
begin
  (* NO SELECT *)
end;

procedure tBase.Draw(PaintDC:HDC);
begin
  Abstract;
end;

{--------------- TBranch -------------}
constructor tBranch.Init(A,B:pHook);
begin
  pA:=A;
  pB:=B;
end;


procedure tBranch.Draw(PaintDC:HDC);
begin
       MoveTo(PaintDC,zStep*pA^.x,zStep*pA^.y);
       LineTo(PaintDC,zStep*pB^.x,zStep*pB^.y);
end;


{--------------- TText -------------}
destructor TText.Done;
begin
  StrDispose(Str);
  tLink.Done;
end;

procedure TText.DBLCLK(WinP:pWindow);
begin
  Application^.ExecDialog(new(PTTextDialog,init(WinP,'Text',@Self)));
end;

procedure TText.Delete;
begin
  Sys^.pTextList^.Free(@Self);
end;

function TText.TestPoint(xx,yy:integer):boolean;
begin
  TestPoint:=(zStep * x  <= xx)and(zStep * x + _width > xx)and
            (zStep * y <= yy)and(zStep * y + _height > yy);
end;

procedure TText.DrawFocus(HandleDC:HDC;var Pos:TPoint);
var tr:TRect;
begin
    tr.top:=Pos.y;
    tr.left:=Pos.x;
    tr.bottom:=Pos.y+_height;
    tr.right:=Pos.x+_width;
    DrawFocusRect(HandleDC,tr);
end;

procedure TText.Draw(PaintDC:HDC);
var TextExt:longint;
begin
       TextOut(PaintDC, X*zStep, Y*zStep, str, strlen(str));
       TextExt:=GetTextExtent(PaintDC, str, strlen(str));
       _height:=Hiword(TextExt);
       _width:=loword(TextExt);
end;

procedure TText.Copy;
begin
  SystemBuffer:=StrPas(Str);
  Insert('t;;0,0;',SystemBuffer,1);
end;

{--------------- tLink -------------}
constructor tLink.Init(xx,yy:integer;id:word;system:PSystem;lnk:pLink);
begin
  TBase.Init(xx,yy,id,system);
  link:=lnk;moved:=false;
  if (link<>nil)and link^.IsLinkable
  then begin
       link^.link:=@self;
       link^.IsLinkable:=false;
       end;
  sys:=system;
end;

procedure tLink.Move(newx,newy:integer);
begin
  if (link <> nil)and not link^.moved
  then begin
       moved:=true;
       link^.Move(link^.x+newx-x,link^.y+newy-y);
       moved:=false;
       end;
  TBase.Move(newx,newy);
end;

destructor tLink.Done;
begin
  TBase.Done;
  if link <> nil
  then begin
       link^.link:=nil;
       (*IsLinkable:=true;*) (*AP4: il flag deve essere ripristinato al vecchio valore *)
       end;
end;

{--------------- TObj -------------}
constructor tObj.Init(xx,yy:integer;id:word;qwe:pointer;system:PSystem);
const n_to_x:array[1..MaxTerminal]of integer=
             (0,0,0,2,4,6,8,8,8,6,4,2);
const n_to_y:array[1..MaxTerminal]of integer=
             (2,4,6,8,8,8,6,4,2,0,0,0);
var i:integer;
    pTerminal:pHook;
    Attr:TAttrDev;
    AttrIO:TAIOClass;
begin
  if id = 0 (* NEW ID REQUESTED *)
  then begin
       id:=system^.ObjIdPeak;
       inc(system^.ObjIdPeak);
       end
  else if id >= system^.ObjIdPeak
       then system^.ObjIdPeak:=id+1;
  tLink.Init(xx,yy,id,system,nil);
  IsLinkable:=true;
  pqwe:=qwe;
  Capability(pqwe,Attr,AttrIO);
  for i:=1 to MaxTerminal
  do if AttrIO[i]<>0
     then begin
        pTerminal:=New(PHook,Init(xx+n_to_x[i],yy+n_to_y[i],num+zTerminal,system));
        Terminal[i]:=pTerminal;
        System^.pHookList^.insert(pTerminal);
        end
     else Terminal[i]:=nil;
end;

procedure tObj.Unbind;
var i:integer;
begin
  for i:=1 to MaxTerminal
  do if terminal[i]<>nil
     then terminal[i]^.Unbind;
end;

procedure tObj.DrawFocus(HandleDC:HDC;var Pos:TPoint);
var tr:TRect;
begin
    tr.top:=Pos.y;
    tr.left:=Pos.x;
    tr.bottom:=Pos.y + 64;
    tr.right:=Pos.x + 64;
    DrawFocusRect(HandleDC,tr);
end;

destructor tObj.Done;
begin
  if num+1 = sys^.ObjIdPeak
  then dec(sys^.ObjIdPeak);  (* AP9: ObjIdPeak tende a crescere *)
  if link <> nil
  then begin
       link^.Delete;(* remove linked text *)
       link:=nil;
       end;
  DisposeObj(pqwe);
  tLink.Done;
end;

procedure tObj.Delete;
var i:integer;
begin
 Unbind;
 for i:=1 to MaxTerminal
 do if terminal[i]<>nil
    then Sys^.pHookList^.Free(terminal[i]);
 Sys^.pObjList^.Free(@Self)
end;

function tObj.TestPoint(xx,yy:integer):boolean;
begin
  TestPoint:=(zStep * x + zStep2 <= xx)and(zStep * x + 64 - zStep2 > xx)and
            (zStep * y + zStep2 <= yy)and(zStep * y + 64 - zStep2 > yy);
end;


procedure tObj.Move(newx,newy:integer);
var dx,dy,i:integer;
begin
  dx:=newx-x;
  dy:=newy-y;
  for i:=1 to MaxTerminal
  do if Terminal[i] <> nil
     then with Terminal[i]^
          do begin
             inc(x,dx);
             inc(y,dy);
             end;
  tLink.Move(newx,newy);
end;

procedure tObj.DBLCLK(WinP:pWindow);
begin
  DialogObj(Winp^.HWindow,pqwe);
end;

procedure tObj.Draw(PaintDC:HDC);
var
    Pos:TPoint;
begin
    Pos.x:=X*zStep;
    Pos.y:=Y*zStep;
    DrawObj(pqwe, PaintDC, Pos);
end;

procedure tObj.Copy;
begin
  Obj2Str(pqwe,SystemBuffer);
  Insert('u0;0,0;',SystemBuffer,1);
end;


{--------------- THook -------------}

function THook.TestPoint(xx,yy:integer):boolean;
begin
  if num <= zTerminal 
  then TestPoint:=(zStep * x - zStep2 <= xx)and(zStep * x + zStep2 > xx)and
            (zStep * y - zStep2 <= yy)and(zStep * y + zStep2 > yy)
  else TestPoint:=false;
end;

procedure THook.DrawFocus(HandleDC:HDC;var Pos:TPoint);
var tr:TRect;
begin
    tr.top:=Pos.y - zStep2;
    tr.left:=Pos.x - zStep2;
    tr.bottom:=Pos.y + zStep2;
    tr.right:=Pos.x + zStep2;
    DrawFocusRect(HandleDC,tr);
end;

procedure THook.Draw(PaintDC:HDC);
  var s:array[0..7]of char;
  begin
    if (num <= MaxTerminal) (* System IO terminal *)
    then begin
         Str(num,S);
         TextOut(PaintDC, X*zStep, Y*zStep, s, strlen(s));
         end;
    Rectangle(PaintDC,zStep*x-1,zStep*y-1,zStep*x+2,zStep*y+2);
end;

destructor THook.Done;
begin
  if num <= MaxTerminal (* System IO terminal *)
  then Sys^.Terminal[num]:=nil;
  tBase.Done;
end;

constructor THook.Init(xx,yy:integer;id:word;system:PSystem);
begin
  TBase.Init(xx,yy,id,system);
  if num <= MaxTerminal (* System IO terminal *)
  then System^.Terminal[num]:=@self;
end;

procedure THook.Unbind;
var i:integer;
     procedure Remove(Item: PBranch); far;
     begin
       if (Item^.pA = @Self)or(Item^.pB = @Self)
       then Sys^.pBranchList^.Free(Item)
       else inc(i);
     end;
begin
  with Sys^.pBranchList^
  do begin
     i:= 0;
     while (i < Count)
     do Remove(At(i));
     end;
end;

procedure THook.Delete;
begin
  Unbind;
  Sys^.pHookList^.Free(@Self);
end;

procedure THook.DBLCLK(WinP:pWindow);
begin
  if Num <= MaxTerminal
  then Application^.ExecDialog(new(PTHookDialog,init(WinP,'SysHook',@Self)));
end;

procedure tHook.Move(newx,newy:integer);
var hook2:phook;
(* AP8: gestire il caso in cui <@Self> sia spostato sull'altro estremo di un branch *) 
     procedure ChangeHookRef(Item: PBranch); far;
     begin
       if Item^.pA = hook2
       then Item^.pA:= @Self
       else if Item^.pB = hook2
            then Item^.pB:= @Self
     end;

     function Hit(Item: pBase): Boolean; far;
     begin
       Hit:=Item^.TestPoint(newx * zStep - zStep2,newy * zStep - zStep2);
     end;

begin
  hook2:=Sys^.pHookList^.FirstThat(@Hit);
  if (hook2 <> nil)and(hook2<>@Self)
  then begin
         Sys^.pBranchList^.ForEach(@ChangeHookRef);
         Sys^.pHookList^.Free(hook2);
       end;
  tBase.Move(newx,newy);
end;


{--------------- TSystem -------------}
constructor tSystem.Init;
var i:integer;
begin
  New(ptextlist,Init(4,2));
  New(pobjlist,Init(8,4));
  New(phooklist,Init(16,8));
  New(pbranchlist,Init(8,4));
  HookIdPeak:=13; (* VALUES 1..12 ARE RESERVED BY SYSTEM TERMINAL ! *)
  ObjIdPeak:=1;   (* VALUE 0 IS USED TO REQUEST A NEW ID *)
(* begin: Aggiunto per il supporto MACRO *)
  for i:=1 to MaxTerminal
  do Terminal[i]:=nil;
  LastVar:=0; (*5555*)
(* end: Aggiunto per il supporto MACRO *)
  blockSize:=1024; 
end;

procedure GetString(var s,sub:string;var i:integer);
(* This procedure fetch from string <s> a substring <sub> *)
var j:integer;
begin
j:=0;
while (i<=length(s))and(s[i]<>';')
do begin
   inc(j);
   sub[j]:=s[i];
   inc(i);
   end;
sub[0]:=char(j);
end;

function GetNumber(var s:string;var i:integer):integer;
(* This function fetch from string <s> an integer value *)
var ris:integer;
    sign:boolean;
begin
ris:=0;
if s[i]='-'
then begin
     sign:=true;
     inc(i);
     end
else sign:=false;
while (i<=length(s))and(s[i] in ['0'..'9'])
do begin
   ris:=ris*10+ord(s[i])-ord('0');
   inc(i);
   end;
if sign
then ris:=-ris;
GetNumber:=ris;
end;

procedure tSystem.ReadObj(var s:string);
var id,x,y,i,blockid:integer;
    pqwe:pointer;
begin
  i:=2;
  id:=GetNumber(s,i);inc(i);
  x:=GetNumber(s,i);inc(i);
  y:=GetNumber(s,i);inc(i);
  NewFromStr(pqwe,s,i,@Self); (* 5555: added @Self *)
  pObjList^.insert(New(PObj,Init(x,y,id,pqwe,@Self)));
end;

procedure tSystem.ReadHook(var s:string);
var id,x,y,i:integer;
    pt:pHook;
begin
  i:=2;
  id:=GetNumber(s,i);inc(i);
  if id >= HookIdPeak
  then HookIdPeak:=id+1;
  x:=GetNumber(s,i);inc(i);
  y:=GetNumber(s,i);
  pt:=New(PHook,Init(x,y,id,@self));
  pHookList^.insert(pt);
  if id <= MaxTerminal (* System IO Terminal *)
  then Terminal[id]:=pt;
end;

procedure tSystem.ReadText(var s:string);
var id,x,y,i,j:integer;
    p:PText;
    q:pObj;
     function Matches(Item: PObj): Boolean; far;
     begin
       Matches:=(Item^.num=id)
     end;
begin
  i:=3;
  x:=GetNumber(s,i);inc(i);
  y:=GetNumber(s,i);inc(i);
  if s[i]<>';'
  then begin
       inc(i);id:=GetNumber(s,i);
       q:=pObjList^.FirstThat(@Matches);
       end
  else q:=nil;
  inc(i);
  p:=New(PText,Init(x,y,0,@Self,q));
  GetMem(p^.str,length(s)+2-i);
  for j:=0 to length(s)-i
  do p^.str[j]:=s[j+i];
  p^.str[length(s)-i+1]:=#0;
  pTextList^.insert(p);
end;


procedure tSystem.ReadBranch(var s:string);
var x,i:integer;
    id:integer;
    a,b:pHook;
    objt:pObj;


   function GetHook:pHook;
     function Matches(Item: PHook): Boolean; far;
     begin
       Matches:=(Item^.num=id)
     end;
   begin
     case s[i] of
      'h':begin
           inc(i);id:=GetNumber(s,i);inc(i);
           GetHook:=pHookList^.FirstThat(@Matches);
          end;
      'u':begin
           inc(i);id:=GetNumber(s,i);inc(i);
           objt:=pObjList^.FirstThat(@Matches);
           id:=GetNumber(s,i);inc(i);
           GetHook:=objt^.Terminal[id];
          end;
      end; (* of case *)
   end;
begin
  i:=3;
(*  id:=GetNumber(s,i);inc(i);branches do not have <id>!*)
  while (i<length(s))
  do begin
     a:=GetHook;
     b:=GetHook;
     if (a<>nil)and(b<>nil)
     then  pBranchList^.insert(New(PBranch,Init(a,b)));
     end;
end;

function tSystem.Find_Id(name:namet):integer;
(* 5555: questa procedura deve essere migliorata
         ERROR HANDLING, OPTIMIZE *)
var i:word;found:boolean;
begin
    found:=false;i:=LastVar;
    if LastVar <> 0
    then repeat
           if name=MacroVar[i].name
           then found:=true
           else dec(i)
         until found or(i=0);
    if found
    then Find_Id:=i
    else Find_Id:=0
end; { of Find_Id }


function tSystem.RegisterVar(var s:string):boolean;
(* 5555: questa procedura deve essere migliorata
         ERROR HANDLING, OPTIMIZE *)
var cname:namet;valore:real;code:integer;
begin
  if LastVar<MaxSizeOfList
  then begin
       cname:=copy(s,1,pos('=',s)-1);
       delete(s,1,pos('=',s));
       Val(s,valore,code);
       if (length(cname)>0)and(Find_Id(cname)=0)
       then begin
            inc(LastVar);
            with MacroVar[LastVar]
            do begin
               Name:=cname; { strip_space }
               value:=valore;
               end;
            RegisterVar:=true;
            end
       else RegisterVar:=false
       end
  else RegisterVar:=false
end;

function tSystem.ReadSystem(fn:PChar):boolean;
var f:text;
    error,complete:boolean;
    s:string;(*  AP10: usare un <PChar> invece del tipo <String>*)


  function ReadHeader(var s:string):boolean;
  var i,id,x,y:integer;
      sub:string;
      version:real;code:integer; (* used to fetch version number *)
  begin
    i:=1;
    GetString(s,sub,i);inc(i);
    if sub <> 'sym'
    then begin
           ReadHeader:=false;
           exit;
         end;
    GetString(s,sub,i);inc(i); (* version *)
    Val(sub,version,code);
    BlockSize:=GetNumber(s,i);inc(i);
    ReadHeader:=true;
    if version < 0.32 + 0.005 (* added for FP errors *)
    then begin
(* BACKWARD COMPATIBILITY WITH EARLY VERSIONS *)
         while (i<length(s))
         do begin
            inc(i);id:=GetNumber(s,i);inc(i);
            end
         end
    else while (i<length(s))
         do begin
(* NEW VERSIONS MAY HAVE ARGUMENT LIST *)
(* 5555 *)
            GetString(s,sub,i);inc(i);
            if sub <> ''
            then begin
                 RegisterVar(sub);
                 end;
            end;
  end;

  function open(var f:text;fn:PChar):integer;
  (* return values:       0  successful
                          1  cannot open file
                          2  this is not a LIBRARY
                          3  component not found in LIBRARY
  *)
  var str:array[0..254]of char;
      first,component:PChar;
      IsLibrary,found:boolean;
  begin
  open:=0;
  first:=StrScan(fn,'.');
  component:=StrRScan(fn,'.');
  IsLibrary:= first <> component;
  if IsLibrary
  then begin
       component[0]:=#0;
       inc(component);
       end;
  assign(f,fn);
  {$I-}
  reset(f);
  {$I+}
  if IOResult<>0
  then begin
       open:=1;
       exit;
       end;
  if IsLibrary
  then begin
       readln(f,str);
       if StrLComp(str,'lib;0.0',7) <> 0
       then begin
            open:=2;
            close(f);
            exit;
            end;
       found:=false;
       while not eof(f)and not found
       do begin
          readln(f,str);
          if (StrLComp('macro;',str,6) = 0)and
             (StrComp(component,str+6) = 0)
          then found:=true;
          end;
       if not found
       then begin
            open:=3;
            close(f);
            exit;
            end;
       end;
  end;

begin
  if open(f,fn) <> 0
  then begin
       ReadSystem:=false;
       exit;
       end;
  readln(f,s);
  error:=not ReadHeader(s);
  complete:=false;
  while not (eof(f)or error or complete)
  do begin
     readln(f,s);
     case s[1]of
       '/':{this is a comment};
       'u':ReadObj(s);
       'h':ReadHook(s);
       'b':ReadBranch(s);
       't':ReadText(s);
       'm':{this is a macro header}complete:=true;
       end; { of case }
     end;
  close(f);
  ReadSystem:=not error;
end;


function tSystem.WriteSystem(fn:PChar):boolean;
var f:text;
    nbr:integer;
    y,m,d,dow:word;

  procedure WriteHeader;
  var i:integer;
  begin
    write(f,'sym;0.4;',blocksize);
(* following lines were removed in version 0.33 
    for i:=1 to MaxTerminal
    do if Terminal[i]<>nil
       then write(f,';h',Terminal[i]^.num);
*)
(* following lines were added in version 0.33 *)
    for i:=1 to LastVar (* 5555*)
    do write(f,';',MacroVar[i].name,'=',MacroVar[i].value);
    writeln(f);
  end;

  procedure WriteObj(Item:pObj);far;
  var s:string;
  begin
  Obj2Str(item^.pqwe,s);
  writeln(f,'u',item^.num,';',item^.x,',',item^.y,';',s);
  end;

  procedure WriteHook(Item:pHook);far;
  begin
  if item^.num and zTerminal = 0
  then writeln(f,'h',item^.num,';',item^.x,',',item^.y);
  end;

  procedure WriteText(Item:pText);far;
  begin
    write(f,'t;',item^.x,',',item^.y,';');
    if item^.link <> nil
    then write(f,'u',item^.link^.num);
    writeln(f,';',item^.Str);
  end;

  procedure WriteBranch(Item:pBranch);far;
    procedure PutHook(hook:phook);
    var id,i:integer;
        objt:pObj;

     function Matches(Item: Pointer): Boolean; far;
     begin
       Matches:=(pBase(Item)^.num=id)
     end;

    begin
      if hook^.num and zTerminal <> 0
      then begin
             id:=hook^.num xor zTerminal;
             objt:=pObjList^.FirstThat(@Matches);
             i:=1;
             while (i<=MaxTerminal)and(objt^.terminal[i]<>hook)
             do inc(i);
             write(f,'u',id,'.',i);
           end
      else write(f,'h',hook^.num);
    end;

  begin
    if nbr and 3=0
    then write(f,'b');
    write(f,';');
    PutHook(item^.pA);
    write(f,',');
    PutHook(item^.pB);
    dec(nbr);
    if nbr and 3=0
    then writeln(f);
  end;

begin
  assign(f,fn);
  rewrite(f);
  WriteHeader;
  GetDate(y,m,d,dow);
  writeln(f,'/*Created by WinSound, Ver 0.4, ',d:2,'-',m:2,'-',y,' */');
  nbr:=0;
  pObjList^.ForEach(@WriteObj);
  pHookList^.ForEach(@WriteHook);
  pTextList^.ForEach(@WriteText);
  pBranchList^.ForEach(@WriteBranch);
  close(f);
end;


destructor tSystem.Done;
begin
  Dispose(pobjlist,Done);
  Dispose(phooklist,Done);
  Dispose(pbranchlist,Done);
  Dispose(ptextlist,Done);
end;

function TSystem.IOCount:integer;
var i,count:integer;
begin
  count:=0;
  for i:=1 to MaxTerminal
  do if Terminal[i]<>nil
     then inc(count);
  IOCount:=count;
end;


function TSystem.BuildMBranch:integer;
(* This subroutine checks the system and
   build the backward graph.

   Errors returned:

      zTooManyBranches    Internal error
      zCollision          At least two outputs connected together
      zNoOutput           At least one branch without any output device connected
      zEmpty              A system without connections
      zVacantInput        An input without any connected branch
      zShortedIO          At least two IO terminals connected together
      zVacantIO           An IO terminal not connected
*)

const zMaxOut=128;

type  Out=array[1..zMaxOut]of TOut;

var NextMark,i,
    LostMark:integer;
    pOut:^Out;
    error, error2, nout:integer;
    mah:integer; (* AP5: La procedura .FirstThat deve essere potenziata *)

  procedure GetOutput(Item:pObj);far;
  var i:integer;
      Attr:TAttr;
      AttrIO:TAIOClass;
  begin
    with item^
    do begin
       Capability(pqwe,Attr,AttrIO);
       for i:=1 to MaxTerminal
       do if AttrIO[i] and zOutput <> 0
          then with terminal[i]^
               do if mark <> 0
                  then if pOut^[mark].obj <> nil
                       then error:=zCollision
                       else begin
                            pOut^[mark].obj:=item;
                            pOut^[mark].terminal:=i;
                            inc(nout);
                            end;
(*                  else error:=zVacantOutput : this is only
                                                a warning! *)
       end;
  end;

  procedure SetOutput(Item:pObj);far;
  var i:integer;
      Attr:TAttr;
      AttrIO:TAIOClass;
      empty:TOut;
  begin
    empty.obj:=nil;
    empty.terminal:=0;
    with item^
    do begin
       Capability(pqwe,Attr,AttrIO);
       for i:=1 to MaxTerminal
       do if AttrIO[i] and zInput <> 0
          then with terminal[i]^
               do if mark <> 0
                  then backward[i]:=pOut^[mark]
                  else begin
                       error:=zVacantInput;
                       backward[i]:=empty;
                       end
          else backward[i]:=empty;
       end;
  end;

  procedure SetBack(Item: pObj); far;
  var j:integer;
  begin
    with item^
    do for j:=1 to MaxTerminal
       do if terminal[j]<>nil
          then with terminal[j]^
               do if mark = mah
                  then begin
                       backward[j].terminal:=i;
(*                       backward[j].obj:=nil; *)
                       end;
  end;

  procedure ClearHook(Item:pHook);far;
  begin
    item^.mark:=0;
  end;

(*  AP2: Ottimizzare TSystem.BuildMBranch.Update *)
  procedure Update(marka,markb:integer);
     procedure UpdateHook(Item:pHook);far;
     begin
       if item^.mark=markb
       then item^.mark:=marka;
     end;
  begin
    pHookList^.ForEach(@UpdateHook);
    Inc(LostMark);
  end;

  procedure UpdateBranch(Item:pBranch);far;
  var marka,markb:integer;
  begin
    with item^
    do begin
       marka:=pA^.mark;
       markb:=pB^.mark;
       if marka = 0
       then if markb = 0
            then begin
                 pA^.mark:=NextMark;
                 pB^.mark:=NextMark;
                 inc(NextMark);
                 end
            else pA^.mark:=pB^.mark
       else if markb = 0
            then pB^.mark:=pA^.mark
            else if marka = markb
                 then  (*skip*)
                 else Update(marka,markb)
       end;
  end;

  function CheckSystemIO:integer;
  var i,j:integer;
  begin
       for i:=1 to MaxTerminal-1
       do if Terminal[i]<>nil
          then if Terminal[i]^.mark=0
               then begin
                    CheckSystemIO:=zVacantIO;
                    exit
                    end
               else for j:=i+1 to MaxTerminal
                    do if (Terminal[j]<>nil)and(Terminal[i]^.mark = Terminal[j]^.mark)
                       then begin
                            CheckSystemIO:=zShortedIO;
                            exit;
                            end;
       CheckSystemIO:=0;
  end;


begin
  BuildMBranch:=0;
  pHookList^.ForEach(@ClearHook);
  NextMark:=1;LostMark:=0;
  pBranchList^.ForEach(@UpdateBranch);
  if NextMark > zMaxOut
  then begin
       BuildMBranch:=zTooManyBranches;
       exit;
       end;
  if NextMark = 1
  then begin
       BuildMBranch:=zEmpty;
       exit;
       end;
  new(pOut);
  for i:=1 to NextMark - 1
  do pOut^[i].obj:=nil;
  error:=0;
  nout:=0;
  pObjList^.ForEach(@GetOutput);
  if error = 0
  then pObjList^.ForEach(@SetOutput);
(* begin: Aggiunto per il supporto MACRO *)
       error2:=CheckSystemIO;
(*       if error2 <> zVacantIO
       then*) 
            for i:=1 to Maxterminal
            do if (Terminal[i]<>nil)and(Terminal[i]^.mark<>0)
               then if pOut^[Terminal[i]^.mark].Obj <> nil
                    then begin
                         TypeIO[i]:=zOutput;
                         Back[i]:=pOut^[Terminal[i]^.mark];
                         end
                    else begin
                         inc(nout);
                         TypeIO[i]:=zInput;
                         mah:=Terminal[i]^.mark;
                         pObjList^.ForEach(@SetBack);
                         Back[i].obj:=nil;
                         end
               else begin
                    TypeIO[i]:=zNone;
                    Back[i].obj:=nil;
                    end;
       if error = 0
       then error :=error2; (*AP6: verificare la priorita' degli errori *)
(* end: Aggiunto per il supporto MACRO *)
  if (error = 0)and(nout <> NextMark - LostMark - 1)
  then error:=zNoOutput;
  dispose(pOut);
  BuildMBranch:=error;

end;

function TSystem.SystemSort:pObj;

const zMaxObj=128;
type aobj=array[0..zMaxObj-1]of pobj;

var objs:^aobj;
    i,first,last:integer;
    error:integer;

   procedure swap(a,b:integer);
   var t:pobj;
   begin
     t:=objs^[a];
     objs^[a]:=objs^[b];
     objs^[b]:=t;
   end;

   function copre(a,b:pobj):boolean;
   var i:integer;
   begin
     copre:=false;
     for i:=1 to Maxterminal
     do if a^.backward[i].obj = b
        then begin
             copre:=true;
             exit;
             end;
   end;

begin
(* first check for auto-loop *)
  SystemSort:=nil;
  if pObjList^.count = 0
  then exit;
  for i:=0 to pObjList^.count - 1
  do if copre(pObjList^.At(i),pObjList^.At(i))
     then exit;

(*AP3: rimuovere l'uso dell'array <Objs> *)
  new(Objs);
  for i:=0 to pObjList^.count - 1
  do Objs^[i]:=pObjList^.At(i);
  first:=0;last:=pObjList^.count - 1;
  error:=0;


(* then check for more general loops *)
  while (last>0)and (error = 0)
  do begin
     i:=first+1;
     while (i<=last) and not copre(objs^[i],objs^[first])
	 do inc(i);
     if i<=last
     then begin
	    inc(first);
	    swap(i,first)
	  end
     else begin
	     swap(first,last);
	     if first>0
	     then begin
		  dec(first);
		  for i:=0 to first
		  do if copre(objs^[i],objs^[last])
		       then error:=zLoop;
		  end;
	     dec(last);
	  end;
     end;
  if error = 0
  then begin
       SystemSort:=Objs^[0];
       for i:=0 to pObjList^.count - 2
       do Objs^[i]^.next:=Objs^[i+1];
       Objs^[pObjList^.count - 1]^.next:=nil;
       end;
  dispose(Objs);
end;

function TSystem.CheckSystem(var start:pObj):integer;
var result:integer;
begin
  result:=BuildMBranch;
  CheckSystem:=result;
  if result = 0
  then begin
       start:=SystemSort;
       if start = nil
       then CheckSystem:=zLoop;
       end
  else start:=nil;
end;

function CheckFS_in(scan:pObj;prop:AIOprop):boolean;
(* Questa funzione verifica che le FS degli ingressi sampled
   di un oggetto siano identiche *)
var fs:longint;
    i:integer; 
begin
  fs:=-1;
  for i:=1 to MaxTerminal
  do if (scan^.backward[i].obj<>nil)
     then with scan^.backward[i]
          do begin
             if obj^.ioprop[terminal].attr and zMaskSampled = zSampled
             then if fs = -1 (* i.e. the first sampled input *)
                  then fs:=obj^.ioprop[terminal].fsample
                  else if fs <> obj^.ioprop[terminal].fsample
                       then begin
                            CheckFS_in:=false;
                            exit;
                            end
             end
     else if scan^.backward[i].terminal<>0
     then with scan^.backward[i]
          do begin
             if prop[terminal].attr and zMaskSampled = zSampled
             then if fs = -1 (* i.e. the first sampled input *)
                  then fs:=prop[terminal].fsample
                  else if fs <> prop[terminal].fsample
                       then begin
                            CheckFS_in:=false;
                            exit;
                            end
             end;
  CheckFS_in:=true;
end;


function CheckSys(var scan:pObj;prop:AIOprop):integer;
var endanalysis:boolean;
    i,result:integer;
begin
  result:=0;
  endanalysis:=false;
  while (scan<>nil)and not endanalysis
  do begin
     if CheckFS_in(scan,prop)
     then begin
          for i:=1 to MaxTerminal
          do with scan^.backward[i]
             do if obj<>nil (*AP2: sarebbe meglio non basarsi su backward[]*)
                then scan^.ioprop[i]:=obj^.ioprop[terminal]
                else if terminal=0
                     then scan^.ioprop[i].attr:=zNone
                     else scan^.ioprop[i]:=prop[terminal]; (*MACRO SUPPORT*)
          result:=CheckObj(scan^.pqwe,scan^.ioprop);
          end
     else result:=zReIncompatible;
     if result <> 0
     then endanalysis:=true
     else scan:=scan^.next;
     end;
  CheckSys:=result;
end;

function StartSys(var scan:pObj;prop:AIOprop;BlockSize:longint;HWindow:HWnd):integer;
var endanalysis:boolean;
    i,result:integer;
    stop,start:pObj;

begin
  result:=0;
  endanalysis:=false;
  start:=scan;
  while (scan<>nil)and not endanalysis
  do begin
     if CheckFS_in(scan,prop)
     then begin
          for i:=1 to MaxTerminal
          do with scan^.backward[i]
             do if obj<>nil (*AP2: sarebbe meglio non basarsi su backward[]*)
                then scan^.ioprop[i]:=obj^.ioprop[terminal]
                else if terminal=0
                     then scan^.ioprop[i].attr:=zNone
                     else scan^.ioprop[i]:=prop[terminal]; (*MACRO SUPPORT*)
          result:=StartAnalysis(scan^.pqwe,scan^.ioprop,BlockSize,HWindow);
          end
     else result:=zReIncompatible;
     if result<>0
     then endanalysis:=true
     else scan:=scan^.next;
     end;
  if endanalysis
  then begin
       stop:=scan;
       scan:=start;
       while (scan<>stop)
       do begin
          StopAnalysis(scan^.pqwe);
          scan:=scan^.next;
          end;
       end;
  StartSys:=result;
end;


(* ------- Generic ---------*)

procedure _LongRead(TheFile: integer;
  MemPtr: Pointer; BitsByteSize: Longint);
type
  LongType = record
    case Word of
      0: (Ptr: Pointer);
      1: (Long: Longint);
      2: (Lo: Word;
	  Hi: Word);
  end;
var
  Count: Longint;
  Start, ToAddr, Bits: LongType;
begin
  Start.Long := 0;
  Bits.Ptr := MemPtr;
  Count := BitsByteSize - Start.Long;
  while Count > 0 do
  begin
    ToAddr.Hi := Bits.Hi + (Start.Hi * Ofs(AHIncr));
    ToAddr.Lo := Start.Lo;
    if Count > $4000 then Count := $4000;
    _lread(TheFile, ToAddr.Ptr, Count);
    Start.Long := Start.Long + Count;
    Count := BitsByteSize - Start.Long;
  end;
end;

function OpenWave(var f:integer;fn:pChar;var fsample,nsample:longint):integer;
(* Apre un file di tipo WAV e restituisce la frequenza di campionamento
   in <fsample> e la lunghezza del suono in <slength>.
   Ritorna 0 se il file e' leggibile,
           1 = 'No way to read file',
           2 = 'Invalid file format',
           3 = 'Not a <8-bit> audio file' *)
const sign:array[0..15]of char=('R','I','F','F','W','A','V','E','f','m','t',' ','d','a','t','a');
var buf:array[0..43]of byte;
    i,extra:integer;
begin
if strlen(fn)=0
then begin
     OpenWave:=1;
     exit;
     end;
f:=_lopen(fn,of_read or of_share_deny_write);
if f = -1 (* hFile_Error *)
then begin
     OpenWave:=1;
     exit;
     end;
if _lread(f,@buf,20) <> 20
then begin
     _lclose(f);
     OpenWave:=2;
     exit;
     end;
for i:=0 to 3
do if chr(buf[i]) <> sign[i]
   then begin
        _lclose(f);
        OpenWave:=2;
        exit;
        end;
for i:=0 to 7
do if chr(buf[i+8]) <> sign[i+4]
   then begin
        _lclose(f);
        OpenWave:=2;
        exit;
        end;
extra:=buf[16];
_lread(f,@buf,extra+8);
for i:=0 to 3
do if chr(buf[i+extra]) <> sign[i+12] 
   then begin
        _lclose(f);
        OpenWave:=2;
        exit;
        end;
fsample:=longint((@buf[4])^);
if (buf[14]<>8) or (buf[2]<>1)(*or(buf[12]<>1)*)
then begin
     _lclose(f);
     OpenWave:=3;
     exit;
     end;
nsample:=longint((@buf[extra+4])^);
OpenWave:=0;
end;


function WriteHeader(var f:file;fn:TFileName;fsample,nsample:longint):integer;
(* Apre un file sonoro per la scrittura e restituisce:
   0: ok
   1: error
*)
const skel:array[0..43]of char=('R','I','F','F','$',#0,#0,#0,'W','A','V','E','f','m','t',' ',
         #16,#0,#0,#0,#1,#0,#1,#0,#0,#0,#0,#0,#0,#0,#0,#0,
         #1,#0,#8,#0,'d','a','t','a',#0,#0,#0,#0);
var  buf:array[0..43]of byte;
    i:integer;
begin
  WriteHeader:=0;
  Assign(f,fn);
  {$I-}
  rewrite(f,1);
  {$I+}
  if IOResult<>0
  then  begin
          WriteHeader:=1;
          exit;
        end;
  for i:=0 to 43
  do buf[i]:=ord(skel[i]);
  longint((@buf[4])^):=nsample+36;
  longint((@buf[24])^):=fsample;
  longint((@buf[28])^):=fsample;
  longint((@buf[40])^):=nsample;
  blockwrite(f,buf,44);
end; { of WriteHeader }

procedure LongWrite(var TheFile: file;
  MemPtr: Pointer; BitsByteSize: Longint);
type
  LongType = record
    case Word of
      0: (Ptr: Pointer);
      1: (Long: Longint);
      2: (Lo: Word;
	  Hi: Word);
  end;
var
  Count: Longint;
  Start, ToAddr, Bits: LongType;
begin
  Start.Long := 0;
  Bits.Ptr := MemPtr;
  Count := BitsByteSize - Start.Long;
  while Count > 0 do
  begin
    ToAddr.Hi := Bits.Hi + (Start.Hi * Ofs(AHIncr));
    ToAddr.Lo := Start.Lo;
    if Count > $4000 then Count := $4000;
    blockwrite(TheFile, ToAddr.Ptr^, Count(*, NWritten*));
(*    _lwrite(TheFile, ToAddr.Ptr, Count);*)
    Start.Long := Start.Long + Count;
    Count := BitsByteSize - Start.Long;
  end;
end;

procedure GetPString(var s:string;pSub:pChar;var i:integer);
(* This procedure fetch from string <s> a substring <sub> *)
var j:integer;
begin
j:=0;
while (i<=length(s))and(s[i]<>';')
do begin
   pSub[j]:=s[i];
   inc(j);
   inc(i);
   end;
pSub[j]:=#0;
end;


function GetIValue(PS:pSystem;var s:string;var i:integer;var value:integer):boolean;
(* This function fetch from string <s> a integer value *)
var l:longint;
begin
if GetLValue(PS,s,i,l)
then begin
     value:=l;
     GetIValue:=true;
     end
else GetIValue:=false;
end;

function GetLValue(PS:pSystem;var s:string;var i:integer;var value:longint):boolean;
(* This function fetch from string <s> a longint value *)
var ris:longint;
    sub:string(*[15]*);
    j,ti:integer;
begin
GetLValue:=false;
ris:=0;
j:=0;
(* skip leading blank(s) *)
while (i<=length(s))and(s[i]=' ')
do inc(i);
ti:=i;
if s[ti]='-'
then begin
     inc(j);
     sub[j]:=s[ti];
     inc(ti);
     end;
while (ti <= length(s))and(s[ti] in ['0'..'9'])
do begin
   inc(j);
   sub[j]:=s[ti];
   inc(ti);
   end;
sub[0]:=char(j);
Val(sub,value,j);
if j <> 0
then begin (* ops, not a number, maybe a variable ? *)
     if PS = nil
     then exit; (* ops, no variables *)
     GetString(s,sub,i);
     j:=PS^.Find_Id(sub);
     if j = 0
     then exit (* ops, neither a variable *)
     else value:=round(PS^.MacroVar[j].value);
     end
else i:=ti;
GetLValue:=true;
end;

function GetRValue(PS:pSystem;var s:string;var i:integer;var value:real):boolean;
(* This function fetch from string <s> a real value *)
var ris:longint;
    sub:string(*[31]*);
    j,ti:integer;
begin
GetRValue:=false;
ris:=0;
j:=0;
(* skip leading blank(s) *)
while (i<=length(s))and(s[i]=' ')
do inc(i);
ti:=i;
while (ti<=length(s))and(s[ti] in ['0'..'9','-','+','e','E','.'])
do begin
   inc(j);
   sub[j]:=s[ti];
   inc(ti);
   end;
sub[0]:=char(j);
Val(sub,value,j);
(* if StrLen(sub) = 0   bug TPW1.5, sub:array[]of char
then code:=-1
else Val(sub,value,code);*)
if j <> 0
then begin (* ops, not a number, maybe a variable ? *)
     if PS = nil
     then exit; (* ops, no variables *)
     GetString(s,sub,i);
     j:=PS^.Find_Id(sub);
     if j = 0
     then exit (* ops, neither a variable *)
     else value:=PS^.MacroVar[j].value;
     end
else i:=ti;
GetRValue:=true;
end;



(* ----- TTextDialog ----- *)

procedure TTextDialog.SetUpWindow;
begin
  TDialog.SetUpWindow;
  SetDlgItemText(HWindow,103,TextP^.str);
end;

constructor TTextDialog.Init(AParent: PWindowsObject; AName: PChar; p:pText);
begin
  TDialog.Init(AParent, AName);
  TextP:=p;
end;

procedure TTextDialog.Ok(var Msg:TMessage);
var testo:array[0..128]of char;
begin
    TDialog.Ok(Msg);
    GetDlgItemText(HWindow, 103, testo, sizeof(testo));
    StrDispose(TextP^.str);
    TextP^.str:=StrNew(testo);
end;

(* ----- THookDialog ----- *)

procedure THookDialog.SetUpWindow;
begin
  TDialog.SetUpWindow;
  SetDlgItemInt(HWindow,103,HookP^.num,false);
end;

constructor THookDialog.Init(AParent: PWindowsObject; AName: PChar; p:pHook);
begin
  TDialog.Init(AParent, AName);
  HookP:=p;
end;

procedure THookDialog.Ok(var Msg:TMessage);
var _num:integer;
    result:wordbool;
begin
    TDialog.Ok(Msg);
    _num:=GetDlgItemInt(HWindow, 103, pBool(@result), false);
    if result and (_num > 0) and (_num <= MaxTerminal) and (HookP^.sys^.Terminal[_num] = nil)
    then begin
         HookP^.sys^.Terminal[_num]:=HookP;
         HookP^.sys^.Terminal[HookP^.num]:=nil;
         HookP^.num:=_num
         end
    else MessageBeep(MB_ICONEXCLAMATION);

end;

end.