{************************************************}
{  WSTEST: usato per il test di WS               }
{  uso: WSTEST <filelist>                        }
{       dove <filelist> e' un file che elenca i  }
{       nomi dei files di tipo SYM da provare    }
{************************************************}

program WSTEST;

{$R WS}

uses
  WinTypes, WinProcs, WObjects, Strings, WSwnd,
  CommDLG, WinDos;

const
  AppName='WSTEST';

type
(* Begin: Aggiunta per MDI *)
     PMDIWin = ^TMDIWin;

     TMDIWin = OBJECT (TMDIWindow)
       constructor Init (ATitle : PChar; AMenu : HMenu);
       procedure SetupWindow;virtual;
       procedure WMEnterIdle(var Msg: TMessage); virtual WM_First + WM_EnterIdle;
       procedure About(var Message: TMessage); Virtual cm_first + idm_About;
       procedure Open(var Message: TMessage); Virtual cm_first + idm_Open;
       procedure NewWave(var Message: TMessage); Virtual cm_first + idm_Wave;
       procedure NewFilter(var Message: TMessage); Virtual cm_first + idm_Filter;
       procedure NewSystem(var Message: TMessage); Virtual cm_first + idm_System;
       procedure GetWindowClass(var WndClass: TWndClass); virtual;
     END;
(* End: Aggiunta per MDI *)


  TApp = object(TApplication)
    procedure InitMainWindow; virtual;
    procedure InitInstance; virtual;
  end; { of TApp }

function WSDLLVersion:word;far;external 'WSDLL';

{--------------- TApp ------------------------}

procedure TApp.InitMainWindow;
begin
  if lobyte(GetVersion)=$03
  then if WSDLLVersion = $0500
       then MainWindow := New(PMDIWin, Init('WinSound/03',
                  LoadMenu(HInstance, 'Menu_1')))
       else MainWindow := new(PDialog,init(nil,'WrongDLL'))
  else MainWindow := new(PDialog,init(nil,'WrongWin'));
end;

procedure TApp.InitInstance;
begin
  TApplication.InitInstance;
  HAccTable := LoadAccelerators(HInstance, 'ACCELERATORS');
end;


(* Begin: Aggiunta per MDI *)
CONSTRUCTOR TMDIWin.Init (ATitle : PChar; AMenu : HMenu);
BEGIN
  TMDIWindow.Init (ATitle, AMenu);
  ChildMenuPos := 0;
END;

procedure TMDIWin.SetupWindow;
var p:pSystemWindow;
    str:array[0..255]of char;
    msg:TMessage;
    i:integer;
    t:text;
begin
  TMDIWindow.SetupWindow;
  if ParamCount = 1
  then begin
       Assign(t,ParamStr(1));
       Reset(t);
       while not eof(t)
       do begin
            readln(t,str);
            p:=New (PSystemWindow, Init (@self, str));
            if p<>nil
            then begin
                 Application^.MakeWindow (p);
                 p^.Run(msg);
                 p^.CloseWindow;
                 end
            else MessageBox(HWindow,str,'WS TEST ERROR',MB_IconAsterisk)
            end;
       end;
end;


procedure TMDIWin.GetWindowClass(var WndClass: TWndClass);
begin
  TMDIWindow.GetWindowClass(WndClass);
  WndClass.hIcon := LoadIcon(HInstance, 'A_ICON');
end;

procedure TMDIWin.About(var Message: TMessage);
begin
  Application^.ExecDialog(new(PDialog,init(@Self,'About')))
end;

function FileOpen(HWindow:HWND;FileName:PChar):boolean;
const
  DefExt = 'wav';
var
  OpenFN      : TOpenFileName;
  Filter      : array [0..100] of Char;
  FullFileName: array[0..128] of Char;
  i:integer;
begin
  StrCopy(FullFileName, '');

  FillChar(Filter, SizeOf(Filter), #0);  { Set up for double null at end }
(* Character '#' will be converted in #0 *)
  StrCopy(Filter, 'All WinSound files#*.wav;*.flt;*.sym#Waves#*.wav#Filters#*.flt');
  StrCopy(@Filter[StrLen(Filter)], '#Systems#*.sym');
  for i:=0 to StrLen(Filter)
  do if Filter[i] = '#' then Filter[i] := #0;

  FillChar(OpenFN, SizeOf(TOpenFileName), #0);
  with OpenFN do
  begin
    hInstance     := HInstance;
    hwndOwner     := HWindow;
    lpstrDefExt   := DefExt;
    lpstrFile     := FullFileName;
    lpstrFilter   := Filter;
    lpstrFileTitle:= FileName;
    flags         := ofn_FileMustExist(* or ofn_AllowMultiSelect*);
    lStructSize   := sizeof(TOpenFileName);
    nFilterIndex  := 1;       {Index into Filter String in lpstrFilter}
    nMaxFile      := SizeOf(FullFileName);
  end;
  FileOpen:=GetOpenFileName(OpenFN);
end;



procedure TMDIWin.Open(var Message: TMessage);
var  FileName: array[0..fsPathName] of Char;
     Dir: array[0..fsDirectory] of Char;
     Name: array[0..fsFileName] of Char;
     Ext: array[0..fsExtension] of Char;
     p:pointer;
begin
  if FileOpen(HWindow, @FileName)
  then begin
         FileSplit(FileName, Dir, Name, Ext);
         StrUpper(Ext);
         if StrComp(Ext,'.WAV') = 0
         then p:=New (PWaveWindow, Init (@self, FileName))
         else if StrComp(Ext,'.FLT') = 0
              then p:=New (PFilterWindow, Init (@self, FileName))
              else p:=New (PSystemWindow, Init (@self, FileName));
         if p<>nil
         then Application^.MakeWindow (p);
       end;
end;

procedure TMDIWin.NewWave(var Message: TMessage);
begin
(*  Application^.ExecDialog(new(PTinfoDialog,init(@Self,'Param')));*)
  Application^.MakeWindow (New (PWaveWindow, Init (@self, nil)));
end;

procedure TMDIWin.NewFilter(var Message: TMessage);
begin
(*  Application^.ExecDialog(new(PTinfoDialog,init(@Self,'Param')));*)
  Application^.MakeWindow (New (PFilterwindow, Init (@self, nil)));
end;

procedure TMDIWin.NewSystem(var Message: TMessage);
begin
(*  Application^.ExecDialog(new(PTinfoDialog,init(@Self,'Param')));*)
  Application^.MakeWindow (New (PSystemWindow, Init (@self, nil)));
end;

procedure TMDIWin.WMEnterIdle(var Msg: TMessage);
(* MT: Questa procedura assicura il MultiTask *)
begin
  Msg.Result:=0;
  if hAnaWindow <> 0
  then PostMessage(hAnaWindow,WM_U_Analysis,hAnaWindow,0);
end;


{------------- Main Program --------------------}

var
  App: TApp;
begin
  App.Init(AppName);
  App.Run;
  App.Done;
end.
