unit WSwnd;

(* Il flag <modified> deve essere aggiornato ogni volta che
   il sistema e' modificato, cioe' un elemento e' stato
   inserito/cancellato/modificato(spostato)

- Garantire la coerenza della variabile <iDrag>, in particolare
  porre iDrag:=nil; ogni volta che l'oggetto o il testo
  selezionati sono cancellati!!!
*)
(* AP2: sarebbe meglio non basarsi su backward[]*)
(* AP3: usare una variabile sostitutiva alla chiamata GetNBlocks *)
(* AP4: questa versione gestisce solo oggetti ISOCRONI *)
(* AP6: Win16: gestione inefficiente dei dati > 64K *)
(* AP7: che succede se la lunghezza della linea e' maggiore di 255 ?*)
(* AP8: armonizzare gestione files, blockwrite o _lwrite ?*)

{ This unit contains the objects needed to
  handle WaveForms, Numerical Filters and Systems       }

{ L.C. 3-1997
  Ver 0.42    Added TWinScroller to allow scrolling in system window
      0.43    Added Floating Menu in <TSystemWindow> and <TWaveWindow>
              and Enabling of System Menu items.
              Added Printing Command in <TWaveWindow>
              and <TFilterWindow>.
              Added <cues> in <TWaveWindow>.

  Used by WS.PAS }

interface
uses
  WinTypes, WinProcs, WObjects, Strings, MMSystem,
  WSobj, WSFilter, WinDos, CommDlg, Win31, ToolHelp;
const
  idm_Info    =   1;
  idm_Open    =   3;
  idm_Save    =   4;
  idm_SaveAs  =   5;
  idm_PrintSetup= 6;
  idm_Print   =   7;
  idm_Wave    = 101;
  idm_Filter  = 102;
  idm_System  = 103;
  idm_Library = 104;

  idm_blocks  = 200; (*200..299 are reserved by blocks!!!!*)

  idm_FilEdit = 110;

  idm_Play    = 110;
  idm_Eco     = 111;
  idm_Record  = 112;
  idm_View    = 113;

  idm_Zoom    = 120;
  idm_Restore = 121;

  idm_Check   = 110;
  idm_Run     = 111;
  idm_Param   = 112;
  idm_ToolBox = 113;

  idm_Add     = 110;
  idm_Remove  = 111;

  idm_Cut     = 301;
  idm_Copy    = 302;
  idm_Paste   = 303;
  idm_Unbind  = 304;
  idm_SelAll  = 305;
  idm_ObjProps= 306;
  idm_CueList = 306;

  idm_About   = 999;
  id_Edit     = 101;
  WM_U_Insert = WM_User+234; (* Message from ToolBox: Insert Object *)
  WM_U_Analysis = WM_User+235; (* message from TSystemWindow *)
  WM_U_Notify = WM_User+236;

  id_LibraryLB = 100;
  id_ListBox   = 100;

  zWaveId     =   1;
  zFilterId   =   2;
  zSystemId   =   3;
  zLibraryId  =   4;
  Id2Name     :array[1..4]of string[8]=('Wave','Filter','System','Library');

  OpenCounter:integer=0;

const hAnaWindow:hwnd=0; (* for MultiTask *)

type
  PTRunDialog = ^TRunDialog;

  PWinScroller = ^TWinScroller;
  TWinScroller = object(TScroller)
    procedure BeginView(PaintDC: HDC; var PaintInfo: TPaintStruct); virtual;
  end;

  PCue = ^TCue;
  TCue = record (* don't modify this type because of procedure WVSPrintf *)
           id: longint;
           start: longint;
           length: longint;
           labl: PStr;
           next: PCue;
         end;

  PDialogList = ^TDialogList;  (* used for cues *)
  TDialogList = object(TDialog)
    ListBox:PListBox;
    constructor Init(AParent: PWindowsObject; AName: PChar);
    procedure SetUpWindow; virtual;
  end;

  PDocument = ^TDocument;
  TDocument = object(TWindow)
    offset:TPoint;
    TypeOfDocument:integer;
    modified:boolean;
    MyIcon:HIcon;
    Menu:HMenu;
    FileName: TFileName;
    devmode: THandle; (*printer *)
    function CanClose: Boolean; virtual;
    constructor Init(AParent: PWindowsObject; Title: PChar; TypeOfChild:integer);
    destructor Done; virtual;
    procedure GetWindowClass(var WndClass: TWndClass); virtual;
(*    procedure WMSize(var Msg:TMessage);virtual WM_First + WM_Size;*)
    procedure WMRButtonDown(var Msg: TMessage); virtual WM_RButtonDown;
    procedure WMSetFocus(var Msg:TMessage);virtual WM_First + WM_SetFocus;
    procedure PrintSetup(var Message: TMessage); Virtual cm_first + idm_PrintSetup;
    procedure Draw(PaintDC: HDC; rect: TRect;left,right:integer);virtual;
    procedure Print(var Message: TMessage); Virtual cm_first + idm_Print;
    end;

  PSystemWindow = ^TSystemWindow;
  TSystemWindow = object(TDocument)
    MaxIterate:integer;
    iDrag:pBase;
    psys:PSystem;
    HandleDC: HDC;
    ButtonDown:boolean;
    ptDrag,WorkPos,EndPos:TPoint;
    pa:pObj;childp:PTRunDialog;iterate:integer; (* used only while running analysis for MT *)
    procedure EnableEditMenu(enable: boolean);
    procedure Cut(var Message: TMessage); Virtual cm_first + idm_Cut;
    procedure Copy(var Message: TMessage); Virtual cm_first + idm_Copy;
    procedure Paste(var Message: TMessage); Virtual cm_first + idm_Paste;
    procedure Unbind(var Message: TMessage); Virtual cm_first + idm_Unbind;
    procedure ObjProps(var Message: TMessage); Virtual cm_first + idm_ObjProps;
    procedure Check(var Message: TMessage); Virtual cm_first + idm_Check;
    procedure Run(var Message: TMessage); Virtual cm_first + idm_Run;
    procedure Param(var Message: TMessage); Virtual cm_first + idm_Param;
    function GetClassName: PChar; virtual;
    function HitTest(xx,yy:integer):pBase;
    procedure GetWindowClass(var WndClass: TWndClass); virtual;
    constructor Init(AParent: PWindowsObject; Title: PChar);
    procedure Paint(PaintDC: HDC; var PaintInfo: TPaintStruct); virtual;
    procedure WMLButtonDBLCLK(var Msg: TMessage); virtual WM_LBUTTONDBLCLK;
    procedure WMLButtonDown(var Msg: TMessage); virtual WM_LBUTTONDOWN;
    procedure WMLButtonUp(var Msg: TMessage); virtual WM_LBUTTONUP;
    procedure WMMouseMove(var Msg: TMessage); virtual WM_MOUSEMOVE;
    procedure WMUser(var Msg: TMessage); virtual WM_First + WM_U_Insert;
    procedure WMAnalysis(var Msg: TMessage); virtual WM_First + WM_U_Analysis;
    procedure WMSetFocus(var Msg:TMessage);virtual WM_First + WM_SetFocus;
    procedure Info(var Message: TMessage); Virtual cm_first + idm_Info;
    procedure Save(var Message: TMessage); Virtual cm_first + idm_Save;
    procedure SaveAs(var Message: TMessage); Virtual cm_first + idm_SaveAs;
    destructor Done; virtual;
  end; { of TSystemWindow }

  PFilterWindow = ^TFilterWindow;
  TFilterWindow = object(TDocument)
    filterp:pBuiltIn;
    gain:tiobuf;
    maxgain:real;
    function GetClassName: PChar; virtual;
    constructor Init(AParent: PWindowsObject; Title: PChar);
    destructor Done; virtual;
    procedure Paint(PaintDC: HDC; var PaintInfo: TPaintStruct); virtual;
    procedure FilEdit(var Message: TMessage); Virtual cm_first + idm_FilEdit;
    procedure Info(var Message: TMessage); Virtual cm_first + idm_Info;
    procedure Draw(PaintDC: HDC; rect: TRect;left,right:integer);virtual;
  end; { of TFilterWindow }

  PWaveWindow = ^TWaveWindow;
  TWaveWindow = object(TDocument)

    leftmark,rightmark:longint;  (* left and right markers *)
    lsample,rsample:longint;     (* left and right samples *)
    n_cues:longint;              (* number of cues         *)
    cuep: pCue;                  (* pointer to list of cues*)
    samplerate,nsamples:longint;
    tmark:longint;
    MemHandle:THandle;
    buttondown:boolean;
    BufSize,start,residual:longint;HasOutput:boolean;process:pointer; (* used only while processing signal for MT *)
    BufPtr:pointer;childp:PTRunDialog;iterate:integer; (* used only while processing signal for MT *)
    procedure WMLButtonDown(var Msg: TMessage); virtual WM_LBUTTONDOWN;
    procedure WMLButtonUp(var Msg: TMessage); virtual WM_LBUTTONUP;
    procedure WMMouseMove(var Msg: TMessage); virtual WM_MOUSEMOVE;
    function GetClassName: PChar; virtual;
    procedure Info(var Message: TMessage); Virtual cm_first + idm_Info;
    procedure Eco(var Message: TMessage); Virtual cm_first + idm_Eco;
    procedure View(var Message: TMessage); Virtual cm_first + idm_View;
    procedure Play(var Message: TMessage); Virtual cm_first + idm_Play;
    procedure Rec(var Message: TMessage); Virtual cm_first + idm_Record;
    constructor Init(AParent: PWindowsObject; Title: PChar);
    procedure Paint(PaintDC: HDC; var PaintInfo: TPaintStruct); virtual;
    procedure DrawMarker(HandleDC:HDC;x:longint;rect:TRect);
    procedure Zoom(var Message: TMessage); Virtual cm_first + idm_zoom;
    procedure Restore(var Message: TMessage); Virtual cm_first + idm_restore;
    procedure Copy(var Message: TMessage); Virtual cm_first + idm_Copy;
    procedure Paste(var Message: TMessage); Virtual cm_first + idm_Paste;
    procedure Cut(var Message: TMessage); Virtual cm_first + idm_Cut;
    procedure SelectAll(var Message: TMessage); Virtual cm_first + idm_SelAll;
    procedure CueList(var Message: TMessage); Virtual cm_first + idm_CueList;
    procedure Save(var Message: TMessage); Virtual cm_first + idm_Save;
    procedure SaveAs(var Message: TMessage); Virtual cm_first + idm_SaveAs;
    procedure WriteWave(fn:TFileName);
    procedure ProcessWave(var name:string;buffersize:longint;dialog:boolean);
    procedure WMAnalysis(var Msg: TMessage); virtual WM_First + WM_U_Analysis;
    procedure Draw(PaintDC: HDC; rect: TRect;left,right:integer);virtual;
    destructor Done; virtual;
  end; { of TWaveWindow }

  PLibraryWindow = ^TLibraryWindow;
  TLibraryWindow = object(TDocument)
    ListBox:PListBox;f:text;
    OpenFlag:boolean;
    function GetClassName: PChar; virtual;
    constructor Init(AParent: PWindowsObject; Title: PChar);
    procedure SetUpWindow; virtual;
    destructor Done; virtual;
    procedure WMSize(var Msg:TMessage);virtual wm_first + wm_Size;
    procedure Info(var Message: TMessage); Virtual cm_first + idm_Info;
    procedure Save(var Message: TMessage); Virtual cm_first + idm_Save;
    procedure SaveAs(var Message: TMessage); Virtual cm_first + idm_SaveAs;
    procedure Add(var Message: TMessage); Virtual cm_first + idm_Add;
    procedure Remove(var Message: TMessage); Virtual cm_first + idm_Remove;
  end; { of TLibraryWindow }


  PTinfoDialog = ^TInfoDialog;
  TInfoDialog = object(TDialog)
    procedure SetUpWindow; virtual;
  end;


  PTSysinfoDialog = ^TSysInfoDialog;
  TSysInfoDialog = object(TDialog)
    procedure SetUpWindow; virtual;
  end;

  PTSysParamDialog = ^TSysParamDialog;
  TSysParamDialog = object(TDialog)
    procedure SetUpWindow; virtual;
    procedure Ok(var Msg:TMessage);virtual id_first+id_ok;
  end;

  PTFilterDialog = ^TFilterDialog;
  TFilterDialog = object(TDialog)
    procedure SetUpWindow; virtual;
    procedure Ok(var Msg:TMessage);virtual id_first+id_ok;
  end;

  pToolBox = ^TToolBox;
  TToolBox =object(TWindow)
            ObjNum:integer;
            ToolSelected:boolean;
            nRows,nColumns:integer;
            procedure GetWindowClass(var WndClass: TWndClass);virtual;
            constructor Init(AParent: PWindowsObject; Title: PChar);
            procedure Paint(PaintDC: HDC; var PaintInfo: TPaintStruct); virtual;
            procedure WMLButtonDown(var Msg: TMessage); virtual WM_LBUTTONDOWN;
            procedure WMLButtonUp(var Msg: TMessage); virtual WM_LBUTTONUP;
            destructor Done;virtual;
            end;

  TRunDialog = object(TDialog)
    start:longint;
    procedure SetUpWindow; virtual;
    constructor Init(AParent: PWindowsObject; Title: PChar);
    procedure WMNotify(var Msg: TMessage); virtual WM_First + WM_U_Notify;
  end;

implementation

const zText=$8001; (* identificatore oggetto testo *)
      zSystemIO=$8002; (* identificatore terminale I/O di sistema *)
      zNTools=2;
      zLast=zText+zNTools-1;
      pTool:pWindowsObject=nil;

var MenuNil:HMenu;
    BitMap:array[zText..zLast] of HBitmap;


procedure AHIncr; far; external 'KERNEL' index 114;
procedure DrawObj(p:pointer; DC: HDC; BMP: TPoint);far;external 'WSDLL';
function GetNBlocks:integer;far;external 'WSDLL';
function GetBitMap(n:integer):HBitMap;far;external 'WSDLL';
procedure NewObj(var p:pointer;typeOfBlock:integer;HWindow:HWnd;SystemP:pSystem);far;external 'WSDLL';
procedure StopAnalysis(p:pointer);far;external 'WSDLL';
function Analysis(p:pointer;var iop:aiobuf):integer;far;external 'WSDLL';
procedure GetBufSize(p:pointer;var bufsize:longint);far;external 'WSDLL';
(* EXT-WAVE *)
procedure NewFromStr(var p:pointer;var st:string;j:integer;SystemP:pSystem);far;external 'WSDLL';
procedure DisposeObj(var p:pointer);far;external 'WSDLL';


function GlobalLockOff(MemHandle:THandle;lsample:longint):pointer;
begin
  (* following line moves pointer to first sample *)
  GlobalLockOff := Ptr(SelectorOf(GlobalLock(MemHandle)) + HiWord(lsample) * Ofs(AHIncr),LoWord(lsample));
end;

procedure IncPtr(var hPtr:pointer);
begin
  if OffsetOf(hPtr)=$FFFF
  then hPtr:=Ptr(SelectorOf(hPtr)+Ofs(AHIncr),0)
  else inc(longint(hPtr));
end;

procedure DecPtr(var hPtr:pointer);
begin
  if OffsetOf(hPtr)=0
  then hPtr:=Ptr(SelectorOf(hPtr)-Ofs(AHIncr),$FFFF)
  else dec(longint(hPtr));
end;

{--------------- TWinScroller ---------------}

procedure TWinScroller.BeginView(PaintDC: HDC; var PaintInfo: TPaintStruct);
begin
  TScroller.BeginView(PaintDC, PaintInfo);
  with PDocument(Window)^ do
  begin
    Offset.X := XPos * XUnit;
    Offset.Y := YPos * YUnit;
  end;
end;


{--------------- TDocument -----------------}

function TDocument.CanClose: Boolean;
var testo:array[0..127]of char;
begin
if TWindowsObject.CanClose
then begin
     if modified
     then begin
          StrCopy(testo,'File ');StrCat(testo,FileName);
          StrCat(testo,' modified, Close ?');
          CanClose:=MessageBox(HWindow,testo,'WinSound!',MB_IconQuestion or MB_OkCancel)=id_Ok
          end
     else CanClose:=true;
     end
else CanClose:=false;
end;


constructor TDocument.Init(AParent: PWindowsObject; Title: PChar;TypeOfChild:integer);
var Tit:array[0..39]of char;
begin
  devmode:=0; (* null *)
  TypeOfDocument:=TypeOfChild;
  modified:=false;
  case TypeOfChild of
    zWaveId:StrCopy(Tit,'Wave: ');
    zFilterId:StrCopy(Tit,'Filter: ');
    zSystemId:StrCopy(Tit,'System: ');
    zLibraryId:StrCopy(Tit,'Library: ');
    end;
  if Title = nil
  then begin
       FileName[0]:=#0;
       StrCat(Tit,'(Untitled)')
       end
  else begin
       StrCopy(FileName,Title);
       StrCat(Tit,Title);
       end;

  TWindow.Init(AParent, Tit);
  case TypeOfChild of 
    zWaveId:   begin
                MyIcon:=LoadIcon(HInstance, 'FXICON');
                Menu := LoadMenu(HInstance,'MENU_WAVE');
               end;
    zFilterId: begin
                MyIcon:=LoadIcon(HInstance, 'FLTICON');
                Menu := LoadMenu(HInstance,'MENU_FILTER');
               end;
    zSystemId: begin
                MyIcon:=LoadIcon(HInstance, 'SYSICON');
                Menu := LoadMenu(HInstance,'MENU_SYSTEM');
               end;
    zLibraryId:begin
                MyIcon:=LoadIcon(HInstance, 'LIBICON');
                Menu := LoadMenu(HInstance,'MENU_LIBRARY');
               end;
    end;
  if OpenCounter = 0
  then begin
        MenuNil:=GetMenu(Application^.MainWindow^.HWindow);
        BitMap[zText] := LoadBitMap(hInstance, 'TEXT');
        BitMap[zSystemIO] := LoadBitMap(hInstance, 'SYSTEMIO');
       end;
  Inc(OpenCounter);
end;

destructor TDocument.Done;
var AMenu:HMenu;
    i:word;
BEGIN
  TWindow.Done;
  DestroyIcon(MyIcon);
  DestroyMenu(Menu);
  Dec(OpenCounter);
    IF OpenCounter = 0 THEN
      BEGIN                                        
        SetMenu(Application^.MainWindow^.HWindow,MenuNil);
        if pTool <> nil
        then pTool^.CloseWindow;
        for i:=zText to zLast
        do DeleteObject(BitMap[i]);

      END;
END;

procedure TDocument.GetWindowClass(var WndClass: TWndClass);
begin
  TWindow.GetWindowClass(WndClass);
  WndClass.hIcon := MyIcon;
end;

(*procedure TDocument.WMSize(var Msg:TMessage);
begin
  TWindow.WMSize(Msg);
  if IsIconic(HWindow)
  then InvalidateRect(HWindow, nil, True);
end;
*)

procedure TDocument.WMRButtonDown(var Msg: TMessage); 
(* Aggiunta per Floating Menu *)
var
  AMenu: HMenu;
  pos: integer;
begin
  if IsZoomed(HWindow)
  then pos:=2
  else pos:=1;
  AMenu := GetSubMenu(GetMenu(Application^.MainWindow^.HWindow),pos);
  ClientToScreen(HWindow, MakePoint(Msg.LParam));
  TrackPopupMenu(AMenu, TPM_RightButton, Msg.LParamLo, Msg.LParamHi, 0, HWindow, nil);
end;


procedure TDocument.WMSetFocus(var Msg:TMessage);
begin
  SetMenu(Application^.MainWindow^.HWindow,Menu);
end;

(* End: Aggiunta per MDI *)

procedure TDocument.PrintSetup(var Message: TMessage);
(* aggiunta per la stampante *)
var PrDlg: TPrintDlg;
begin
  FillChar(PrDlg, SizeOf(TPrintDlg), #0);
  with PrDlg
  do begin
      hInstance     := HInstance;
      hwndOwner     := HWindow;
      hDevmode      := devmode;
      flags         := PD_NoPageNums or PD_NoSelection or PD_PrintSetup;
      lStructSize   := sizeof(TPrintDlg);
     end;
  if PrintDlg(PrDlg)
  then devmode:= PrDlg.hDevmode;
end;

procedure TDocument.Draw(PaintDC: HDC; rect: TRect;left,right:integer);
(* aggiunta per la stampante *)
begin
  (* abstract *)
end;

procedure TDocument.Print(var Message: TMessage);
(* aggiunta per la stampante *)
var PrDlg: TPrintDlg;
    Doc: TDocInfo;
    r:TRect;
begin
  FillChar(PrDlg, SizeOf(TPrintDlg), #0);
  with PrDlg
  do begin
      hInstance     := HInstance;
      hwndOwner     := HWindow;
      hDevmode      := devmode;
      nCopies       := 1;
      flags         := PD_ReturnDC or PD_NoPageNums or PD_NoSelection;
      nFromPage     := 1;
      nToPage       := 1;
      lStructSize   := sizeof(TPrintDlg);
     end;
  if PrintDlg(PrDlg)
  then begin
       devmode:= PrDlg.hDevmode;
       with Doc
       do begin
            cbSize:=sizeof(TDocInfo);
            lpszDocName:='wsprint';
            lpszOutput:=nil;
          end;
       if (win31.StartDoc(PrDlg.hDC, Doc) > 0) and (StartPage(PrDlg.hDC) > 0)
       then begin
            GetClipBox(PrDlg.hDC,r);
            DrawText(PrDlg.hDC,FileName,-1,r,DT_Center);
            Draw(PrDlg.hDC,r,r.left,r.right);
            EndPage(PrDlg.hDC);
            win31.EndDoc(PrDlg.hDC);
            end
       else MessageBox(HWindow,'WS','Printer Error',MB_ICONEXCLAMATION or MB_OK);
       end;
end;


{--------------- TSystemWindow -------------}

constructor TSystemWindow.Init(AParent: PWindowsObject; Title: PChar);
begin
  TDocument.Init(AParent, Title, zSystemId);
  New(pSys,Init);
  MaxIterate:=9999;
  ButtonDown:=false;
  iDrag:=nil;
  if title <> nil
  then if not pSys^.ReadSystem(Title)
       then begin
            TDocument.Done;
            Dispose(pSys,Done);
            fail; (* autokill *)
            end;

  Attr.style:=Attr.Style or WS_VSCROLL or WS_HSCROLL;
  Scroller:=New(PWinScroller,Init(@Self,16,16,64,64));
  Offset.X := 0;
  Offset.Y := 0;
  end;

procedure TSystemWindow.GetWindowClass(var WndClass: TWndClass);
begin
  TDocument.GetWindowClass(WndClass);
  WndClass.hbrBackGround:=GetStockObject(White_Brush);
  WndClass.style := CS_DBLCLKS;
end;

procedure TSystemWindow.Paint(PaintDC: HDC;var PaintInfo: TPaintStruct);
var Temp:tPoint;
  procedure DrawBranch(Item:pBranch);far;
  begin
    Item^.Draw(PaintDC);
  end;

  procedure DrawItem(Item:pBase);far;
  begin
    Item^.Draw(PaintDC);
  end;

begin
  with pSys^
       do begin
           SelectObject(PaintDC, GetStockObject(White_Brush));
           SelectObject(PaintDC, GetStockObject(Black_Pen));
           pObjList^.ForEach(@DrawItem);
           pTextList^.ForEach(@DrawItem);
           pBranchList^.ForEach(@DrawBranch);
           pHookList^.ForEach(@DrawItem);
           if iDrag<>nil
           then begin
                temp.x:=zStep*iDrag^.x;
                temp.y:=zStep*iDrag^.y;
                iDrag^.DrawFocus(PaintDC,Temp);
                end;
           end;
end;


procedure Invert(HandleDC:HDC;var A,B:TPoint);
var ropOld,brOld:THandle;
begin
  brOld:=SelectObject(HandleDC, GetStockObject(Null_Brush));
  ropOld:=SetROP2(HandleDC, r2_Not);
  MoveTo(HandleDC,A.x,A.y);
  LineTo(HandleDC,B.x,B.y);
  SelectObject(HandleDC,brOld);
  SetROP2(HandleDC, ropOld)
end;



destructor TSystemWindow.Done;
begin
Dispose(PSys,Done);
TDocument.Done;
end;

procedure TSystemWindow.info(var Message: TMessage);
begin
  Application^.ExecDialog(new(PTSysInfoDialog,init(@Self,'SysInfo')));
end;

procedure TSystemWindow.Param(var Message: TMessage);
begin
  Application^.ExecDialog(new(PTSysParamDialog,init(@Self,'SysParam')));
end;

procedure TSystemWindow.Save(var Message: TMessage);
var fn:TFileName;
begin
  if modified
  then if StrLen(FileName) = 0
       then SaveAs(Message)
       else begin
            pSys^.WriteSystem(FileName);
            modified:=false;
            end;
end;

procedure TSystemWindow.SaveAs(var Message: TMessage);
const
  DefExt = 'sym';
var
  OpenFN      : TOpenFileName;
  fn          : TFileName;
begin
  StrCopy(FileName, '');
  FillChar(OpenFN, SizeOf(TOpenFileName), #0);
  with OpenFN do
  begin
    hInstance     := HInstance;
    hwndOwner     := HWindow;
    lpstrDefExt   := DefExt;
    lpstrFile     := FileName;
    lpstrFilter   := 'Systems'+#0+'*.sym'+#0+#0;
    lStructSize   := sizeof(TOpenFileName);
    nFilterIndex  := 1;       {Index into Filter String in lpstrFilter}
    nMaxFile      := SizeOf(FileName);
  end;
  if GetSaveFileName(OpenFN)
  then begin
        pSys^.WriteSystem(FileName);
        StrCopy(fn,'System: ');
        StrCat(fn,FileName);
        SetWindowText(HWindow,fn);
        modified:=false;
       end
end;


function TSystemWindow.HitTest(xx,yy:integer):pBase;
var pSearch:pBase;
(* Input:  xx,yy is the mouse position
   Output: HitTest is the index of Rectangle that include the mouse position
           or 0 if no Rectangle contains the mouse position
*)

     function Hit(Item: pBase): Boolean; far;
     begin
       Hit:=Item^.TestPoint(xx,yy);
     end;

begin
  psearch:=pSys^.pObjList^.FirstThat(@Hit);
  if psearch = nil
  then psearch:=pSys^.pTextList^.FirstThat(@Hit);
  if psearch = nil
  then psearch:=pSys^.pHookList^.FirstThat(@Hit);
  HitTest:=pSearch;
end;

procedure TSystemWindow.WMLButtonDown(var Msg: TMessage);
begin
  if not ButtonDown then
  begin
    ButtonDown := True;  { Mark mouse button as being     }
			 { pressed so when mouse movement }
			 { occurs, a line will be drawn.  }

    SetCapture(hWindow); { Tell Windows to send all mouse   }
			 { messages to window. WMLButtonUp  }
			 { method will release the capture. }

    HandleDC := GetDC(hWindow);    { Create display context for drawing. }
    iDrag:=HitTest(Msg.LParamLo+Offset.x,Msg.LParamHi+Offset.y);
    if iDrag<>nil
    then begin
         SetCursor(LoadCursor(0,IDC_Size));
         WorkPos.x:=zStep*iDrag^.x-Offset.x;
         WorkPos.y:=zStep*iDrag^.y-Offset.y;
         iDrag^.DrawFocus(HandleDC,WorkPos);
         ptDrag.x:=Msg.LParamLo;
         ptDrag.y:=Msg.LParamHi;
         end
    else begin
(*         WorkPos.iBitMap:=selBitMap;*)
         WorkPos.x:=Msg.LParamLo;
         WorkPos.y:=Msg.LParamHi;
         EndPos:=WorkPos;
         end;
  end;
end;

procedure TSystemWindow.WMMouseMove(var Msg: TMessage);

begin
  if ButtonDown
  then begin
       if iDrag = nil
       then begin
            Invert(HandleDC,WorkPos,EndPos);
            EndPos.x:=Msg.LParamLo;
            EndPos.y:=Msg.LParamHi;
            Invert(HandleDC,WorkPos,EndPos);
            end
       else begin
            iDrag^.DrawFocus(HandleDC,WorkPos);
            Inc(WorkPos.x,Msg.LParamLo-ptDrag.x);
            Inc(WorkPos.y,Msg.LParamHi-ptDrag.y);
            ptDrag.x:=Msg.LParamLo;
            ptDrag.y:=Msg.LParamHi;
            iDrag^.DrawFocus(HandleDC,WorkPos);
            end;
       end
end;

procedure TSystemWindow.WMUser(var Msg: TMessage);
var x,y:integer;
    pqwe:pointer;

   procedure NewText;
   var  p:PText;
        q:pBase;
   begin
     q:=HitTest(Msg.LParamLo+Offset.x,Msg.LParamHi+Offset.y);
     if (q<>nil)
     then if q^.IsLinkable
          then begin
               x:=q^.x;
               y:=q^.y + 8;
               end
          else q:=nil;
     p:=New(PText,Init(x,y,0,pSys,pLink(q))); (*????*)
     GetMem(p^.str,5);
     StrCopy(p^.str,'text');
     pSys^.pTextList^.insert(p);
   end;

   procedure NewSystemIO;
   var  p:PText;
        id:integer;
   begin
     with pSys^
     do begin
        id:=1;
        while (id<=MaxTerminal)and(Terminal[id]<>nil)
        do inc(id);
        if id<=MaxTerminal
        then pHookList^.insert(New(PHook,Init(x,y,id,pSys)))
        else MessageBox(HWindow,'Too many System terminals!','WinSound!',MB_IconAsterisk);
        end;
   end;


begin
  if pTool <> nil 
  then with pSys^
       do begin
              ScreenToClient(HWindow,MakePoint(Msg.LParam));
              x:=(Msg.LParamLo+Offset.x) div zStep;
              y:=(Msg.LParamHi+Offset.y) div zStep;
              modified:=true;
              if Msg.WParam and $8000 = 0
              then begin (* OBJECT *)
                   NewObj(pqwe,Msg.WParam,HWindow,pSys);
                   pObjList^.insert(New(PObj,
                         Init(x-zSizeX div 2,y-zSizeY div 2,0,pqwe,pSys)));
                   end
              else begin (* TOOL *)
                   case Msg.WParam of
                     zText:NewText;
                     zSystemIO:NewSystemIO;
                     end; { of case }
                   end;
              InvalidateRect(HWindow, nil, True);
          end;
end;

procedure TSystemWindow.WMLButtonUp(var Msg: TMessage);
var
    a,b:pHook;
    ax,ay,bx,by:integer;


   procedure RetrieveHook(x,y:integer;var z:pHook);

     function Matches(Item: pBase): Boolean; far;
     begin
       Matches:=(Item^.x = x)and(Item^.y = y)
     end;

   begin
     z:=pSys^.pHookList^.FirstThat(@Matches);
     if z = nil
     then begin
          z:=New(PHook,Init(x,y,pSys^.HookIdPeak,pSys));
          inc(pSys^.HookIdPeak);
          pSys^.pHookList^.insert(z);
          end;
   end;

begin
  if ButtonDown then
  begin
    ReleaseCapture; { Tell Windows to stop sending all mouse  }
                    { messages to this window.  Allow other   }
                    { applications to receive mouse messages. }
    ReleaseDC(hWindow,handleDC);
			 { Release display context created   }
                         { by WMLButtonDown method.          }
    ButtonDown := False; { Mark mouse button as not pressed. }
    if (integer(Msg.LParamLo)>0)and(integer(Msg.LParamHi)>0)
    then if iDrag = nil
         then begin
                   with WorkPos
                   do begin
                      ax:=(x+Offset.x+zStep2) div zStep;
                      ay:=(y+Offset.y+zStep2) div zStep;
                      end;
                   with Msg
                   do begin
                      bx:=(LParamLo+Offset.x+zStep2) div zStep;
                      by:=(LParamHi+Offset.y+zStep2) div zStep;
                      end;
                   if (ax<>bx)or(ay<>by)
                   then begin
                        RetrieveHook(ax,ay,a);
                        RetrieveHook(bx,by,b);
                        modified:=true;
                        pSys^.pBranchList^.insert(New(PBranch,Init(a,b)));
                        end;
                   InvalidateRect(HWindow, nil, True);
                   end
         else begin
     (*         iDrag^.DrawFocus(HandleDC,WorkPos);*)
              with Msg
              do begin
                 modified:=true;
                 iDrag^.Move((WorkPos.x+Offset.x) div zStep,(WorkPos.y+Offset.y) div zStep);
                 end;
              InvalidateRect(HWindow, nil, True);
              end
      else InvalidateRect(HWindow, nil, True);
    EnableEditMenu(iDrag <> nil);
  end
end;

procedure TSystemWindow.WMLButtonDBLCLK(var Msg: TMessage);
begin
if iDrag <> nil
then begin
     iDrag^.DBLCLK(@Self);
     InvalidateRect(HWindow, nil, True); (* CORR 5/94 *)
     end
end;

function TSystemWindow.GetClassName: PChar;
begin
  GetClassName := 'SystemWindow';
end;

procedure TSystemWindow.Cut(var Message: TMessage);
begin
if iDrag <> nil
then begin
     iDrag^.Copy;
     iDrag^.Delete;
     iDrag:=nil;EnableEditMenu(false);
     InvalidateRect(HWindow, nil, true);
     end;
end;

procedure TSystemWindow.Copy(var Message: TMessage);
begin
if iDrag <> nil
then begin
     iDrag^.Copy;
     EnableMenuItem(Menu, idm_Paste, MF_Enabled or MF_ByCommand);
     end;
end;

procedure TSystemWindow.Paste(var Message: TMessage);
begin
if SystemBuffer<>''
then begin
     case SystemBuffer[1] of
       'u':pSys^.ReadObj(SystemBuffer);
       't':pSys^.ReadText(SystemBuffer);
       end; (* of case *)
     InvalidateRect(HWindow, nil, true);
     end;
end;

procedure TSystemWindow.Unbind(var Message: TMessage);
begin
if iDrag <> nil
then begin
     iDrag^.Unbind;
     InvalidateRect(HWindow, nil, true);
     end;
end;

procedure TSystemWindow.ObjProps(var Message: TMessage);
begin
if iDrag <> nil
then iDrag^.DBLCLK(@Self);
end;


procedure TSystemWindow.Check(var Message: TMessage);
var result:integer;
    Str:array[0..40]of char;
    start,scan,stop:pObj;
    dummy:AIOprop;  (* MACRO SUPPORT: not used by TSystemWindow.Check !!! *)
begin
  result:=pSys^.CheckSystem(start);
  if result <> 0
  then begin
         LoadString(HInstance, 110+result, Str, Sizeof(Str));
         MessageBox(HWindow,Str,'Check',MB_Ok or MB_IconInformation);
         exit;
       end;
  if start<>nil
  then begin
       scan:=start;
       result:=CheckSys(scan,dummy);
       if scan = nil
       then MessageBox(HWindow,'System syntax is correct','Check',MB_ok or MB_IconInformation)
       else begin
            iDrag:=scan;EnableEditMenu(iDrag <> nil);
            LoadString(HInstance, 120+result, Str, Sizeof(Str));
            MessageBox(HWindow,Str,'Check',MB_Ok or MB_IconInformation);
            InvalidateRect(HWindow, nil, true);
            exit;
            end;
      end;
  end;


procedure TSystemWindow.Run(var Message: TMessage);
var result:integer;
    Str:array[0..40]of char;
    start,scan,stop:pObj;
    NewBlockSize:longint;
    dummy:AIOprop;  (* MACRO SUPPORT: not used by TSystemWindow.Run !!! *)
begin
  result:=pSys^.CheckSystem(start);
  if result <> 0
  then begin
         LoadString(HInstance, 110+result, Str, Sizeof(Str));
         MessageBox(HWindow,Str,'Check',mb_ok);
         exit;
       end;
  if start<>nil
  then begin
       NewBlockSize:=0;
       scan:=start;
       while scan <> nil
       do begin
            GetBufSize(scan^.pqwe,NewBlockSize);
            scan:=scan^.next;
          end;
       if NewBlockSize <> 0
       then pSys^.BlockSize := NewBlockSize;
     (* start analysis *)
       scan:=start;
       result:=StartSys(scan,dummy,pSys^.BlockSize,HWindow);
       if result <> 0
       then begin
            LoadString(HInstance, 120+result, Str, Sizeof(Str));
            MessageBox(HWindow,Str,'Check',mb_ok);
            iDrag:=scan;EnableEditMenu(iDrag <> nil);
            InvalidateRect(HWindow, nil, true);
            exit;
            end;
     pa:=start;hAnaWindow:=hwindow;iterate:=0;
     childp:=new(PTRunDialog,init(@Self,'Run'));
     if Application^.ExecDialog(childp) = IdCancel
     then begin
          hAnaWindow:=0; (* ANALYSIS ABORTED *)
          scan:=start;
          while (scan<>nil)
          do begin
             StopAnalysis(scan^.pqwe);
             scan:=scan^.next;
             end;
          end;
     end;
end;

procedure TSystemWindow.WMAnalysis(var Msg: TMessage);
var result,i:integer;
    start,scan,stop:pObj;
    endanalysis:boolean;
begin
   if MSG.WParam=HWindow
   then begin
        start:=pa;
        if pSys^.blocksize = 0
        then endanalysis:=true (* ONE-SHOT ANALYSIS *)
        else endanalysis:=false;
(*        repeat*)
        scan:=start;
        while (scan<>nil)
        do begin
           for i:=1 to MaxTerminal
           do if scan^.backward[i].obj<>nil(*AP2: sarebbe meglio non basarsi su backward[]*)
              then with scan^.backward[i]
                   do scan^.iobuf[i]:=obj^.iobuf[terminal];
           if Analysis(scan^.pqwe,scan^.iobuf) <> 0
           then endanalysis:=true;
           scan:=scan^.next;
           end;
(*        until endanalysis;*)
        if endanalysis or (iterate > MaxIterate)
        then begin

             hAnaWindow:=0;
             ChildP^.EndDlg(0);
             scan:=start;
             while (scan<>nil)
             do begin
                StopAnalysis(scan^.pqwe);
                scan:=scan^.next;
                end;
             end
        else (*MT: PostMessage(HWindow,WM_U_Analysis,HWindow,longint(start));*)
             begin
             inc(Iterate);
             PostMessage(ChildP^.HWindow,WM_U_Notify,ChildList^.HWindow,0);
             end;
   end;
end;

procedure TSystemWindow.WMSetFocus(var Msg:TMessage);
begin
(*  SetMenu(Application^.MainWindow^.HWindow,Menu);*)
  TDocument.WMSetFocus(Msg);
  EnableEditMenu(iDrag <> nil);
  if pTool = nil
  then pTool:=Application^.MakeWindow(
      New(PToolbox, Init(nil, 'ToolBox')));
end;

procedure TSystemWindow.EnableEditMenu(enable: boolean);
var mf_Flag: integer;
begin
  if enable
  then mf_Flag:=MF_Enabled or MF_ByCommand
  else mf_Flag:=MF_Grayed or MF_ByCommand;
  EnableMenuItem(Menu, idm_Cut, mf_Flag);
  EnableMenuItem(Menu, idm_Copy, mf_Flag);
  EnableMenuItem(Menu, idm_Unbind, mf_Flag);
  EnableMenuItem(Menu, idm_ObjProps, mf_Flag);
  if SystemBuffer <> ''
  then EnableMenuItem(Menu, idm_Paste, MF_Enabled or MF_ByCommand);
end;

{--------------- TFilterWindow -------------}

constructor TFilterWindow.Init(AParent: PWindowsObject; Title: PChar);
begin
  TDocument.Init(AParent, Title, zFilterId);
  filterp:=nil;
  gain.size:=100; (*??*)
  maxgain:=0;
  GetMem(gain.buf,gain.size*sizeof(real));
end;

procedure TFilterWindow.Draw(PaintDC: HDC; rect: TRect;left,right:integer);
var i,m,delta,width,height:longint;
    j:integer;
begin
  if (maxgain <> 0) and (filterp <> nil)
  then begin
       width:=Rect.right;
       height:=Rect.bottom;
       if gain.size > width
       then begin
            delta:=gain.size div width;
            m:=0;j:=0;
            for i:=0 to (right *gain.size)div width - 1
            do begin
               if j >= left
               then SetPixel(PaintDC,j,round((1-RealArray(gain.buf^)[j]/maxgain)*height),GetSysColor(Color_WindowText));
               if i>m
               then begin
                    inc(m,delta);
                    inc(j);
                    end;
               end;
            end
       else begin
            delta:=width div gain.size;
            m:=0;j:=0;i:=0;
            MoveTo(PaintDC,0,round((1-RealArray(gain.buf^)[j]/maxgain)*height));
            while (j<gain.size)
            do begin
               if i>m
               then begin
                    LineTo(PaintDC,i,round((1-RealArray(gain.buf^)[j]/maxgain)*height));
                    inc(m,delta);
                    inc(j);
                    end;
               inc(i);
               end;
            end;
       end;
end;

procedure TFilterWindow.Paint(PaintDC: HDC;var PaintInfo: TPaintStruct);
var rect:TRect;
begin
  GetClientRect(HWindow,Rect);
  with PaintInfo.rcpaint
  do Draw(PaintDC,Rect,left,right);
end;

function TFilterWindow.GetClassName: PChar;
begin
  GetClassName := 'FilterWindow';
end;

destructor TFilterWindow.Done;
begin
if filterp<>nil
then Dispose(filterP,Done);
FreeMem(gain.buf,gain.size*sizeof(real));
TDocument.Done;
end;

procedure TFilterWindow.FilEdit(var Message: TMessage);
begin
  Application^.ExecDialog(new(PTFilterDialog,init(@Self,'Filter')));
end;

procedure TFilterWindow.Info(var Message: TMessage);
begin
  MessageBox(HWindow,'Not implemented','WinSound!',MB_ok);
end;

{--------------- TWaveWindow -----------------}
type ttag=array[0..3] of char; (* DON'T CHANGE THIS *)
type tcuedef= record
             id,id1:longint;
             tag:ttag;
             dummy1,dummy2,start: longint
           end;
const list: ttag='LIST';
      data: ttag='data';
      cue:  ttag='cue ';
      adtl: ttag='adtl';
      ltxt: ttag='ltxt';
      labl: ttag='labl';
      mark: ttag='mark';

type  ttl = record                 (* DON'T CHANGE THIS *)
             tag: ttag;
             length: longint;
            end;


destructor TWaveWindow.Done;
var nextp:pCue;
begin
TDocument.Done;
if MemHandle <> 0
then GlobalFree(MemHandle);
while cuep <> nil
do begin
     nextp:=cuep^.next;
     StrDispose(cuep^.labl);
     dispose(cuep);
     cuep:=nextp;
   end;
end;

function TWaveWindow.GetClassName: PChar;
begin
  GetClassName := 'WaveWindow';
end;

constructor TWaveWindow.Init(AParent: PWindowsObject; Title: PChar);
var i,f:integer;
    Str:array[0..39]of char;

  (* modifica <cue> *)
  function FindCue(id:longint):pCue;
  var p: pCue;
  begin
    p:=cuep;
    while (p <> nil) and (p^.id <> id)
    do p:=p^.next;
    FindCue:=p;
  end;


  procedure StoreCue;
  var  tcue: tcuedef;
       i: integer;
       first, last: pCue;
  begin
    first:=cuep;
    _lread(f, @n_cues, 4);
    for i:=1 to n_cues
    do begin
        _lread(f, @tcue, sizeof(tcue));
        new(last);
        with last^
        do begin
             id:=tcue.id;
             start:=tcue.start;
             length:=0;
             labl:=nil;
             next:=nil;
           end;
        if first = nil
        then first:=last;
        if cuep = nil
        then cuep:=last
        else begin
             cuep^.next:=last;
             cuep:=last;
             end;
       end;
  cuep:=first;
  end;

  procedure Adjust(var value: longint);
  (* le lunghezze dispari devono essere incrementate *)
  begin
    if odd(value)
    then inc(value);
  end;

  procedure ReadCue;
  var  tl: ttl;
       tag: ttag;
       l:longint;

    procedure process_adtl;
    var id: longint;
        p: pCue;
    begin
      _lread(f, @tl, sizeof(tl)); dec(l, sizeof(tl));
      Adjust(tl.length);
      if tl.tag = ltxt
      then begin
             _lread(f, @id, 4); dec(tl.length, 4); dec(l,4);
             p:=FindCue(id);
             if p <> nil
             then begin
                  _lread(f, @p^.length, 4);dec(tl.length, 4); dec(l,4);
                  end;
           end;
      if tl.tag = labl
      then begin
             _lread(f, @id, 4); dec(tl.length, 4); dec(l,4);
             p:=FindCue(id);
             if p <> nil
             then begin
                  GetMem(p^.labl, tl.length);
                  _lread(f, @p^.labl^, tl.length); dec(l,tl.length);
                  tl.length:=0;
                  end;
           end;
      _llseek(f, tl.length, 1); dec(l, tl.length);
    end;

  begin
    while _lread(f, @tl, sizeof(tl)) = sizeof(tl)
    do begin
         if tl.tag = cue
         then StoreCue
         else if tl.tag = list
              then begin
                     l:=tl.length;
                     _lread(f, @tag, 4);dec(l,4);
                     if tag = adtl
                     then while l <> 0
                          do process_adtl
                     else _llseek(f, l, 1)
                   end
              else _llseek(f, tl.length, 1);
       end;
  end;

begin
  MemHandle:=0;
  TDocument.Init(AParent, Title, zWaveId);
  ButtonDown:=false;
  n_cues:=0;
  cuep:=nil;
  if Title = nil
  then begin
       nsamples:=0;
       samplerate:=0;
       end
  else begin
       i:=OpenWave(f,Title,samplerate,nsamples);
       if i = 0
       then begin
            MemHandle:=GlobalAlloc(GHnd,nsamples);
            if MemHandle <> 0
            then begin
                 _LongRead(f,GlobalLock(MemHandle),nsamples);
                 GlobalUnlock(MemHandle);
                 ReadCue;
                 _lclose(f);
                 end
            else begin
                 TDocument.Done;
                 fail; (* autokill *)
                 end
            end
       else begin
            LoadString(HInstance, 100+i, Str, Sizeof(Str));
            MessageBox(HWindow,Str,'WaveFile',mb_ok);
            TDocument.Done;
            fail; (* autokill *)
            end
       end;
  lsample:=0;rsample:=nsamples - 1;
  LeftMark:=lsample;  (* -1 means that Mark is not valid *)
  RightMark:=rsample; (* -1 means that Mark is not valid *)
  end;

procedure TWaveWindow.DrawMarker(HandleDC:HDC;x:longint;rect:TRect);
var ropOld:THandle;
begin
  x:=(x - lsample) * rect.right div (rsample - lsample);
  MoveTo(HandleDC,x,0);
  ropOld:=SetROP2(HandleDC, r2_Not);
  LineTo(HandleDC,x,rect.bottom);
  SetROP2(HandleDC, ropOld)
end;

procedure TWaveWindow.Draw(PaintDC: HDC; rect: TRect;left,right:integer);
var i,m,delta,width:longint;
    j:integer;
    MemPtr: pointer;
    min,max:integer;

begin
  if MemHandle <> 0
  then  begin
        SetCursor(LoadCursor(0, IDC_Wait));
        width:=Rect.right;
        SetMapMode(PaintDC,MM_Anisotropic);
        SetWindowExt(PaintDC,1,256);
        SetViewPortExt(PaintDC,1,Rect.bottom);
        if rsample-lsample >= width
        then begin
             delta := (rsample - lsample + 1) div width;
             min := 255;max := 0;
             j := left;
             m :=delta * (j + 1);
             MemPtr := GlobalLockOff(MemHandle,lsample + delta * j);
             for i := delta * j to right * delta - 1
             do begin
                if min > byte(MemPtr^)
                then min := byte(MemPtr^);
                if max < byte(MemPtr^)
                then max := byte(MemPtr^);
                if i = m
                then begin
                     MoveTo(PaintDC,j,min);
                     LineTo(PaintDC,j,max + 1);
                     min:= 255;max:= 0;
                     inc(m, delta);
                     inc(j);
                     end;
                IncPtr(MemPtr);
                end;
             end
        else begin
             MemPtr := GlobalLockOff(MemHandle,lsample);
             j:=0;m:=0;MoveTo(PaintDC,0,byte(MemPtr^));
             for i:=0 to rsample-lsample
             do begin
                LineTo(PaintDC,j,byte(MemPtr^));
                inc(longint(MemPtr));
                inc(m,width);
                while (m > rsample-lsample + 1)
                do begin
                     dec(m,rsample-lsample + 1);
                     inc(j);
                   end;
                end;
             end;
        SetViewPortExt(PaintDC,1,256); (* restore mapping *)
        GlobalUnlock(MemHandle);
        SetCursor(LoadCursor(0, idc_Arrow));
        end;
end;

procedure TWaveWindow.Paint(PaintDC: HDC;var PaintInfo: TPaintStruct);
var rect:TRect;
    p: pCue;

    procedure DrawCue(HandleDC:HDC;p:pCue;rect:TRect);
    var OldPen: HPen;
        a,b: integer;
        tr: TRect;
    begin
      b:=(p^.start + p^.length - lsample) * rect.right div (rsample - lsample);
      a:=(p^.start - lsample) * rect.right div (rsample - lsample);
      with tr
      do begin
           left:=a;
           top:=0;
           right:=b;
           bottom:=rect.bottom;
         end;
      OldPen := SelectObject(PaintDC, CreatePen(PS_SOLID, 1, RGB(255,0,0)));
      MoveTo(PaintDC,a,0);
      LineTo(PaintDC,a,rect.bottom);
      MoveTo(PaintDC,b,0);
      LineTo(PaintDC,b,rect.bottom);
      DrawText(PaintDC,p^.labl,-1,tr,DT_Center or DT_NoClip);
      DeleteObject(SelectObject(PaintDC, OldPen));
    end;


begin
  GetClientRect(HWindow,Rect);
  with PaintInfo.rcpaint
  do Draw(PaintDC,Rect,left,right);
  if leftmark <> -1
  then DrawMarker(PaintDC,LeftMark,Rect);
  if rightmark <> -1
  then DrawMarker(PaintDC,RightMark,Rect);
  p:=cuep;
  while p <> nil
  do begin
       DrawCue(PaintDC,p,Rect);
       p:=p^.next;
     end;
end;

procedure TWaveWindow.WMLButtonDown(var Msg: TMessage);
var HandleDC:HDC;
    Rect:TRect;
begin
  if MemHandle = 0
  then exit;
  buttondown:=true;
  HandleDC := GetDC(hWindow);    { Create display context for drawing. }
  SetCapture(hWindow);
  GetClientRect(HWindow,Rect);
  if rightmark <> -1
  then DrawMarker(HandleDC,rightmark,Rect);
  rightmark := -1;
  if leftmark <> -1
  then DrawMarker(HandleDC,LeftMark,Rect);
  tmark := integer(Msg.LParamLo) * (rsample - lsample) div Rect.right + lsample;
  leftmark := tmark;
  DrawMarker(HandleDC, tMark, Rect);
  ReleaseDC(hWindow,HandleDC);
end;

procedure TWaveWindow.WMLButtonUp(var Msg: TMessage);
begin
  if buttondown
  then begin
       WMMouseMove(Msg);
       if tmark < leftmark
       then begin
              rightmark:=leftmark;
              leftmark:=tmark;
            end
       else rightmark:=tmark;
       if rightmark = leftmark
       then rightmark:=-1;
       buttondown:=false;
       ReleaseCapture;
       end;
end;

procedure TWaveWindow.WMMouseMove(var Msg: TMessage);
var HandleDC:HDC;
    Rect:TRect;
    t:longint;

    procedure Validate(var x:longint);
    begin
    if x < 0
    then x := 0
    else if x >= nsamples
         then x := nsamples - 1;
    end;

begin
  if buttondown
  then begin
       HandleDC := GetDC(hWindow);    { Create display context for drawing. }
       GetClientRect(HWindow,Rect);
       if tmark <> leftmark
       then DrawMarker(HandleDC, tmark, Rect);
       tmark := integer(Msg.LParamLo) * (rsample - lsample) div Rect.right + lsample;
       Validate(tmark);
       if leftmark <> tmark
       then DrawMarker(HandleDC, tmark, Rect);
       ReleaseDC(hWindow,HandleDC);
       end;
end;


procedure TWaveWindow.Zoom(var Message: TMessage);
begin
  if leftmark <> -1
  then begin
       lsample:=leftmark;
       end;
  if rightmark <> -1
  then begin
       rsample:=rightmark;
       end;
  InvalidateRect(HWindow, nil, True);
end;

procedure TWaveWindow.Restore(var Message: TMessage);
begin
  if MemHandle <> 0
  then begin
       leftmark:=lsample;
       rightmark:=rsample;
       lsample:=0;
       rsample:=nsamples - 1;
       InvalidateRect(HWindow, nil, True);
       end;
end;

procedure TWaveWindow.Copy(var Message: TMessage);
var ClipHandle:THandle;
    ClipPtr,MemPtr:pointer;

    procedure WriteHeader(mem:pointer;fsample,nsample:longint);
    const skel:array[0..43]of char=('R','I','F','F','$',#0,#0,#0,'W','A','V','E','f','m','t',' ',
             #16,#0,#0,#0,#1,#0,#1,#0,#0,#0,#0,#0,#0,#0,#0,#0,
             #1,#0,#8,#0,'d','a','t','a',#0,#0,#0,#0);
    begin
         longint((@skel[4])^):=nsample+36;
         longint((@skel[24])^):=fsample;
         longint((@skel[28])^):=fsample;
         longint((@skel[40])^):=nsample;
         move(skel,mem^,44);
    end; { of WriteHeader }

begin
  if (MemHandle <> 0)and(rightmark <> -1)and(leftmark <> -1)
     and (rightmark <> leftmark)
  then begin
       ClipHandle:=GlobalAlloc(GHnd,44+(RightMark-LeftMark+1));
       if ClipHandle <> 0
       then begin 
            ClipPtr:=GlobalLock(ClipHandle);
            MemPtr:=GlobalLockOff(MemHandle,LeftMark);
            WriteHeader(ClipPtr,samplerate,(RightMark-LeftMark+1));
            inc(longint(ClipPtr),44);
            hMemCpy(ClipPtr,MemPtr,(RightMark-LeftMark+1));
            GlobalUnlock(MemHandle);
            GlobalUnlock(ClipHandle);
            if OpenClipBoard(HWindow) and EmptyClipBoard
            then begin
                 SetClipBoardData(cf_Wave, ClipHandle);
                 CloseClipBoard;
                 end
            else GlobalFree(ClipHandle);
            end;
       end;
end;

procedure TWaveWindow.Paste(var Message: TMessage);
var ClipHandle,Temp:THandle;
    ClipPtr,MemPtr,SPtr,DPtr:pointer;
    fs,samples,i:longint;
begin
  if OpenClipBoard(HWindow)
  then begin
       ClipHandle:=GetClipBoardData(cf_Wave);
       if ClipHandle <> 0
       then begin
            ClipPtr:=GlobalLock(ClipHandle);
            inc(longint(ClipPtr),24);
            fs:=longint(ClipPtr^);
            inc(longint(ClipPtr),16);
            samples:=longint(ClipPtr^);
            inc(longint(ClipPtr),4);
            if MemHandle = 0
            then begin
                 Temp := GlobalAlloc(GHnd,samples);
                 samplerate:= fs;
                 end
            else Temp := GlobalRealloc(MemHandle,nsamples+samples,0);
            if Temp <> 0
            then begin
                 MemHandle:=Temp;
                 if LeftMark = -1
                 then LeftMark := 0;
                 MemPtr:=GlobalLock(MemHandle);
                 SPtr := Ptr(SelectorOf(MemPtr) + HiWord(nsamples) * Ofs(AHIncr),LoWord(nsamples));
                 DPtr := Ptr(SelectorOf(MemPtr) + HiWord(nsamples+samples) * Ofs(AHIncr),LoWord(nsamples+samples));
                 for i:=nsamples - 1 downto LeftMark
                 do begin
                    DecPtr(DPtr); (* AP6: Win16 ? *)
                    DecPtr(SPtr);
                    byte(DPtr^):=byte(SPtr^);
                    end;
                 hmemcpy(SPtr,ClipPtr,samples);
                 Inc(rsample,samples);
                 Inc(nsamples,samples);
                 RightMark:=LeftMark+samples-1;
                 GlobalUnlock(MemHandle);
                 InvalidateRect(HWindow, nil, True);
                 modified:=true;
                 end;
            GlobalUnlock(ClipHandle);
            end;
       CloseClipBoard;
       end
end;

procedure TWaveWindow.Cut(var Message: TMessage);
var SPtr,DPtr,MemPtr:pointer;
    i:longint;
begin
  if (MemHandle <> 0)and(rightmark <> -1)and(leftmark <> -1)
     and (rightmark <> leftmark)
  then begin
         TWaveWindow.Copy(Message);
         MemPtr:=GlobalLock(MemHandle);
         SPtr := Ptr(SelectorOf(MemPtr) + HiWord(RightMark) * Ofs(AHIncr),LoWord(RightMark));
         DPtr := Ptr(SelectorOf(MemPtr) + HiWord(LeftMark) * Ofs(AHIncr),LoWord(LeftMark));
         for i:=RightMark + 1 to nsamples - 1
         do begin
            byte(DPtr^):=byte(SPtr^);
            IncPtr(DPtr); (* AP6: Win16 ? *)
            IncPtr(SPtr);
            end;
         Dec(rsample,RightMark-LeftMark+1);
         Dec(nsamples,RightMark-LeftMark+1);
         RightMark:=-1;
         GlobalUnlock(MemHandle);
         MemHandle:=GlobalRealloc(MemHandle,nsamples,0);
         InvalidateRect(HWindow, nil, True);
         modified:=true;
       end;
end;

procedure TWaveWindow.selectAll(var Message: TMessage);
begin
  LeftMark:=0;
  RightMark:=nsamples-1;
  InvalidateRect(HWindow, nil, True);
end;

procedure TWaveWindow.CueList(var Message: TMessage);
begin
  Application^.ExecDialog(new(PDialogList,init(@Self,'CUELIST')))
end;



procedure TWaveWindow.WriteWave(fn:TFileName);
var f:file;

  procedure WriteCue;
  const filler : byte = 0;
  var  tcue: tcuedef;
       tlength: record
                  id,length:longint;
                  tag:ttag;
                  dummy1,dummy2:longint;
                end;
       tl: ttl;
       p: pCue;
       vlength: longint;
  begin
    p:=cuep;
    tl.tag:=cue;
    tl.length:=4 + n_cues * sizeof(tcue);
    blockwrite(f, tl, sizeof(tl));
    blockwrite(f, n_cues, 4);
    vlength:=0;
    while p <> nil
    do begin
        with tcue
        do begin
             id:=p^.id;
             id1:=id;
             tag:=data;
             dummy1:=0;
             dummy2:=0;
             start:=p^.start;
             if p^.labl <> nil
             then begin
                  vlength:=vlength + StrLen(p^.labl) + 5 + sizeof(tl);
                  if odd(vlength)
                  then inc(vlength);
                  end;
           end;
        blockwrite(f, tcue, sizeof(tcue));
        p:=p^.next;
        end;

    p:=cuep;
    tl.tag:=list;
    tl.length:=4 + n_cues * (sizeof(tlength) + sizeof(tl)) + vlength;
    blockwrite(f, tl, sizeof(tl));
    blockwrite(f, adtl, 4);
    while p <> nil
    do begin
        tl.tag:= ltxt;
        tl.length:= sizeof(tlength);
        blockwrite(f, tl, sizeof(tl));
        with tlength
        do begin
             id:=p^.id;
             length:=p^.length;
             tag:=mark;
             dummy1:=0;
             dummy2:=0;
           end;
        blockwrite(f, tlength, sizeof(tlength));

        if p^.labl <> nil
        then begin
             tl.tag:=labl;
             tl.length:=4 + StrLen(p^.labl) + 1;
             blockwrite(f, tl, sizeof(tl));
             blockwrite(f, p^.id, 4);
             blockwrite(f, p^.labl^, StrLen(p^.labl) + 1);
             if odd(tl.length)
             then blockwrite(f, filler , 1);
             end;
        p:=p^.next;
        end;

  end;

begin
  if WriteHeader(f,fn,samplerate,nsamples) = 0
  then begin
       LongWrite(f,GlobalLock(MemHandle),nsamples);
       if cuep <> nil
       then WriteCue;
       Close(f);
       GlobalUnlock(MemHandle);
       end;
end;

procedure TWaveWindow.Save(var Message: TMessage);
begin
  if modified
  then if StrLen(FileName) = 0
       then SaveAs(Message)
       else begin
            WriteWave(FileName);
            modified:=false;
            end;
end;

procedure TWaveWindow.SaveAs(var Message: TMessage);
const
  DefExt = 'wav';
var
  OpenFN      : TOpenFileName;
  fn          : TFileName;
begin
  StrCopy(FileName, '');
  FillChar(OpenFN, SizeOf(TOpenFileName), #0);
  with OpenFN do
  begin
    hInstance     := HInstance;
    hwndOwner     := HWindow;
    lpstrDefExt   := DefExt;
    lpstrFile     := FileName;
    lpstrFilter   := 'Waves'+#0+'*.wav'+#0+#0;
    lStructSize   := sizeof(TOpenFileName);
    nFilterIndex  := 1;       {Index into Filter String in lpstrFilter}
    nMaxFile      := SizeOf(FileName);
  end;
  if GetSaveFileName(OpenFN)
  then begin
        WriteWave(FileName);
        StrCopy(fn,'System: ');
        StrCat(fn,FileName);
        SetWindowText(HWindow,fn);
        modified:=false;
       end
end;


procedure TWaveWindow.info(var Message: TMessage);
begin
  Application^.ExecDialog(new(PTinfoDialog,init(@Self,'WAVInfo')))
end;

(* EXT-WAVE *)
function StartAnalysis(p:pointer;var prop:AIOprop;bufsize:longint;HWindow:HWnd):TResult;far;external 'WSDLL';
procedure Capability(p:pointer;var Attr:TAttrDev;var IOClass:TAIOClass);far;external 'WSDLL';
function DialogObj(HWindow:HWnd;pqwe:pointer):integer;far;external 'WSDLL';(*5555*)

procedure TWaveWindow.ProcessWave(var name:string;buffersize:longint;dialog:boolean);
var ioprop:AIOProp;
    Str:array[0..40]of char;
    i,result:integer;
    size:longint;
    AttrDev:TAttrDev;
    AttrIO:TAIOClass;
begin
  BufSize:=buffersize;
(* EXT-WAVE *)
  if MemHandle = 0
  then exit;

  NewFromStr(process,name,1,nil);
(* la variabile <dialog> esiste dovra' essere soppressa !!! *)
  if dialog and (DialogObj(HWindow,process) <> 1)  (*5555*)
  then begin
       DisposeObj(process);
       exit;
       end;
  Capability(process,AttrDev,AttrIO);
  HasOutput:=(AttrIO[2] and zOutput) <> 0;
  if (leftmark = -1)
  then begin
       start:=0;
       size:=nsamples;
       end
  else begin
       start:=leftmark;
       size:=nsamples-leftmark;
       end;
  if rightmark <> -1
  then dec(size,nsamples-rightmark-1);
  ioprop[1].attr:=zByte or zSampled or zSimple;
  ioprop[1].fsample:=samplerate;
  for i:=2 to MaxTerminal
  do begin
     ioprop[i].attr:=zNone;
     end;
  result := StartAnalysis(process,ioprop,BufSize,HWindow);
  if result <> 0
  then begin
         LoadString(HInstance, 120+result, Str, Sizeof(Str));
         MessageBox(HWindow,Str,'Wave',MB_ok);
       end
  else begin
       BufPtr:=GlobalLock(MemHandle);residual:=size;
       hAnaWindow:=hwindow;iterate:=0;
       childp:=new(PTRunDialog,init(@Self,'Run'));
       if Application^.ExecDialog(childp) = IdCancel
       then begin
            hAnaWindow:=0; (* ANALYSIS ABORTED *)
            StopAnalysis(process);
            GlobalUnlock(MemHandle);
            end;
       end;
  DisposeObj(process);
end;

procedure TWaveWindow.WMAnalysis(var Msg: TMessage);
var result,i:integer;
    endanalysis:boolean;
    shortest:longint;
    iobuf:AIObuf;
begin
   if MSG.WParam=HWindow
   then begin
        endanalysis:=false;
        if residual = 0
        then endanalysis:=true
        else begin
             iobuf[1].buf := Ptr(SelectorOf(BufPtr) + HiWord(start) * Ofs(AHIncr),LoWord(start));
             if residual < BufSize
             then iobuf[1].size:=residual
             else iobuf[1].size:=BufSize;
             dec(residual,iobuf[1].size);
             inc(start,iobuf[1].size);
             if Analysis(process,iobuf) <> 0
             then endanalysis:=true
             else if HasOutput
                  then begin
                       if iobuf[2].size > iobuf[1].size
                       then shortest:=iobuf[1].size
                       else shortest:=iobuf[2].size;
                       hmemcpy(iobuf[1].buf,iobuf[2].buf,shortest);
                       end;
             end;
        if endanalysis
        then begin
             hAnaWindow:=0;
             ChildP^.EndDlg(0);
             StopAnalysis(process);
             GlobalUnlock(MemHandle);
             if HasOutput
             then begin
                  InvalidateRect(HWindow, nil, True);
                  modified:=true;
                  end;
             end
        else (*MT: PostMessage(HWindow,WM_U_Analysis,HWindow,longint(start));*)
             begin
             inc(Iterate);
             PostMessage(ChildP^.HWindow,WM_U_Notify,ChildList^.HWindow,0);
             end;
   end;
end;


procedure TWaveWindow.Play(var Message: TMessage);
var str:string;

begin
(* Vecchio metodo:
  if not sndPlaySound(FileName,0)
  then MessageBox(HWindow,'Cannot play sound','WinSound!',MB_ok);*)
  str:='System;WSXYZ.SYM.PLAY';
  ProcessWave(str,32768,false);
end;

procedure TWaveWindow.Eco(var Message: TMessage);
var str:string;
begin
  str:='System;WSXYZ.SYM.ECO';
  ProcessWave(str,4096,true);
end;

procedure TWaveWindow.View(var Message: TMessage);
var str:string;
begin
  str:='System;WSXYZ.SYM.VIEW';
  ProcessWave(str,1024,false);
end;

procedure TWaveWindow.Rec(var Message: TMessage);
var str:string;
begin
  str:='System;WSXYZ.SYM.RECORD';
  ProcessWave(str,32768,false);
end;


{--------------- TLibraryWindow -------------}

constructor TLibraryWindow.Init(AParent: PWindowsObject; Title: PChar);
var str:array[0..255]of char;
begin
  TDocument.Init(AParent, Title, zLibraryId);
  if StrLen(FileName) = 0
  then openflag:=false
  else begin
       assign(f,FileName);
       {$I-}
       reset(f);
       {$I+}
       if IOResult<>0
       then begin
            TDocument.Done;
            fail;
            exit;
            end;
       readln(f,str);  (* AP7: che succede se la lunghezza della linea e' maggiore di 255 ?*)
       if StrLComp(str,'lib;',4) <> 0
       then begin
            TDocument.Done;
            close(f);
            fail;
            exit;
            end;
       openflag:=true;
       end;
  ListBox:=New(PListBox,Init(@Self,id_LibraryLB,0,0,0,0));
end;

procedure TLibraryWindow.SetupWindow;
var str:array[0..255]of char;
begin
  TWindow.SetupWindow;
  if openflag
  then begin
       while not eof(f)
       do begin
          readln(f,str); (* AP7: che succede se la lunghezza della linea e' maggiore di 255 ?*)
          if (StrLComp('macro;',str,6) = 0)
          then ListBox^.AddString(str);
          end;
       close(f);openflag:=false;
       end;
end;

procedure TLibraryWindow.WMSize(var Msg:TMessage);
begin
  TWindow.WMSize(Msg);
  MoveWindow(ListBox^.HWindow,0,0,LoWord(Msg.LParam),HiWord(Msg.LParam),false);
end;

function TLibraryWindow.GetClassName: PChar;
begin
  GetClassName := 'LibraryWindow';
end;

destructor TLibraryWindow.Done;
begin
(*  if openflag
  then close(f);*)
  Dispose(ListBox,Done);
  TDocument.Done;
end;

procedure TLibraryWindow.Save(var Message: TMessage);
begin
  MessageBox(HWindow,'Not implemented','WinSound!',MB_ok);
end;

procedure TLibraryWindow.SaveAs(var Message: TMessage);
begin
  MessageBox(HWindow,'Not implemented','WinSound!',MB_ok);
end;

procedure TLibraryWindow.Info(var Message: TMessage);
begin
  MessageBox(HWindow,'Not implemented','WinSound!',MB_ok);
end;

procedure TLibraryWindow.Add(var Message: TMessage);
begin
  MessageBox(HWindow,'Not implemented','WinSound!',MB_ok);
end;

procedure TLibraryWindow.Remove(var Message: TMessage);
begin
  MessageBox(HWindow,'Not implemented','WinSound!',MB_ok);
end;

{--------------- T....Dialog -----------------}


procedure TInfoDialog.SetUpWindow;
var
  testo:array[0..31]of char;
begin
  TDialog.SetUpWindow;
  StrCopy(testo,PWaveWindow(Parent)^.FileName);
  SetDlgItemText(HWindow,103,testo);
  WVSPrintf(testo,'%-15ld',PWaveWindow(Parent)^.samplerate);
  SetDlgItemText(HWindow,104,testo);
  WVSPrintf(testo,'%-15ld',PWaveWindow(Parent)^.nsamples);
  SetDlgItemText(HWindow,105,testo);
end;

procedure TRunDialog.WMNotify(var Msg: TMessage);
var
  testo:array[0..31]of char;
  time: TTimerInfo;
begin
  if Msg.WParam = HWindow
  then begin
       time.dwsize:=SizeOf(time);
       TimerCount(@time);
       Str(time.dwmsThisVM-start,testo);
       SetDlgItemText(HWindow,100,testo);
       end;
end;


procedure TRunDialog.SetUpWindow;
begin
  TDialog.SetUpWindow;
  if StrLen(PSystemWindow(Parent)^.FileName) <> 0
  then SetDlgItemText(HWindow,103,PSystemWindow(Parent)^.FileName);
end;

constructor TRunDialog.Init(AParent: PWindowsObject; Title: PChar);
var time: TTimerInfo;
begin
  TDialog.Init(AParent,Title);
  time.dwsize:=SizeOf(time);
  TimerCount(@time);
  start:=time.dwmsThisVM;
end;

procedure TSysInfoDialog.SetUpWindow;
var
  testo:array[0..31]of char;
begin
  TDialog.SetUpWindow;
  StrCopy(testo,PSystemWindow(Parent)^.FileName);
  SetDlgItemText(HWindow,103,testo);
  SetDlgItemInt(HWindow,104,PSystemWindow(Parent)^.pSys^.pObjList^.count,false);
  SetDlgItemInt(HWindow,105,PSystemWindow(Parent)^.pSys^.pBranchList^.count,false);
  SetDlgItemInt(HWindow,106,PSystemWindow(Parent)^.pSys^.IOCount,false);
  SetDlgItemInt(HWindow,107,PSystemWindow(Parent)^.pSys^.LastVar,false);
end;

procedure TSysParamDialog.Ok(var Msg:TMessage);
var testo:array[0..31]of char;
    _blocksize:longint;
    _MaxIterate,code:integer;
    error:boolean;
    result:wordbool;

begin
    TDialog.Ok(Msg);
    error:=true;
    GetDlgItemText(HWindow, 103, testo, sizeof(testo));
    Val(testo,_blocksize,code);
    if (code = 0)and not boolean(StrScan(testo,'-'))
    then begin
         _maxiterate:=GetDlgItemInt(HWindow, 104, pBool(@result), false);
         if result
         then begin
              PSystemWindow(Parent)^.pSys^.blocksize:=_blocksize;
              PSystemWindow(Parent)^.maxiterate:=_maxiterate;
              PSystemWindow(Parent)^.modified:=true;
              error:=false;
              end;
         end;
    if error
    then MessageBeep(MB_ICONEXCLAMATION);
end;

procedure TSysParamDialog.SetUpWindow;
var
  testo:array[0..15]of char;
begin
  TDialog.SetUpWindow;
  WVSPrintf(testo,'%-ld',PSystemWindow(Parent)^.pSys^.BlockSize);
  SetDlgItemText(HWindow,103,testo);
  WVSPrintf(testo,'%-d',PSystemWindow(Parent)^.MaxIterate);
  SetDlgItemText(HWindow,104,testo);
end;

procedure TFilterDialog.Ok(var Msg:TMessage);
var testo:array[0..63]of char;
    i:longint;
     _ft,_ripple:real;
     _order:integer;
     selindex,code:integer;
     result:WordBool;
     newp:pBuiltIn;

begin
  
  with PFilterWindow(Parent)^
  do begin
     FilterDialogOk(Self.HWindow,103,newp);
     if newp <> nil
     then begin
          TDialog.Ok(Msg);
          if filterp <> nil
          then Dispose(filterp,Done);
          filterp:=newp;
          filterp^.FreqResponse(gain);
          maxgain:=0;
          for i:=0 to gain.size - 1
          do if RealArray(gain.buf^)[i] > maxgain
             then maxgain:=RealArray(gain.buf^)[i];
          InvalidateRect(HWindow, nil, True);
          end
     end;
end;

procedure TFilterDialog.SetUpWindow;
begin
  TDialog.SetUpWindow;
  with PFilterWindow(Parent)^
  do SetUpFilterDialog(Self.HWindow,103,filterp);
end;


(* ----- TToolBox ----- *)

constructor TToolBox.Init(AParent: PWindowsObject; Title: PChar);
var Rect:TRect;
begin
  TWindow.Init(AParent,Title);
  Attr.Style:=ws_Popup or ws_Overlapped or ws_Visible or ws_minimizebox
              or ws_sysmenu or ws_caption;
  Attr.w:=64;
  Attr.h:=64 * (GetNBlocks+zNTools)+GetSystemMetrics(SM_CYCaption)(*+GetSystemMetrics(SM_CYMenu)*);
  GetClientRect(GetDeskTopWindow,Rect);
  nColumns:=Attr.h div Rect.bottom + 1;
  if nColumns > 1
  then begin
       nRows:=(Rect.bottom - GetSystemMetrics(SM_CYCaption))div 64;
       nColumns:=(GetNBlocks+zNTools+nRows-1)div nRows;
       Attr.h:=nRows * 64 + GetSystemMetrics(SM_CYCaption);
       Attr.w:=nColumns * 64;
       end
  else nRows:=GetNBlocks+zNTools;
  ObjNum:=0;
  ToolSelected:=false;
end;

procedure TToolBox.Paint(PaintDC: HDC; var PaintInfo: TPaintStruct);
var
  MemDC: HDC;
  bm: TBitMap;
  i:word;
  x,y:integer;
  procedure NextXY;
  begin
    inc(y,64);
    if y >= NRows * 64
    then begin
         inc(x,64);
         y:=0;
         end;
  end;

begin
  MemDC := CreateCompatibleDC(PaintDC);
  x:=0;y:=0;
  for i:=1 to GetNBlocks
  do begin
     SelectObject(MemDC, GetBitMap(i));
     GetObject(GetBitMap(i), SizeOf(bm), @bm);
     BitBlt(PaintDC, x, y, bm.bmWidth, bm.bmHeight, MemDC, 0, 0, SrcCopy);
     NextXY;
     end;
  for i:=zText to zLast
  do begin(* AP3: usare una variabile sostitutiva alla chiamata GetNBlocks *)
     SelectObject(MemDC, BitMap[i]);
     GetObject(BitMap[i], SizeOf(bm), @bm);
     BitBlt(PaintDC, x, y, bm.bmWidth, bm.bmHeight, MemDC, 0, 0, SrcCopy);
     NextXY;
     end;
  DeleteDC(MemDC);
end;

procedure TToolBox.WMLButtonDown(var Msg: TMessage);
var Point:TPoint;
begin
  if not ToolSelected
  then begin
       ToolSelected:=true;
       Point:=MakePoint(Msg.LParam);
       ObjNum:=Point.y div 64 + 1;
       if NColumns > 1
       then begin
            Inc(ObjNum,Point.x div 64 * NRows);
            if ObjNum > GetNBlocks+zNTools
            then ToolSelected:=false;
            end;
       if ToolSelected
       then begin
            SetCursor(LoadCursor(0,IDC_Icon));
            SetCapture(hWindow);
            end;
       end;
end;

procedure TToolBox.WMLButtonUp(var Msg: TMessage);
var selected:word;
begin
  if ToolSelected
  then begin
       ToolSelected:=false;
       ReleaseCapture;
       ClientToScreen(HWindow,MakePoint(Msg.LParam));
       if ObjNum <= GetNBlocks (* AP3: usare una variabile sostitutiva alla chiamata GetNBlocks *)
       then Selected := ObjNum
       else Selected := ObjNum - GetNBlocks + zText - 1;
       with Msg
       do PostMessage(WindowFromPoint(MakePoint(Msg.LParam)),WM_First + WM_U_Insert,selected,LParam);
       end;
end;

destructor TToolBox.Done;
begin
  TWindow.Done;
  pTool:=nil;
end;

procedure TToolBox.GetWindowClass(var WndClass: TWndClass);
begin
  TWindow.GetWindowClass(WndClass);
  WndClass.hIcon := LoadIcon(HInstance, 'TOOLICON');
end;

(*------ TDialogList ------*)

constructor TDialogList.Init(AParent: PWindowsObject; AName: PChar);
begin
  TDialog.Init(Aparent,AName);
  ListBox:=New(PListBox,InitResource(@Self,ID_ListBox));
end;

procedure TDialogList.SetUpWindow;
var
  p: pCue;
  testo:array[0..31]of char;
begin
  TDialog.SetUpWindow;
  p:=PWaveWindow(Parent)^.cuep;
  while p <> nil
  do begin
       WVSPrintf(testo,'%4li %8li %8li %s', p^);
       ListBox^.AddString(testo);
       p:=p^.next;
     end;
end;



(* MAIN *)

begin
  pTool:=nil;
  SystemBuffer:=''; (* copy/paste buffer is empty *)
end.